package br.com.centralit.api.dao;

import java.util.Calendar;

import br.com.centralit.api.model.ContaContabilSaldo;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;
import br.com.centralit.framework.model.Organizacao;
/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 22/01/2015 - 14:48:56
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *	
 */
public interface ContaContabilSaldoDao extends CitGenericDAO {
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author iago.almeida
	 *
	 * @param idContaContabil
	 * @param dataReferencia
	 * @return
	 */
	ContaContabilSaldo obterContaContabilSaldoPorContaContabilEDataReferencia(Long idContaContabil, Calendar dataReferencia);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author iago.almeida
	 *
	 * @param idContaContabil
	 * @return
	 */
	ContaContabilSaldo obterUltimaContaContabilSaldo(Long idContaContabil);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por verificar a existencia de saldo fechado para as contas contábeis de um orgão em uma dada referência.
	 *
	 * @author geovane.filho
	 *
	 * @param organizacao Orgão a se verificar a existencia de saldo fechado para suas contas.
	 * @param dataReferencia Data de referência para filtro.
	 * 
	 * @return <code>true</code> caso exista saldo fechado para alguma conta deste orgão na data de referência passada, <code>false</code> caso contrário.
	 */
	Boolean existeSaldoOrganizacaoEDataReferencia(Organizacao organizacao, Calendar dataReferencia);
	
}
