package br.com.centralit.api.dao;

import java.util.Collection;

import java.util.Set;

import br.com.centralit.api.model.Material;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;
import br.com.centralit.framework.model.Usuario;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>MaterialDao
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * @since 15/12/2014 - 08:50:39
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
public interface MaterialDao extends CitGenericDAO {

	/**
	 * Método responsável por listar a entidade <code>Material</code> através do nome
	 * 
	 * @author rogerio.costa
	 * @param idOrganizacao 
	 * 
	 * @param nome
	 * 
	 * @return Collection<Material>
	 */
	Collection<Material> listarMaterial(String codigoOuDescricao, Long dominioCodigoTipoMaterial, Long idOrganizacao);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter a Entidade<code>Material</code> através do ID da classificacaoMaterial
	 * 
	 * @author rogerio.costa
	 * 
	 * @return Material
	 */
	Material obterPorIdClassificacaoMaterial(Long idClassificacaoMaterial);
	
	/**
	 * Método responsável por verificar se existe material vinculado as classificacoes informadas
	 *
	 * @author wilker.machado
	 * @param usuarioLogado 
	 *
	 * @param idsClassificacoesImpactantes
	 * 
	 * @return <code>Boolean</code>
	 */
	boolean existeMaterialVinculadoAClassificacao(Set<Long> idsClassificacoes, Usuario usuarioLogado);
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author iago.almeida
	 *
	 * @param idContaContabil
	 * @param usuarioLogado 
	 * @return
	 */
	boolean existeMaterialVinculadoAContaContabil(Long idContaContabil, Usuario usuarioLogado);

	/**
	 * Método responsável por
	 *
	 * @author wilker.machado
	 *
	 * @param idOrganizacao
	 * @return
	 */
	Collection<Long> getIdsContasContabeisEmMateriais(Long idOrganizacao);
	
	/**
	 * Método responsável por consultar um materiais pelo código ou pelo nome.
	 * 
	 * @author luis.camargo
	 * 
	 * @param codigoOuDescricao
	 * @param idOrganizacao
	 * 
	 * @return
	 */
	Collection<Material> findMateriaisByOrganizacao(String codigoOuDescricao, Long idOrganizacao);

}
