package br.com.centralit.api.dao.impl;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.MaterialCaracteristicaDao;
import br.com.centralit.api.model.MaterialCaracteristica;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>MaterialCaracteristicaDaoHibernate
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 23/12/2014 - 15:51:41
 *
 * @version 1.0.0
 *
 * @author rogerio.costa
 *
 */
@Repository("materialCaracteristicaDao")
public class MaterialCaracteristicaDaoHibernate extends CitGenericDAOImpl implements MaterialCaracteristicaDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param classs
	 */
	public MaterialCaracteristicaDaoHibernate() {

		super(MaterialCaracteristica.class);
	}

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por validar se existem Material Caracteristica por caracteristica
	 *
	 * @author rogerio.cassimiro
	 *
	 * @param id
	 * @return
	 */
	@Override
	public Boolean existeMaterialCarateristicaPorCaracteristica(Long id){

		SearchSeven search = new SearchSeven();

		search.addFilterIn("caracteristica.id", id);

		return this.count(search) > 0 ? Boolean.TRUE : Boolean.FALSE;
	}

}
