package br.com.centralit.api.dao.impl;

import java.util.List;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.MaterialConsumoDao;
import br.com.centralit.api.model.MaterialConsumo;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Filter;
import com.googlecode.genericdao.search.Sort;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 25/05/2015 - 10:21:29
 *
 * @version 1.0.0
 *
 * @author rogerio.costa
 *
 */
@Repository("materialConsumoDao")
public class MaterialConsumoDaoHibernate extends CitGenericDAOImpl implements MaterialConsumoDao {

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public MaterialConsumoDaoHibernate() {

		super(MaterialConsumo.class);
	}

	@Override
	public List<MaterialConsumo> findMateriaisConsumoByOrganizacao(String descricaoOuCodigo, Long idOrganizacao) {

		SearchSeven search = new SearchSeven();

		search.addFilterOr(Filter.ilike("descricao", "%" + descricaoOuCodigo + "%"), Filter.ilike("classificacaoMaterial.codigo", "%" + descricaoOuCodigo + "%"));

		search.addFilterEqual("organizacao.id", idOrganizacao);

		search.addSort(Sort.asc("descricao"));

		search.setMaxResults(10);

		return this.search(search, MaterialConsumo.class);

	}

}
