package br.com.centralit.api.dao.impl;

import javax.persistence.Query;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.MaterialConsumoTipoUnidadeMedidaEntradaDao;
import br.com.centralit.api.model.MaterialConsumoTipoUnidadeMedidaEntrada;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;

@Repository("materialConsumoTipoUnidadeMedidaEntradaDao")
public class MaterialConsumoTipoUnidadeMedidaEntradaDaoHibernate extends CitGenericDAOImpl implements MaterialConsumoTipoUnidadeMedidaEntradaDao {

	public MaterialConsumoTipoUnidadeMedidaEntradaDaoHibernate() {

		super(MaterialConsumoTipoUnidadeMedidaEntrada.class);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por validar se a unidade medida que será excluída está vinculada em alguma entrada almoxarifada
	 * 
	 * @author rogerio.cassimiro
	 * 
	 * @param idUnidadeMedida
	 * @param idMaterialConsumo
	 * @return {@link Boolean}
	 */
	@Override
	public boolean validarUnidadeEmUsoEntradaAlmoxarifado(Long idUnidadeMedida, Long idMaterialConsumo) {
		
		StringBuilder sb = new StringBuilder();
		sb.append("select eai.id from alm_en_entradaitem  eai ")
		.append("inner join alm_entrada ea on ea.id = eai.entrada_id ")
		.append("inner join unidademedida um on um.id = eai.unidademedidaentrada_id ")
		.append("inner join alm_materialconsumo mc on mc.id = eai.material_id ")
		.append("where um.id = :idUnidadeMedida and mc.id = :idMaterialConsumo");

		Query q = em().createNativeQuery(sb.toString());
		q.setParameter("idUnidadeMedida", idUnidadeMedida);
		q.setParameter("idMaterialConsumo", idMaterialConsumo);
		
		return q.getResultList().size() > 0;
	}
}
