package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.OneToMany;

import org.hibernate.envers.Audited;
import org.hibernate.envers.NotAudited;

import br.com.centralit.api.framework.json.ViewsAdmMateriais;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

@Audited
@Entity
@Inheritance(strategy = InheritanceType.JOINED)
@JsonIgnoreProperties({ "$dataEstorno", "$selected", "$checked" })
public class Baixa extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -3665146012333491070L;

	/** Atributo id. */
	@Id
//	@SequenceGenerator(name = "baixa_id_seq", sequenceName = "baixa_id_seq")
//	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "baixa_id_seq")
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class, ViewsAdmMateriais.BaixaAlmoxarifadoListView.class  })
	private Long id;

	/** Atributo documentos. */
	@Audited
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "baixa", cascade = CascadeType.ALL)
	@JsonView({ Views.BaixaEditView.class, ViewsAdmMateriais.BaixaAlmoxarifadoEditView.class })
	private Collection<BaixaDocumento> documentos;

	/** Atributo observacoes. */
	@NotAudited
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "baixa", cascade = CascadeType.ALL)
	@JsonView({ Views.BaixaEditView.class, ViewsAdmMateriais.BaixaAlmoxarifadoEditView.class })
	private Collection<BaixaObservacao> observacoes;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>documentos</code>
	 *
	 * @return <code>Collection<BaixaDocumento></code>
	 */
	public Collection<BaixaDocumento> getDocumentos() {

		return documentos;
	}

	/**
	 * Define o valor do atributo <code>documentos</code>.
	 *
	 * @param documentos
	 */
	public void setDocumentos(Collection<BaixaDocumento> documentos) {

		this.documentos = documentos;
	}

	/**
	 * Retorna o valor do atributo <code>observacoes</code>
	 *
	 * @return <code>Collection<BaixaObservacao></code>
	 */
	public Collection<BaixaObservacao> getObservacoes() {

		return observacoes;
	}

	/**
	 * Define o valor do atributo <code>observacoes</code>.
	 *
	 * @param observacoes
	 */
	public void setObservacoes(Collection<BaixaObservacao> observacoes) {

		this.observacoes = observacoes;
	}

}
