package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

import org.hibernate.envers.Audited;
import org.hibernate.envers.NotAudited;

import br.com.centralit.api.framework.json.ViewsAdmMateriais;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: Material</b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 05/12/2014 - 10:11:31
 *
 * @version 1.0.0
 *
 * @author ally.barra
 *
 */
@Audited
@Entity
@Inheritance(strategy = InheritanceType.JOINED)
@JsonIgnoreProperties({"unidadeMedida", "unidadeArmazenamento", "tiposUnidadeMedidaEntrada"})
public class Material extends PersistentObjectAuditOrganizacao {

	/** Atributo id. */
	@Id
//	@SequenceGenerator(name = "material_id_seq", sequenceName = "material_id_seq")
//	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "material_id_seq")
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class, Views.BemPatrimonialAutoCompleteView.class, Views.AdicaoBemPatrimonialView.class, ViewsAdmMateriais.AtendimentoRequisicaoConsumoItemView.class,
				ViewsAdmMateriais.MaterialConsumoAutoCompleteRequisicao.class, ViewsAdmMateriais.BaixaAlmoxarifadoEditView.class, ViewsAdmMateriais.DevolucaoEditView.class, Views.InventarioMobileCompleto.class,
				Views.InventarioMobile.class, Views.InventarioMobileJEDI.class, ViewsAdmMateriais.TransferenciaContaContabilListView.class, ViewsAdmMateriais.MaterialConsultaInfo.class })
	private Long id;

	/** Atributo emplaquetavel. */
	@JsonView({ Views.MaterialEditView.class })
	private Boolean emplaquetavel;

	/** Atributo descricao. */
	@JsonView({ Views.BemPatrimonialAutoCompleteSimplesView.class, Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class, Views.AdicaoBemPatrimonialView.class, Views.TransferenciaEditView.class, Views.EntradaEditView.class,
				Views.SaidaTemporariaEditView.class, Views.BaixaEditView.class, Views.DepreciacaoView.class, Views.SaidaTemporariaItemListView.class, Views.DadosBemPatrimonialEditView.class, Views.BemPatrimonialInventarioAutoCompleteView.class,
				ViewsAdmMateriais.MaterialConsumoAutoCompleteView.class, ViewsAdmMateriais.MaterialConsumoAutoCompleteRequisicao.class, ViewsAdmMateriais.AtendimentoRequisicaoConsumoItemView.class,
				ViewsAdmMateriais.MaterialConsumoBaixaAutoCompleteView.class, ViewsAdmMateriais.CatalogoMaterialEditView.class, ViewsAdmMateriais.BaixaAlmoxarifadoEditView.class,
				ViewsAdmMateriais.DevolucaoEditView.class,  ViewsAdmMateriais.ConfiguracaoRessuprimentoListView.class, ViewsAdmMateriais.ConfiguracaoRessuprimentoEditView.class,
				ViewsAdmMateriais.RequisicaoConsumoEditView.class, ViewsAdmMateriais.TransferenciaContaContabilEditView.class, ViewsAdmMateriais.CatalogoMaterialItemEditView.class, Views.InventarioMobileCompleto.class, Views.InventarioMobile.class,
				Views.DefinicaoDetentorEditView.class, Views.InventarioMobileJEDI.class, Views.BemPatrimonialListView.class, Views.SelecaoBemPatrimonialEditView.class, Views.EntradaItemEditView.class, ViewsAdmMateriais.MaterialConsultaInfo.class,
				ViewsAdmMateriais.RequisicaoConsumo.class, ViewsAdmMateriais.TransferenciaEnderecoEstoqueView.class, ViewsAdmMateriais.EntradaAlmoxarifadoEditView.class })
	private String descricao;

	/** Atributo dominioTipoMaterial. */
	@JsonView({ Views.MaterialEditView.class, ViewsAdmMateriais.MaterialTransferenciaView.class, ViewsAdmMateriais.TransferenciaContaContabilEditView.class, ViewsAdmMateriais.MaterialConsultaInfo.class,
		        ViewsAdmMateriais.RequisicaoConsumo.class})
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	private Dominio dominioTipoMaterial;

	/** Atributo classificacaoMaterial. */
	@JsonView({ Views.MaterialEditView.class, Views.MaterialAutoCompleteView.class, Views.EntradaEditView.class, Views.EntradaItemEditView.class, ViewsAdmMateriais.MaterialConsultaInfo.class})
	@ManyToOne(fetch = FetchType.LAZY)
	private ClassificacaoMaterial classificacaoMaterial;

	/** Atributo contaContabil. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.MaterialEditView.class, ViewsAdmMateriais.MaterialTransferenciaView.class , Views.BemPatrimonialEditView.class, Views.BemPatrimonialListView.class, Views.MaterialAutoCompleteView.class, ViewsAdmMateriais.MaterialConsultaInfo.class})
	private ContaContabil contaContabil;

	/** Atributo materialCaracteristicas. **/
	@JsonView({ Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class, ViewsAdmMateriais.MaterialConsultaInfo.class })
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "material", cascade = CascadeType.ALL)
	private Collection<MaterialCaracteristica> materialCaracteristicas;

	/** Atributo materialImagens. */
	@NotAudited
	@JsonView({ Views.MaterialEditView.class, ViewsAdmMateriais.MaterialConsultaInfo.class })
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "material", cascade = CascadeType.ALL)
	private Collection<MaterialImagem> materialImagens;

	/** Atributo codigo. */
	@Column(length = 30)
	@JsonView({ Views.MaterialEditView.class, ViewsAdmMateriais.MaterialConsultaInfo.class })
	private String codigo;


	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -333193869941650689L;

	@JsonView({ Views.BemPatrimonialAutoCompleteSimplesView.class, Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class, Views.AdicaoBemPatrimonialView.class, Views.TransferenciaEditView.class, Views.EntradaEditView.class,
		Views.SaidaTemporariaEditView.class, Views.BaixaEditView.class, Views.DepreciacaoView.class, Views.SaidaTemporariaItemListView.class, Views.DadosBemPatrimonialEditView.class, Views.BemPatrimonialInventarioAutoCompleteView.class,
		ViewsAdmMateriais.MaterialConsumoAutoCompleteView.class, ViewsAdmMateriais.MaterialConsumoAutoCompleteRequisicao.class, ViewsAdmMateriais.AtendimentoRequisicaoConsumoItemView.class,
		ViewsAdmMateriais.MaterialConsumoBaixaAutoCompleteView.class, ViewsAdmMateriais.CatalogoMaterialEditView.class, ViewsAdmMateriais.BaixaAlmoxarifadoEditView.class,
		ViewsAdmMateriais.DevolucaoEditView.class,  ViewsAdmMateriais.ConfiguracaoRessuprimentoListView.class, ViewsAdmMateriais.ConfiguracaoRessuprimentoEditView.class,
		ViewsAdmMateriais.RequisicaoConsumoEditView.class, ViewsAdmMateriais.TransferenciaContaContabilEditView.class, ViewsAdmMateriais.CatalogoMaterialItemEditView.class, Views.InventarioMobileCompleto.class, Views.InventarioMobile.class,
		Views.DefinicaoDetentorEditView.class, Views.InventarioMobileJEDI.class, Views.BemPatrimonialListView.class, Views.EntradaItemEditView.class, ViewsAdmMateriais.MaterialConsultaInfo.class})
	@Transient
	private String codigoEDescricao;
	
	@JsonView({ Views.BemPatrimonialAutoCompleteSimplesView.class, Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class, Views.AdicaoBemPatrimonialView.class, Views.TransferenciaEditView.class, Views.EntradaEditView.class,
		Views.SaidaTemporariaEditView.class, Views.BaixaEditView.class, Views.DepreciacaoView.class, Views.SaidaTemporariaItemListView.class, Views.DadosBemPatrimonialEditView.class, Views.BemPatrimonialInventarioAutoCompleteView.class,
		ViewsAdmMateriais.MaterialConsumoAutoCompleteView.class, ViewsAdmMateriais.MaterialConsumoAutoCompleteRequisicao.class, ViewsAdmMateriais.AtendimentoRequisicaoConsumoItemView.class,
		ViewsAdmMateriais.MaterialConsumoBaixaAutoCompleteView.class, ViewsAdmMateriais.CatalogoMaterialEditView.class, ViewsAdmMateriais.BaixaAlmoxarifadoEditView.class,
		ViewsAdmMateriais.DevolucaoEditView.class,  ViewsAdmMateriais.ConfiguracaoRessuprimentoListView.class, ViewsAdmMateriais.ConfiguracaoRessuprimentoEditView.class,
		ViewsAdmMateriais.RequisicaoConsumoEditView.class, ViewsAdmMateriais.TransferenciaContaContabilEditView.class, ViewsAdmMateriais.CatalogoMaterialItemEditView.class, Views.InventarioMobileCompleto.class, Views.InventarioMobile.class,
		Views.DefinicaoDetentorEditView.class, Views.InventarioMobileJEDI.class, Views.BemPatrimonialListView.class, Views.EntradaItemEditView.class, ViewsAdmMateriais.MaterialConsultaInfo.class})
	@Transient
	private String codigoDescricaoCodigoCC;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>emplaquetavel</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getEmplaquetavel() {

		return emplaquetavel;
	}

	/**
	 * Define o valor do atributo <code>emplaquetavel</code>.
	 *
	 * @param emplaquetavel
	 */
	public void setEmplaquetavel(Boolean emplaquetavel) {

		this.emplaquetavel = emplaquetavel;
	}

	/**
	 * Retorna o valor do atributo <code>dominioTipoMaterial</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioTipoMaterial() {

		return dominioTipoMaterial;
	}

	/**
	 * Define o valor do atributo <code>dominioTipoMaterial</code>.
	 *
	 * @param dominioTipoMaterial
	 */
	public void setDominioTipoMaterial(Dominio dominioTipoMaterial) {

		this.dominioTipoMaterial = dominioTipoMaterial;
	}

	/**
	 * Retorna o valor do atributo <code>classificacaoMaterial</code>
	 *
	 * @return <code>ClassificacaoMaterial</code>
	 */
	public ClassificacaoMaterial getClassificacaoMaterial() {

		return classificacaoMaterial;
	}

	/**
	 * Define o valor do atributo <code>classificacaoMaterial</code>.
	 *
	 * @param classificacaoMaterial
	 */
	public void setClassificacaoMaterial(ClassificacaoMaterial classificacaoMaterial) {

		this.classificacaoMaterial = classificacaoMaterial;
	}

	/**
	 * Retorna o valor do atributo <code>contaContabil</code>
	 *
	 * @return <code>ContaContabil</code>
	 */
	public ContaContabil getContaContabil() {

		return contaContabil;
	}

	/**
	 * Define o valor do atributo <code>contaContabil</code>.
	 *
	 * @param contaContabil
	 */
	public void setContaContabil(ContaContabil contaContabil) {

		this.contaContabil = contaContabil;
	}

	/**
	 * Retorna o valor do atributo <code>materialCaracteristicas</code>
	 *
	 * @return <code>Collection<MaterialCaracteristica></code>
	 */
	public Collection<MaterialCaracteristica> getMaterialCaracteristicas() {

		return materialCaracteristicas;
	}

	/**
	 * Define o valor do atributo <code>materialCaracteristicas</code>.
	 *
	 * @param materialCaracteristicas
	 */
	public void setMaterialCaracteristicas(Collection<MaterialCaracteristica> materialCaracteristicas) {

		this.materialCaracteristicas = materialCaracteristicas;
	}

	/**
	 * Retorna o valor do atributo <code>materialImagens</code>
	 *
	 * @return <code>Collection<MaterialImagem></code>
	 */
	public Collection<MaterialImagem> getMaterialImagens() {

		return materialImagens;
	}

	/**
	 * Define o valor do atributo <code>materialImagens</code>.
	 *
	 * @param materialImagens
	 */
	public void setMaterialImagens(Collection<MaterialImagem> materialImagens) {

		this.materialImagens = materialImagens;
	}

	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}

	/**
	 * Define o valor do atributo <code>descricao</code>.
	 *
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}


	/**
	 * Retorna o valor do atributo <code>codigo</code>
	 *
	 * @return <code>String</code>
	 */
	public String getCodigo() {

		return codigo;
	}


	/**
	 * Define o valor do atributo <code>codigo</code>.
	 *
	 * @param codigo
	 */
	public void setCodigo(String codigo) {

		this.codigo = codigo;
	}


	/**
	 * Retorna o valor doa atributos <code>codigo</code> e <code>descricao</code> concatenados.
	 *
	 * @return <code>String</code>
	 */
	public String getCodigoEDescricao() {

		if (this.codigoEDescricao == null) {
			if (this.classificacaoMaterial == null) {
				codigoEDescricao = this.descricao;
			} else {
				codigoEDescricao = this.classificacaoMaterial.getCodigo().concat(" - ").concat(this.descricao);
			}
		}

		return codigoEDescricao;
	}

	/**
	 * Define o valor do atributo <code>codigoEDescricao</code>
	 *
	 * @param codigoEDescricao
	 */
	public void setCodigoEDescricao(String codigoEDescricao) {
		this.codigoEDescricao = codigoEDescricao;
	}

	public String getCodigoDescricaoCodigoCC() {
		
		if (this.codigoDescricaoCodigoCC == null) {
			if (this.classificacaoMaterial == null) {
				codigoDescricaoCodigoCC = this.descricao;
			} else {
				codigoDescricaoCodigoCC = this.classificacaoMaterial.getCodigo().concat(" - ").concat(this.descricao);
			}
			
			if(this.contaContabil != null){
				codigoDescricaoCodigoCC += " - " + contaContabil.getCodigo();
			}
		}

		return codigoDescricaoCodigoCC;
	}

	public void setCodigoDescricaoCodigoCC(String codigoDescricaoCodigoCC) {
		this.codigoDescricaoCodigoCC = codigoDescricaoCodigoCC;
	}
	
	
}
