package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.framework.json.ViewsAdmMateriais;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 05/12/2014 - 10:03:52
 *
 * @version 1.0.0
 *
 * @author ally.barra
 *
 */
@Audited
@AuditTable(value = "MatCaracteristica_aud")
@Entity
@JsonIgnoreProperties({ "$edit", "$checked" })
public class MaterialCaracteristica extends PersistentObjectAudit {

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo codigo. */
	@Column(length = 30)
	@JsonView({ Views.MaterialAutoCompleteView.class })
	private String codigo;

	/** Atributo generico. */
	@JsonView({ Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class, Views.EntradaEditView.class, Views.BemPatrimonialEditView.class })
	private Boolean generico;

	/** Atributo imprimeConteudo. */
	@JsonView({ Views.MaterialAutoCompleteView.class })
	private Boolean imprimeConteudo;

	/** Atributo obrigatorio. */
	@JsonView({ Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class, Views.EntradaEditView.class, Views.BemPatrimonialEditView.class })
	private Boolean obrigatorio;

	/** Atributo sequencia. */
	@JsonView({ Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class })
	private Long sequencia;

	/** Atributo caracteristica. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.MaterialAutoCompleteView.class, Views.MaterialEditView.class, Views.EntradaEditView.class, Views.BemPatrimonialEditView.class, Views.MaterialConsultaInfo.class })
	public Caracteristica caracteristica;

	/** Atributo material. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsAdmMateriais.EntradaAlmoxarifadoEditView.class })
	private Material material;

	/** Atributo materialRemocao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private Material materialRemocao;

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 6457940093834583996L;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>codigo</code>
	 *
	 * @return <code>String</code>
	 */
	public String getCodigo() {

		return codigo;
	}

	/**
	 * Define o valor do atributo <code>codigo</code>.
	 *
	 * @param codigo
	 */
	public void setCodigo(String codigo) {

		this.codigo = codigo;
	}

	/**
	 * Retorna o valor do atributo <code>generico</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getGenerico() {

		return generico;
	}

	/**
	 * Define o valor do atributo <code>generico</code>.
	 *
	 * @param generico
	 */
	public void setGenerico(Boolean generico) {

		this.generico = generico;
	}

	/**
	 * Retorna o valor do atributo <code>imprimeConteudo</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getImprimeConteudo() {

		return imprimeConteudo;
	}

	/**
	 * Define o valor do atributo <code>imprimeConteudo</code>.
	 *
	 * @param imprimeConteudo
	 */
	public void setImprimeConteudo(Boolean imprimeConteudo) {

		this.imprimeConteudo = imprimeConteudo;
	}

	/**
	 * Retorna o valor do atributo <code>obrigatorio</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getObrigatorio() {

		return obrigatorio;
	}

	/**
	 * Define o valor do atributo <code>obrigatorio</code>.
	 *
	 * @param obrigatorio
	 */
	public void setObrigatorio(Boolean obrigatorio) {

		this.obrigatorio = obrigatorio;
	}

	/**
	 * Retorna o valor do atributo <code>sequencia</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getSequencia() {

		return sequencia;
	}

	/**
	 * Define o valor do atributo <code>sequencia</code>.
	 *
	 * @param sequencia
	 */
	public void setSequencia(Long sequencia) {

		this.sequencia = sequencia;
	}

	/**
	 * Retorna o valor do atributo <code>caracteristica</code>
	 *
	 * @return <code>Caracteristica</code>
	 */
	public Caracteristica getCaracteristica() {

		return caracteristica;
	}

	/**
	 * Define o valor do atributo <code>caracteristica</code>.
	 *
	 * @param caracteristica
	 */
	public void setCaracteristica(Caracteristica caracteristica) {

		this.caracteristica = caracteristica;
	}

	/**
	 * Retorna o valor do atributo <code>material</code>
	 *
	 * @return <code>Material</code>
	 */
	public Material getMaterial() {

		return material;
	}

	/**
	 * Define o valor do atributo <code>material</code>.
	 *
	 * @param material
	 */
	public void setMaterial(Material material) {

		this.material = material;
	}

	/**
	 * Retorna o valor do atributo <code>materialRemocao</code>
	 *
	 * @return <code>Material</code>
	 */
	public Material getMaterialRemocao() {

		return materialRemocao;
	}

	/**
	 * Define o valor do atributo <code>materialRemocao</code>.
	 *
	 * @param materialRemocao
	 */
	public void setMaterialRemocao(Material materialRemocao) {

		this.materialRemocao = materialRemocao;
	}

}
