package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.envers.Audited;

import br.com.centralit.api.framework.json.ViewsAdmMateriais;
import br.com.centralit.framework.json.Views;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 25/05/2015 - 16:57:19
 *
 * @version 1.0.0
 *
 * @author rogerio.costa
 *
 */
@Audited
@Entity
@Table(name="alm_materialconsumo")
@JsonIgnoreProperties({ "dominioUnidadeMedida", "materiaisConsumo" })
public class MaterialConsumo extends Material {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -1444946484577894455L;

	/** Atributo elementoDespesa. */
	@JsonView({ Views.MaterialEditView.class, Views.MaterialConsultaInfo.class })
	private String elementoDespesa;

	/** Atributo dominioUnidadeArmazenamento. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsAdmMateriais.RequisicaoConsumoEditView.class,
				Views.MaterialEditView.class,
				ViewsAdmMateriais.MaterialConsumoAutoCompleteView.class,
				ViewsAdmMateriais.EntradaAlmoxarifadoEditView.class,
				ViewsAdmMateriais.MaterialConsumoBaixaAutoCompleteView.class,
				ViewsAdmMateriais.BaixaAlmoxarifadoEditView.class,
				ViewsAdmMateriais.CatalogoMaterialItemEditView.class, Views.MaterialConsultaInfo.class, ViewsAdmMateriais.RequisicaoConsumo.class,
				Views.GenericView.class})
	private UnidadeMedida unidadeArmazenamento;

	/** Atributo tiposUnidadeMedidaEntrada. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "materialConsumo", cascade = CascadeType.ALL)
	@JsonView({ ViewsAdmMateriais.RequisicaoConsumoEditView.class,
				Views.MaterialEditView.class,
				ViewsAdmMateriais.MaterialConsumoAutoCompleteView.class,
				ViewsAdmMateriais.EntradaAlmoxarifadoEditView.class,
				ViewsAdmMateriais.CatalogoMaterialItemEditView.class, Views.MaterialConsultaInfo.class})
	private Collection<MaterialConsumoTipoUnidadeMedidaEntrada> tiposUnidadeMedidaEntrada;

	/**
	 * Retorna o valor do atributo <code>elementoDespesa</code>
	 *
	 * @return <code>String</code>
	 */
	public String getElementoDespesa() {

		return elementoDespesa;
	}

	/**
	 * Define o valor do atributo <code>elementoDespesa</code>.
	 *
	 * @param elementoDespesa
	 */
	public void setElementoDespesa(String elementoDespesa) {

		this.elementoDespesa = elementoDespesa;
	}

	/**
	 * Retorna o valor do atributo <code>tiposUnidadeMedidaEntrada</code>
	 *
	 * @return <code>Collection<UnidadeMedidaEntrada></code>
	 */
	public Collection<MaterialConsumoTipoUnidadeMedidaEntrada> getTiposUnidadeMedidaEntrada() {

		return tiposUnidadeMedidaEntrada;
	}

	/**
	 * Define o valor do atributo <code>tiposUnidadeMedidaEntrada</code>.
	 *
	 * @param tiposUnidadeMedidaEntrada
	 */
	public void setTiposUnidadeMedidaEntrada(Collection<MaterialConsumoTipoUnidadeMedidaEntrada> tiposUnidadeMedidaEntrada) {

		this.tiposUnidadeMedidaEntrada = tiposUnidadeMedidaEntrada;
	}

	/**
	 * Retorna o valor do atributo <code>unidadeArmazenamento</code>
	 *
	 * @return <code>UnidadeMedida</code>
	 */
	public UnidadeMedida getUnidadeArmazenamento() {

		return unidadeArmazenamento;
	}

	/**
	 * Define o valor do atributo <code>unidadeArmazenamento</code>.
	 *
	 * @param unidadeArmazenamento
	 */
	public void setUnidadeArmazenamento(UnidadeMedida unidadeArmazenamento) {

		this.unidadeArmazenamento = unidadeArmazenamento;
	}

}
