package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.Audited;

import br.com.centralit.api.framework.json.ViewsAdmMateriais;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObject;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

@Audited
@Entity
@Table(name="alm_mc_unidmedidaentrada")
@JsonIgnoreProperties({ "$edit", "$checked" })
public class MaterialConsumoTipoUnidadeMedidaEntrada extends PersistentObject {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY)
	private MaterialConsumo materialConsumo;

	/** Atributo materialConsumoRemocao. */
	@ManyToOne(fetch = FetchType.LAZY)
	private MaterialConsumo materialConsumoRemocao;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.MaterialEditView.class, ViewsAdmMateriais.MaterialConsumoAutoCompleteView.class, ViewsAdmMateriais.EntradaAlmoxarifadoEditView.class, Views.MaterialConsultaInfo.class })
	private UnidadeMedida unidadeMedida;


	@Column
	@JsonView({ Views.GenericView.class })
	private Boolean isPadrao;

	/**
	 * Retorna o valor do atributo <code>materialConsumo</code>
	 *
	 * @return <code>MaterialConsumo</code>
	 */
	public MaterialConsumo getMaterialConsumo() {

		return materialConsumo;
	}

	/**
	 * Define o valor do atributo <code>materialConsumo</code>.
	 *
	 * @param materialConsumo
	 */
	public void setMaterialConsumo(MaterialConsumo materialConsumo) {

		this.materialConsumo = materialConsumo;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>unidadeMedida</code>
	 *
	 * @return <code>UnidadeMedida</code>
	 */
	public UnidadeMedida getUnidadeMedida() {

		return unidadeMedida;
	}

	/**
	 * Define o valor do atributo <code>unidadeMedida</code>.
	 *
	 * @param unidadeMedida
	 */
	public void setUnidadeMedida(UnidadeMedida unidadeMedida) {

		this.unidadeMedida = unidadeMedida;
	}

	/**
	 * Retorna o valor do atributo <code>materialConsumoRemocao</code>
	 *
	 * @return <code>MaterialConsumo</code>
	 */
	public MaterialConsumo getMaterialConsumoRemocao() {

		return materialConsumoRemocao;
	}

	/**
	 * Define o valor do atributo <code>materialConsumoRemocao</code>.
	 *
	 * @param materialConsumoRemocao
	 */
	public void setMaterialConsumoRemocao(MaterialConsumo materialConsumoRemocao) {

		this.materialConsumoRemocao = materialConsumoRemocao;
	}

	public Boolean getIsPadrao() {
		return isPadrao;
	}

	public void setIsPadrao(Boolean isPadrao) {
		this.isPadrao = isPadrao;
	}
}
