package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.envers.AuditJoinTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.framework.json.ViewsAdmMateriais;
import br.com.centralit.framework.json.Views;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 21/05/2015 - 15:07:47
 *
 * @version 1.0.0
 *
 * @author rogerio.costa
 *
 */
@Audited
@Entity
@JsonIgnoreProperties({ "elementoDespesa", "unidadeArmazenamento", "tiposUnidadeMedidaEntrada"})
public class MaterialPermanente extends Material {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 164167533535250470L;

	/** Atributo unidadeMedida. */
	@Audited
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ Views.MaterialAutoCompleteView.class,
				Views.MaterialEditView.class,
				Views.EntradaEditView.class,
				ViewsAdmMateriais.MaterialConsumoAutoCompleteRequisicao.class,
				Views.EntradaItemEditView.class })
	private UnidadeMedida unidadeMedida;

	/** Atributo materiaisConsumo. */
	@AuditJoinTable
	@JsonView({ Views.MaterialEditView.class })
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "materialPermanente", cascade = CascadeType.ALL)
	private Collection<MaterialPermanenteConsumo> materiaisConsumo;

	/**
	 * Retorna o valor do atributo <code>materiaisConsumo</code>
	 *
	 * @return <code>Collection<MaterialPermanenteConsumo></code>
	 */
	public Collection<MaterialPermanenteConsumo> getMateriaisConsumo() {

		return materiaisConsumo;
	}

	/**
	 * Define o valor do atributo <code>materiaisConsumo</code>.
	 *
	 * @param materiaisConsumo
	 */
	public void setMateriaisConsumo(Collection<MaterialPermanenteConsumo> materiaisConsumo) {

		this.materiaisConsumo = materiaisConsumo;
	}

	/**
	 * Retorna o valor do atributo <code>dominioUnidadeMedida</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public UnidadeMedida getUnidadeMedida() {

		return unidadeMedida;
	}

	/**
	 * Define o valor do atributo <code>unidadeMedida</code>.
	 *
	 * @param unidadeMedida
	 */
	public void setUnidadeMedida(UnidadeMedida unidadeMedida) {

		this.unidadeMedida = unidadeMedida;
	}

}
