package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.Audited;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - GovernanÃ§a Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negÃ³cio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 05/12/2014 - 08:05:06
 *
 * @version 1.0.0
 *
 * @author ally.barra
 *
 */
@Audited
@Entity
@Table(name = "mat_matpermanenteconsumo")
@JsonIgnoreProperties({ "$checked" })
public class MaterialPermanenteConsumo extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -1444946484577894455L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo material. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ Views.MaterialAutoCompleteView.class })
	private MaterialPermanente materialPermanente;

	/** Atributo materialConsumo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ Views.GenericView.class })
	private MaterialConsumo materialConsumo;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>materialConsumo</code>
	 *
	 * @return <code>Material</code>
	 */
	public Material getMaterialConsumo() {

		return materialConsumo;
	}

	/**
	 * Retorna o valor do atributo <code>materialPermanente</code>
	 *
	 * @return <code>MaterialPermanente</code>
	 */
	public MaterialPermanente getMaterialPermanente() {

		return materialPermanente;
	}

	/**
	 * Define o valor do atributo <code>materialPermanente</code>.
	 *
	 * @param materialPermanente
	 */
	public void setMaterialPermanente(MaterialPermanente materialPermanente) {

		this.materialPermanente = materialPermanente;
	}

	/**
	 * Define o valor do atributo <code>materialConsumo</code>.
	 *
	 * @param materialConsumo
	 */
	public void setMaterialConsumo(MaterialConsumo materialConsumo) {

		this.materialConsumo = materialConsumo;
	}

}
