package br.com.centralit.api.model;

import java.math.BigDecimal;
import java.util.Calendar;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import br.com.centralit.api.framework.json.ViewsAdmMateriais;
import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.json.JsonCalendarSimpleDateSerializer;
import br.com.centralit.framework.json.MoneyDeserializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 21/05/2015 - 15:11:29
 *
 * @version 1.0.0
 *
 * @author rogerio.costa
 *
 */
@Entity
public class TransferenciaContaContabil extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -4482023451961315188L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo dataTransferencia. */
	@Column(name = "dataTransferencia", nullable = false, updatable = false)
	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	@JsonView({ ViewsAdmMateriais.TransferenciaContaContabilListView.class })
	private Calendar dataTransferencia;

	/** Atributo contaDestino. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsAdmMateriais.TransferenciaContaContabilListView.class })
	private ContaContabil contaDestino;

	/** Atributo contaOrigem. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsAdmMateriais.TransferenciaContaContabilListView.class })
	private ContaContabil contaOrigem;

	/** Atributo material. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	@JsonView({ ViewsAdmMateriais.TransferenciaContaContabilListView.class })
	private Material material;

	/** Atributo almoxarifado. */
	@JsonView({ ViewsAdmMateriais.TransferenciaContaContabilEditView.class })
	private Boolean almoxarifado;

	@Column(length = 30)
	private String codigo;

	@Column(precision = 20, scale = 4, nullable = false)
	@JsonDeserialize(using = MoneyDeserializer.class)
	@JsonView({ViewsAdmMateriais.TransferenciaContaContabilEditView.class})
	private BigDecimal quantidadeMaterial;

	@Column(precision = 20, scale = 4, nullable = false)
	@JsonDeserialize(using = MoneyDeserializer.class)
	@JsonView({ViewsAdmMateriais.TransferenciaContaContabilEditView.class})
	private BigDecimal valorTransferencia;

	@Column(precision = 20, scale = 4)
	@JsonDeserialize(using = MoneyDeserializer.class)
	@JsonView({ViewsAdmMateriais.TransferenciaContaContabilEditView.class})
	private BigDecimal valorDepreciacaoAcumulada;


	/**
	 * Retorna o valor do atributo <code>quantidadeMaterial</code>
	 *
	 * @return <code>BigDecimal</code>
	 */
	public BigDecimal getQuantidadeMaterial() {

		return quantidadeMaterial;
	}


	/**
	 * Define o valor do atributo <code>quantidadeMaterial</code>.
	 *
	 * @param quantidadeMaterial
	 */
	public void setQuantidadeMaterial(BigDecimal quantidadeMaterial) {

		this.quantidadeMaterial = quantidadeMaterial;
	}


	/**
	 * Retorna o valor do atributo <code>valorTransferencia</code>
	 *
	 * @return <code>BigDecimal</code>
	 */
	public BigDecimal getValorTransferencia() {

		return valorTransferencia;
	}


	/**
	 * Define o valor do atributo <code>valorTransferencia</code>.
	 *
	 * @param valorTransferencia
	 */
	public void setValorTransferencia(BigDecimal valorTransferencia) {

		this.valorTransferencia = valorTransferencia;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>dataTransferencia</code>
	 *
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataTransferencia() {

		return dataTransferencia;
	}

	/**
	 * Define o valor do atributo <code>dataTransferencia</code>.
	 *
	 * @param dataTransferencia
	 */
	public void setDataTransferencia(Calendar dataTransferencia) {

		this.dataTransferencia = dataTransferencia;
	}

	/**
	 * Retorna o valor do atributo <code>contaDestino</code>
	 *
	 * @return <code>ContaContabil</code>
	 */
	public ContaContabil getContaDestino() {

		return contaDestino;
	}

	/**
	 * Define o valor do atributo <code>contaDestino</code>.
	 *
	 * @param contaDestino
	 */
	public void setContaDestino(ContaContabil contaDestino) {

		this.contaDestino = contaDestino;
	}

	/**
	 * Retorna o valor do atributo <code>contaOrigem</code>
	 *
	 * @return <code>ContaContabil</code>
	 */
	public ContaContabil getContaOrigem() {

		return contaOrigem;
	}

	/**
	 * Define o valor do atributo <code>contaOrigem</code>.
	 *
	 * @param contaOrigem
	 */
	public void setContaOrigem(ContaContabil contaOrigem) {

		this.contaOrigem = contaOrigem;
	}

	/**
	 * Retorna o valor do atributo <code>material</code>
	 *
	 * @return <code>Material</code>
	 */
	public Material getMaterial() {

		return material;
	}

	/**
	 * Define o valor do atributo <code>material</code>.
	 *
	 * @param material
	 */
	public void setMaterial(Material material) {

		this.material = material;
	}

	/**
	 * Retorna o valor do atributo <code>almoxarifado</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getAlmoxarifado() {

		return almoxarifado;
	}

	/**
	 * Define o valor do atributo <code>almoxarifado</code>.
	 *
	 * @param almoxarifado
	 */
	public void setAlmoxarifado(Boolean almoxarifado) {

		this.almoxarifado = almoxarifado;
	}

	/**
	 * Retorna o valor do atributo <code>codigo</code>
	 *
	 * @return <code>String</code>
	 */
	public String getCodigo() {

		return codigo;
	}

	/**
	 * Define o valor do atributo <code>codigo</code>.
	 *
	 * @param codigo
	 */
	public void setCodigo(String codigo) {

		this.codigo = codigo;
	}



	/**
	 * Retorna o valor do atributo <code>valorDepreciacaoAcumulada</code>
	 *
	 * @return <code>BigDecimal</code>
	 */
	public BigDecimal getValorDepreciacaoAcumulada() {

		return valorDepreciacaoAcumulada;
	}



	/**
	 * Define o valor do atributo <code>valorDepreciacaoAcumulada</code>.
	 *
	 * @param valorDepreciacaoAcumulada
	 */
	public void setValorDepreciacaoAcumulada(BigDecimal valorDepreciacaoAcumulada) {

		this.valorDepreciacaoAcumulada = valorDepreciacaoAcumulada;
	}


}
