package br.com.centralit.api.service;

import java.util.Calendar;

import br.com.centralit.api.model.ContaContabilSaldo;
import br.com.centralit.framework.model.Organizacao;
import br.com.centralit.framework.service.arquitetura.GenericService;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 13/01/2015 - 15:30:00
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *	
 */
public interface ContaContabilSaldoService extends GenericService<ContaContabilSaldo, Long> {

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author iago.almeida
	 *
	 * @param idContaContabil
	 * @param dataReferencia
	 * @return
	 */
	ContaContabilSaldo obterContaContabilSaldoPorContaContabilEDataReferencia(Long idContaContabil, Calendar dataReferencia);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author iago.almeida
	 *
	 * @param idContaContabil
	 * @return
	 */
	ContaContabilSaldo obterUltimaContaContabilSaldo(Long idContaContabil);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por fechar o Saldo das contas contábeis de um orgão.
	 *
	 * @author geovane.filho
	 *
	 * @param organizacao Orgão a se fechar os Saldos de suas contas contábeis.
	 * 
	 * @return <code>true</code> caso todos os saldos sejam fechados e <code>false</code> caso contrario.
	 */
	boolean fechaSaldoContasContabeis(Organizacao organizacao);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por verificar a existencia de saldo fechado para as contas contábeis de um orgão em uma dada referência.
	 *
	 * @author geovane.filho
	 *
	 * @param organizacao Orgão a se verificar a existencia de saldo fechado para suas contas.
	 * @param dataReferencia Data de referência para filtro.
	 * 
	 * @return <code>true</code> caso exista saldo fechado para alguma conta deste orgão na data de referência passada, <code>false</code> caso contrário.
	 */
	Boolean existeSaldoOrganizacaoEDataReferencia(Organizacao organizacao, Calendar dataReferencia);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por fechar o saldo das contas contábeis de materiais do tipo permanente (Patrimônio) de um orgão.
	 *
	 * @author geovane.filho
	 *
	 * @param organizacao
	 * @return
	 */
	boolean fechaSaldoContasContabeisTipoPermanente(Organizacao organizacao);
}
