package br.com.centralit.api.service;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.List;

import br.com.centralit.api.model.ContaContabil;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.Organizacao;
import br.com.centralit.framework.service.arquitetura.GenericService;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 29/12/2014 - 17:25:02
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
public interface ContaContabilService extends GenericService<ContaContabil, Long> {

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author rogerio.costa
	 * 
	 * @param codigo
	 * @return
	 */
	Collection<ContaContabil> findContaContabil(String codigo);

	/**
	 * 
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por encontrar todas as contas contabeis de um determinado orgão.
	 * 
	 * @author geovane.filho
	 * 
	 * @param organizacao
	 *            <code>Organizacao</code> a se buscar suas contas contabeis.
	 * 
	 * @return <code>Collection<ContaContabil></code> contendo todas as contas contabeis do orgão.
	 */
	Collection<ContaContabil> findAllByOrganizacao(Organizacao organizacao);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por lista conta contábil por código e órgão do usuário logado
	 * 
	 * @author rogerio.cassimiro
	 * 
	 * @param codigo
	 * @param idOrganizacao
	 * @return Collection<ContaContabil>
	 */
	Collection<ContaContabil> findContaContabilPorOrganizacao(String codigo, Long idOrganizacao);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por verificar se existe uma contaContabil vinculado a estrutura
	 * 
	 * @author rogerio.costa
	 * 
	 * @param localizacaoId
	 * 
	 * @return boolean
	 */
	boolean existeContaContabilVinculadaAEstrutura(Long idEstrutura);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter conta contábil por código, órgão, domínio
	 * 
	 * @author rogerio.cassimiro
	 * 
	 * @param codigo
	 * @param idOrganizacao
	 * @param idDominio
	 * @return Collection<ContaContabil>
	 */
	Collection<ContaContabil> findContaContabilPorOrganizacaoEDominio(String codigo, Long idOrganizacao, Long idDominio);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter conta contábil por código, órgão, domínio que não esteja em uso em algum material
	 * 
	 * @author rogerio.cassimiro
	 * 
	 * @param codigo
	 * @param idOrganizacao
	 * @param idDominio
	 * @return Collection<ContaContabil>
	 */
	Collection<ContaContabil> findContaContabilPorOrganizacaoEDominioSemUsoMaterial(String codigo, Long idOrganizacao, Long idDominio);
	
	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por obter conta contábil por código, órgão, domínio que não esteja em uso em algum almoxarifado
	 * 
	 * @author geovane.filho
	 * 
	 * @param codigo
	 * @param idOrganizacao
	 * @param idDominio
	 * @return Collection<ContaContabil>
	 */
	Collection<ContaContabil> findContaContabilPorOrganizacaoEDominioSemUsoAlmoxarifado(String codigo, Long idOrganizacao, Long idDominio);

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por listar a entidade <code>ContaContabil</code> através do orgão, tipoMaterial e que não esteja em uso pela estrutura.
	 * 
	 * @author rogerio.costa
	 * 
	 * @param str
	 * @param idOrganizacao
	 * @param codigoTipoMaterial
	 * @param idContaContabilEmUso
	 * @return Collection<ContaContabil>
	 */
	Collection<ContaContabil> findContaContabilPorOrganizacaoTipoMaterial(String str, Long idOrganizacao, Long codigoTipoMaterial);
	
	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por recuperar o valor atual total de uma determinada conta
	 * 
	 * @author geovane.filho
	 * 
	 * @param contaId id da conta
	 * @return
	 */
	public BigDecimal getValorAtual(Long contaId);
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por obter a conta contábil definida na configuracaoparametrosistema
	 *
	 * @author rogerio.cassimiro
	 *
	 * @return
	 */
	ContaContabil obterContaContabilAlmoxarifadoConfiguracaoParametroSistema();

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 *  Método responsável por obter a conta contábil por inventário
	 *
	 * @author rogerio.cassimiro
	 *
	 * @param busca
	 * @param idInventario
	 * @return
	 */
	List<ContaContabil> findContaContabilPorInventario(String busca, Long idInventario);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por trazer uma conta contabil referenciada em um determinado material
	 *
	 * @author geovane.filho
	 *
	 * @param materialId id do material
	 * @return
	 */
	ContaContabil findByMaterial(Long materialId);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por encontrar todas as contas contabeis de um determinado tipo de material de um orgão.
	 *
	 * @author geovane.filho
	 *
	 * @param organizacao
	 * @param tipoMaterial
	 * @return
	 */
	Collection<ContaContabil> findAllByOrganizacaoAndTipoMaterial(Organizacao organizacao, Dominio tipoMaterial);

}
