package br.com.centralit.api.service;

import java.math.BigDecimal;
import java.util.List;

import br.com.centralit.api.model.MaterialConsumo;
import br.com.centralit.framework.service.arquitetura.GenericService;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 25/05/2015 - 10:25:14
 *
 * @version 1.0.0
 *
 * @author rogerio.costa
 *
 */
public interface MaterialConsumoService extends GenericService<MaterialConsumo, Long> {

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">593</a>
	 * </p>
	 *
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 *
	 * Método responsável por buscar os materiais de consumo de uma organizacao
	 *
	 * @author juliana.barbosa
	 *
	 * @param descricao
	 * @param idOrganizacao
	 * @return
	 */
	List<MaterialConsumo> findMateriaisConsumoByOrganizacao(String descricao, Long idOrganizacao);

	/**
	 * Método responsável por calcular o valor atual total dos materiais de consumo em estoque de um determinado material.
	 *
	 * @param materialId
	 *            material a se pesquisar o valor atual total dos seus materiais de consumo em estoque.
	 * @param organizacaoId
	 * @return
	 */
	public BigDecimal getValorAtualMaterial(Long materialId, Long organizacaoId);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por buscar a quantidade atual de um determinado material de consumo
	 *
	 * @author geovane.filho
	 *
	 * @param materialId
	 * @param organizacaoId
	 * @return
	 */
	public BigDecimal getQuantidadeAtualMaterial(Long materialId, Long organizacaoId);	
	
	/**
	 *
	 * Método responsável por buscar a quantidade atual de um determinado material de consumo - chamada da job
	 *
	 * @author rogerio.cassimiro
	 *
	 * @param materialId
	 * @param organizacaoId
	 * @param urlScheme
	 * @param urlHost
	 * @param urlPort
	 * @return {@link BigDecimal}
	 */
	public BigDecimal getQuantidadeAtualMaterial(Long materialId, Long organizacaoId, String urlScheme, String urlHost, int urlPort);	

}
