package br.com.centralit.api.service.impl;

import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.service.DominioService;
import br.com.centralit.api.service.MenuService;
import br.com.centralit.api.service.ModuloService;
import br.com.centralit.api.service.PaginaService;
import br.com.centralit.framework.model.UtilStartup;
import br.com.centralit.framework.model.Menu;
import br.com.centralit.framework.model.MenuFile;
import br.com.centralit.framework.model.Pagina;

@Service("inicializarAdmMateriaisService")
public class InicializarAdmMateriaisServiceImpl extends UtilStartup {

	@Autowired
	private PaginaService paginaService;

	@Autowired
	private MenuService menuService;

	@Autowired
	private DominioService dominioService;
	
	@Autowired
	private ModuloService moduloService;

	private Menu menuAdmMaterial;
	/**
	 * Método responsável por gerar carga do módulo Portal
	 *
	 * @author rogerio.cassimiro
	 *
	 */
	public void gerarCarga() {
		criarPaginasMenus();
	}
	
	/**
	 *
	 * Método responsável por criar paginas e menus do modulo
	 *
	 * @author iago.almeida
	 *
	 */
	private void criarPaginasMenus() {

		dominioJS = this.dominioService.findByChaveAndNome(TIPO_FILE, TIPO_FILE_JS);
		moduloSelecionado = this.moduloService.getModuloPorBaseUrl(BASE_URL_ADM_MATERIAIS, null);
		
		// Menu pai Administração de Materiais
		menuAdmMaterial = new Menu("Administração de materiais", null, null, null, 4, COR_ADM_MATERIAL, CSS_MENU_ADM_MATERIAL, OPACIDADE_MENU_ADM, CLASSE_ADM_MATERIAL, ICONE_MENU_ADMINISTRACAO_DE_MATERIAIS, moduloSelecionado);
		menuAdmMaterial = this.menuService.mergeIfNotExist(menuAdmMaterial);

		// Submenu Materiais
		Menu menuMateriais = new Menu("Materiais", null, menuAdmMaterial, 3, 2, null, null, null, null, moduloSelecionado);
		menuMateriais = this.menuService.mergeIfNotExist(menuMateriais);
		// Menu Cadastro de material
		Pagina pgMaterial = new Pagina("Cadastro de material", "/cit-adm-materiais-web/html/material/material.html");
		pgMaterial = this.paginaService.saveIfNotExist(pgMaterial);
		Menu menuMaterial = new Menu("Cadastro de material", pgMaterial, menuMateriais, null, 1, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFileMaterial = this.gerarArquivosMenu(menuMaterial, CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM, "Material", true, true, true);
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialPermanenteConsumoRepository.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialPermanenteConsumoRepository.min.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialImagemRepository.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialImagemRepository.min.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialCaracteristicaRepository.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialCaracteristicaRepository.min.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialConsumoRepository.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialConsumoRepository.min.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialPermanenteRepository.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialPermanenteRepository.min.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialConsumoTipoUnidadeMedidaEntradaRepository.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/MaterialConsumoTipoUnidadeMedidaEntradaRepository.min.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ALMOXARIFADO_WEB_ANGULAR_CUSTOM + "repository/MaterialLocalEstoqueRepository.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ALMOXARIFADO_WEB_ANGULAR_CUSTOM + "repository/MaterialLocalEstoqueRepository.min.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ALMOXARIFADO_WEB_ANGULAR_CUSTOM + "repository/MaterialEnderecoEstoqueRepository.js", dominioJS, menuMaterial));
		filesMenuFileMaterial.add(new MenuFile(CIT_ALMOXARIFADO_WEB_ANGULAR_CUSTOM + "repository/MaterialEnderecoEstoqueRepository.min.js", dominioJS, menuMaterial));
		
		menuMaterial.setIncludes(filesMenuFileMaterial);
		this.menuService.mergeIfNotExist(menuMaterial);
		// Menu Classificação de materiais
		Pagina pgClassificacaoMaterial = new Pagina("Classificação de materiais", "/cit-adm-materiais-web/html/classificacaoMaterial/classificacaoMaterial.html");
		pgClassificacaoMaterial = this.paginaService.saveIfNotExist(pgClassificacaoMaterial);
		Menu menuClassificacao = new Menu("Classificação de materiais", pgClassificacaoMaterial, menuMateriais, null, 2, null, null, null, null, moduloSelecionado);
		menuClassificacao.setIncludes(this.gerarArquivosMenu(menuClassificacao, CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM, "ClassificacaoMaterial", true, false, true));
		this.menuService.mergeIfNotExist(menuClassificacao);

		// Submenu Financeiro
		Menu menuFinanceiro = new Menu("Financeiro", null, menuAdmMaterial, 2, 0, null, null, null, null, moduloSelecionado);
		menuFinanceiro = this.menuService.mergeIfNotExist(menuFinanceiro);
		// Menu Conta contábil
		Pagina pgContaContabil = new Pagina("Conta contábil", "/cit-adm-materiais-web/html/contaContabil/contaContabil.html");
		pgContaContabil = this.paginaService.saveIfNotExist(pgContaContabil);
		Menu menuContaContabil = new Menu("Conta contábil", pgContaContabil, menuFinanceiro, null, 1, null, null, null, null, moduloSelecionado);
		menuContaContabil.setIncludes(this.gerarArquivosMenu(menuContaContabil, CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM, "ContaContabil", true, true, true));
		this.menuService.mergeIfNotExist(menuContaContabil);
		// Menu Transferência entre contas contábeis
		Pagina pgTransfContaContabil = new Pagina("Transferência entre contas contábeis", "/cit-adm-materiais-web/html/transferenciaContaContabil/transferenciaContaContabil.html");
		pgTransfContaContabil = this.paginaService.saveIfNotExist(pgTransfContaContabil);
		Menu menuTransfContaContabil = new Menu("Transferência entre contas contábeis", pgTransfContaContabil, menuFinanceiro, null, 2, null, null, null, null, moduloSelecionado);
		menuTransfContaContabil.setIncludes(this.gerarArquivosMenu(menuTransfContaContabil, CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM, "TransferenciaContaContabil", true, true, true));
		this.menuService.mergeIfNotExist(menuTransfContaContabil);

		// Menu Fechamento do mês de referência
		Pagina pgFechamentoMes = new Pagina("Fechamento do mês de referência", "/cit-adm-materiais-web/html/fechamentoMes/fechamentoMes.html");
		pgFechamentoMes = this.paginaService.saveIfNotExist(pgFechamentoMes);
		Menu menuFechamentoMes = new Menu("Fechamento do mês de referência", pgFechamentoMes, menuFinanceiro, null, 3, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFileFechamentoMes = this.gerarArquivosMenu(menuFechamentoMes, CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM, "MesReferencia", true, false, false);
		filesMenuFileFechamentoMes.add(new MenuFile(CIT_PATRIMONIO_WEB_ANGULAR_CUSTOM + "repository/OrganizacaoPatrimonioRepository.js", dominioJS, menuFechamentoMes));
		filesMenuFileFechamentoMes.add(new MenuFile(CIT_PATRIMONIO_WEB_ANGULAR_CUSTOM + "repository/OrganizacaoPatrimonioRepository.min.js", dominioJS, menuFechamentoMes));
		//Observar comportamento pois nao preciso de todos os arquivos do backend para esse fechamento
		menuFechamentoMes.setIncludes(filesMenuFileFechamentoMes);
		this.menuService.mergeIfNotExist(menuFechamentoMes);
		Logger.getLogger(InicializarAdmMateriaisServiceImpl.class).info("Menu executado - InicializarAdmMateriaisServiceImpl!");

	}

}