package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.MaterialConsumoTipoUnidadeMedidaEntradaDao;
import br.com.centralit.api.model.MaterialConsumoTipoUnidadeMedidaEntrada;
import br.com.centralit.api.service.MaterialConsumoTipoUnidadeMedidaEntradaService;
import br.com.centralit.framework.exception.BusinessException;
import br.com.centralit.framework.exception.CodigoErro;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 27/05/2015 - 15:51:46
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("materialConsumoTipoUnidadeMedidaEntradaService")
public class MaterialConsumoTipoUnidadeMedidaEntradaServiceImpl extends GenericServiceImpl<MaterialConsumoTipoUnidadeMedidaEntrada, Long> implements MaterialConsumoTipoUnidadeMedidaEntradaService {

	private MaterialConsumoTipoUnidadeMedidaEntradaDao materialConsumoTipoUnidadeMedidaEntradaDao;
	
	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param materialConsumoTipoUnidadeMedidaEntradaDao
	 * @param validator
	 */
	@Autowired
	public MaterialConsumoTipoUnidadeMedidaEntradaServiceImpl( MaterialConsumoTipoUnidadeMedidaEntradaDao materialConsumoTipoUnidadeMedidaEntradaDao) {

		this.dao = materialConsumoTipoUnidadeMedidaEntradaDao;
		this.materialConsumoTipoUnidadeMedidaEntradaDao = materialConsumoTipoUnidadeMedidaEntradaDao;
	}

	@Override
	public boolean removeById(Long id) {

		MaterialConsumoTipoUnidadeMedidaEntrada entity = this.getReference(id);

		if(this.materialConsumoTipoUnidadeMedidaEntradaDao.validarUnidadeEmUsoEntradaAlmoxarifado(entity.getUnidadeMedida().getId(), entity.getMaterialConsumo().getId())){
			throw new BusinessException("VALIDACAO.UNIDADE_MEDIDA_VALIDACAO_EXCLUSAO", CodigoErro.REGRA_NEGOCIO.getValue(), "");
		}
		
		entity.setMaterialConsumoRemocao(entity.getMaterialConsumo());

		entity.setMaterialConsumo(null);

		this.merge(entity);

		return super.removeById(id);
	}

	/**
	 * Retorna o valor do atributo <code>materialConsumoTipoUnidadeMedidaEntradaDao</code>
	 * 
	 * @return <code>MaterialConsumoTipoUnidadeMedidaEntradaDao</code>
	 */
	public MaterialConsumoTipoUnidadeMedidaEntradaDao getMaterialConsumoTipoUnidadeMedidaEntradaDao() {

		return materialConsumoTipoUnidadeMedidaEntradaDao;
	}

}
