package br.com.centralit.api.service.impl;

import java.io.IOException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import br.com.centralit.api.dao.MaterialImagemDao;
import br.com.centralit.api.model.MaterialImagem;
import br.com.centralit.api.service.MaterialImagemService;
import br.com.centralit.api.service.MaterialService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * MaterialImagemServiceImp
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 22/12/2014 - 08:58:35
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("materialImagemService")
public class MaterialImagemServiceImpl extends GenericServiceImpl<MaterialImagem, Long> implements MaterialImagemService {

	/** Atributo materialImagemDao. */
	private MaterialImagemDao materialImagemDao;

	/** Atributo materialService. */
	@Autowired
	private MaterialService materialService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param materialImagemDao
	 */
	@Autowired
	public MaterialImagemServiceImpl( MaterialImagemDao materialImagemDao ) {

		this.dao = materialImagemDao;

		this.materialImagemDao = materialImagemDao;

	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean removeById(Long id) {
	
		MaterialImagem materialImagem = this.find(id);
		
		return remove(materialImagem);
	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean remove(MaterialImagem entity) {
	
		entity.setMaterialInativo(entity.getMaterial());
		
		entity.setMaterial(null);
		
		return super.remove(entity);
	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por salvar a entidade <code>MaterialImagem</code>
	 * 
	 * @author rogerio.costa
	 * 
	 * @param file
	 * 
	 * @param idMaterial
	 */
	public void save(MultipartFile file, Long idMaterial) {

		MaterialImagem materialImagem = this.montarDadosMaterialImagem(file, idMaterial);

		super.save(materialImagem);

	}

	/**
	 * <p>
	 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
	 * </p>
	 * 
	 * <p>
	 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
	 * </p>
	 * 
	 * Método responsável por
	 * 
	 * @author rogerio.costa
	 * 
	 * @param file
	 * @param idMaterial
	 */
	private MaterialImagem montarDadosMaterialImagem(MultipartFile file, Long idMaterial) {

		MaterialImagem materialImagem = new MaterialImagem();

		materialImagem.setMaterial(this.getMaterialService().find(idMaterial));

		try {

			materialImagem.setAnexo(file.getBytes());
			
			materialImagem.setTamanho(file.getSize());

			materialImagem.setDescricao(file.getOriginalFilename());

		} catch (IOException e) {

			e.printStackTrace();
		}

		return materialImagem;
	}

	/**
	 * Retorna o valor do atributo <code>materialImagemDao</code>
	 * 
	 * @return <code>MaterialImagemDao</code>
	 */
	public MaterialImagemDao getMaterialImagemDao() {

		return materialImagemDao;
	}

	/**
	 * Retorna o valor do atributo <code>materialService</code>
	 * 
	 * @return <code>MaterialService</code>
	 */
	public MaterialService getMaterialService() {

		return materialService;
	}

}
