package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.MaterialPermanenteDao;
import br.com.centralit.api.model.MaterialPermanente;
import br.com.centralit.api.service.MaterialPermanenteService;
import br.com.centralit.api.service.MaterialService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 28/05/2015 - 08:53:19
 * 
 * @version 1.0.0
 * 
 * @author rogerio.costa
 * 
 */
@Service("materialPermanenteService")
public class MaterialPermanenteServiceImpl extends GenericServiceImpl<MaterialPermanente, Long> implements MaterialPermanenteService {

	/** Atributo materialPermanenteDao. */
	private MaterialPermanenteDao materialPermanenteDao;

	/** Atributo materialService. */
	@Autowired
	private MaterialService materialService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * 
	 * @param materialPermanenteDao
	 */
	@Autowired
	public MaterialPermanenteServiceImpl( MaterialPermanenteDao materialPermanenteDao, @Qualifier("materialPermanenteValidator") Validator validator ) {

		this.dao = materialPermanenteDao;

		this.materialPermanenteDao = materialPermanenteDao;

		this.validator = validator;
	}

	@Override
	public MaterialPermanente save(MaterialPermanente entity) {

		this.validarEntidade(entity, this.validator);

		return (MaterialPermanente) this.materialService.save(entity);
	}

	@Override
	public MaterialPermanente merge(MaterialPermanente entity) {

		this.validarEntidade(entity, this.validator);

		return (MaterialPermanente) this.materialService.merge(entity);
	}

}
