package br.com.centralit.api.viewHelper;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Calendar;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import br.com.centralit.api.model.EstruturaOrganizacional;
import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.json.JsonCalendarSimpleDateSerializer;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * RequisicaoVH
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 28/05/2015 - 19:12:16
 * 
 * @version 1.0.0
 * 
 * @author rogerio.cassimiro
 * 
 */
public class RequisicaoVH implements Serializable {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 2604907484835174816L;

	/** Atributo idOrganizacao. */
	private Long idOrganizacao;

	/** Atributo estrutura. */
	private EstruturaOrganizacional estrutura;

	/** Atributo numero. */
	private String numero;

	/** Atributo dataInicioDevolucao. */
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	private Calendar dataInicioDevolucao;

	/** Atributo dataFimDevolucao. */
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	private Calendar dataFimDevolucao;

	/** Atributo idsTtipoStatusRequisicao. */
	private ArrayList<Long> idsTtipoStatusRequisicao;

	/** Atributo idsTtipoStatusRequisicao. */
	private ArrayList<Long> idsRequisicoes;

	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	private Calendar dataFinalizacao;

	private Boolean statusAtendimentoRequsicao;

	/**
	 * Retorna o valor do atributo <code>idsTtipoStatusRequisicao</code>
	 * 
	 * @return <code>ArrayList<Long></code>
	 */
	public ArrayList<Long> getIdsTtipoStatusRequisicao() {

		return idsTtipoStatusRequisicao;
	}

	/**
	 * Define o valor do atributo <code>idsTtipoStatusRequisicao</code>.
	 * 
	 * @param idsTtipoStatusRequisicao
	 */
	public void setIdsTtipoStatusRequisicao(ArrayList<Long> idsTtipoStatusRequisicao) {

		this.idsTtipoStatusRequisicao = idsTtipoStatusRequisicao;
	}

	/**
	 * Retorna o valor do atributo <code>idOrganizacao</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getIdOrganizacao() {

		return idOrganizacao;
	}

	/**
	 * Define o valor do atributo <code>idOrganizacao</code>.
	 * 
	 * @param idOrganizacao
	 */
	public void setIdOrganizacao(Long idOrganizacao) {

		this.idOrganizacao = idOrganizacao;
	}

	/**
	 * Retorna o valor do atributo <code>estrutura</code>
	 * 
	 * @return <code>EstruturaOrganizacional</code>
	 */
	public EstruturaOrganizacional getEstrutura() {

		return estrutura;
	}

	/**
	 * Define o valor do atributo <code>estrutura</code>.
	 * 
	 * @param estrutura
	 */
	public void setEstrutura(EstruturaOrganizacional estrutura) {

		this.estrutura = estrutura;
	}

	/**
	 * Retorna o valor do atributo <code>dataInicioDevolucao</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataInicioDevolucao() {

		return dataInicioDevolucao;
	}

	/**
	 * Define o valor do atributo <code>dataInicioDevolucao</code>.
	 * 
	 * @param dataInicioDevolucao
	 */
	public void setDataInicioDevolucao(Calendar dataInicioDevolucao) {

		this.dataInicioDevolucao = dataInicioDevolucao;
	}

	/**
	 * Retorna o valor do atributo <code>dataFimDevolucao</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataFimDevolucao() {

		return dataFimDevolucao;
	}

	/**
	 * Define o valor do atributo <code>dataFimDevolucao</code>.
	 * 
	 * @param dataFimDevolucao
	 */
	public void setDataFimDevolucao(Calendar dataFimDevolucao) {

		this.dataFimDevolucao = dataFimDevolucao;
	}

	/**
	 * Retorna o valor do atributo <code>numero</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNumero() {

		return numero;
	}

	/**
	 * Define o valor do atributo <code>numero</code>.
	 * 
	 * @param numero
	 */
	public void setNumero(String numero) {

		this.numero = numero;
	}

	/**
	 * Retorna o valor do atributo <code>idsRequisicoes</code>
	 * 
	 * @return <code>ArrayList<Long></code>
	 */
	public ArrayList<Long> getIdsRequisicoes() {

		return idsRequisicoes;
	}

	/**
	 * Define o valor do atributo <code>idsRequisicoes</code>.
	 * 
	 * @param idsRequisicoes
	 */
	public void setIdsRequisicoes(ArrayList<Long> idsRequisicoes) {

		this.idsRequisicoes = idsRequisicoes;
	}

	/**
	 * Retorna o valor do atributo <code>dataFinalizacao</code>
	 * 
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataFinalizacao() {

		return dataFinalizacao;
	}

	/**
	 * Define o valor do atributo <code>dataFinalizacao</code>.
	 * 
	 * @param dataFinalizacao
	 */
	public void setDataFinalizacao(Calendar dataFinalizacao) {

		this.dataFinalizacao = dataFinalizacao;
	}

	public Boolean getStatusAtendimentoRequsicao() {
		return statusAtendimentoRequsicao;
	}

	public void setStatusAtendimentoRequsicao(Boolean statusAtendimentoRequsicao) {
		this.statusAtendimentoRequsicao = statusAtendimentoRequsicao;
	}

}
