﻿--===========================================================================--
-- ##INI :: CARGAS E ATUALIZACOES DE SALDOS CONTABEIS/ESTOQUE/MOVIMENTOS     --
--===========================================================================--

-- ############################################################################
-- #### -Esses scripts devem ser executados após as depreciações de bens  #####
-- #### -Verificar o anomes referência/data contábil do cliente e ajustar #####
-- ############################################################################


-- #INI :: MIGRACAO DE MOVIMENTOS DE DEPRECIACAO >> CONTACONTABILMOVIMENTO E CONTACONTABILMOVPATRIMONIO
    DO $$ 
    DECLARE      
      r RECORD;
      v_ccmId BIGINT;
      v_movent BIGINT;
      v_classeRefDepre BIGINT;
    BEGIN

      SELECT ID INTO v_movent
        FROM PUBLIC.DOMINIO 
       WHERE CHAVE  = 'tipoMovimentoContaContabil' 
         AND CODIGO = 3;

      SELECT ID INTO v_classeRefDepre
        FROM PUBLIC.DOMINIO 
       WHERE CHAVE  = 'classeReferencia' 
         AND CODIGO = 7;              
    
      FOR r IN 
    SELECT 
        D.MESREFERENCIA AS DATAREFERENCIA,
        DI.VALORDEPRECIACAOATUAL AS VALOR,        
        DI.CONTACONTABIL_ID,
        D.ID AS DEPRECIACAO_ID,
        DI.BEMPATRIMONIAL_ID
    FROM DEPRECIACAO D
    INNER JOIN DEPRECIACAOITEM DI ON (DI.DEPRECIACAO_ID = D.ID)
    ORDER BY D.MESREFERENCIA
      LOOP

         raise notice 'mesano, %', to_char(r.datareferencia, 'YYYYMM');

    -- RECUPERA A PROXIMA SEQUENCE
    SELECT NEXTVAL('hibernate_sequence') into v_ccmId;
    
        INSERT INTO public.contacontabilmovimento
        (
        id,
        datacriacao, 
        dataedicao, 
        version, 
        datareferencia, 
        valor,             
        contacontabil_id, 
        tipomovimentocontacontabil_id, 
        dominioclassereferencia_id,
        idclassereferencia
        )VALUES
        (
        v_ccmId,
        LOCALTIMESTAMP, 
        LOCALTIMESTAMP, 
        0, 
        r.datareferencia, 
        0,             
        r.contacontabil_id, 
        v_movent, 
        v_classeRefDepre,
        R.DEPRECIACAO_ID        
        );        
        
        INSERT INTO public.contacontabilmovpatrimonio
        (
        id,
        reavaliacao,
        valordepreciacao,
        valorreavaliacao,
        valorreducao,
        bempatrimonial_id,
        transferencia_id
        )
        VALUES
        (
        v_ccmId,
        FALSE,
        r.valor,
        0,
        0,        
        r.BEMPATRIMONIAL_ID, 
        NULL
        );
    END LOOP;
   END$$;              
   -- 20 minutos maquina Ju
-- #FIM :: MIGRACAO DE MOVIMENTOS DE DEPRECIACAO >> CONTACONTABILMOVIMENTO E CONTACONTABILMOVPATRIMONIO


UPDATE BEMPATRIMONIAL
SET DOMINIOSTATUSDEPRECIACAO_ID = NULL;

-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE NEM CHEGARAM A SER DEPRECIADOS >> BEMPATRIMONIAL
    DO $$
    DECLARE
      rBEM     RECORD;
      v_tipoStatusDepreciacaoNaoDepreExAnt int;
      v_statusBemBaixado int;
    BEGIN
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=5 INTO v_tipoStatusDepreciacaoNaoDepreExAnt;
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusBem' AND CODIGO=2 INTO v_statusBemBaixado;
      -- RECUPERA OS BENS PATRIMONIAIS QUE ESTAO NA TABELA DE DEPRECIACAO
      FOR rBEM IN 
        SELECT ID FROM PUBLIC.BEMPATRIMONIAL
         WHERE ID IN ( SELECT ID FROM PUBLIC.BEMPATRIMONIAL
                       EXCEPT 
                       SELECT BEMPATRIMONIAL_ID FROM DEPRECIACAOITEM
                      ) 
           AND DOMINIOSTATUS_ID=v_statusBemBaixado
      LOOP
         UPDATE PUBLIC.BEMPATRIMONIAL
            SET dominiostatusdepreciacao_id = v_tipoStatusDepreciacaoNaoDepreExAnt
          WHERE ID = rBEM.id;      
      END LOOP;    
    END$$; 
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE NEM CHEGARAM A SER DEPRECIADOS >> BEMPATRIMONIAL


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL
    DO $$
    DECLARE
      rBEM     RECORD;
      v_tipoStatusDepreciacaoFinalizada int;
      v_statusBemBaixado int;      
    BEGIN
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=3 INTO v_tipoStatusDepreciacaoFinalizada;     
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusBem' AND CODIGO=2 INTO v_statusBemBaixado; 
      -- RECUPERA OS BENS PATRIMONIAIS BAIXADOS QUE ESTAO NA TABELA DE DEPRECIACAO E JA ATINGIRAM O VALOR RESIDUAL
      FOR rBEM IN 
        SELECT DISTINCT BEMPATRIMONIAL_ID AS ID
        FROM DEPRECIACAOITEM D
        INNER JOIN BEMPATRIMONIAL B ON (B.ID = D.BEMPATRIMONIAL_ID)  
        WHERE DOMINIOSTATUS_ID = v_statusBemBaixado 
        AND round((B.VALORBRUTOATUAL*B.PERCENTUALNAODEPRECIAVEL), 2) = round(B.VALORLIQUIDO, 2)
      LOOP
         UPDATE PUBLIC.BEMPATRIMONIAL
            SET dominiostatusdepreciacao_id = v_tipoStatusDepreciacaoFinalizada
         WHERE ID = rBEM.id;      
      END LOOP;    
    END$$; 
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE NAO ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL
    DO $$
    DECLARE
      rBEM     RECORD;
      v_tipoStatusDepreciavel int;
      v_statusBemBaixado int;      
    BEGIN
    
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=1 INTO v_tipoStatusDepreciavel;     
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusBem' AND CODIGO=2 INTO v_statusBemBaixado; 
      
      -- RECUPERA OS BENS PATRIMONIAIS BAIXADOS QUE ESTAO NA TABELA DE DEPRECIACAO E NAO ATINGIRAM O VALOR RESIDUAL
      FOR rBEM IN 
        SELECT DISTINCT BEMPATRIMONIAL_ID AS ID
        FROM PUBLIC.DEPRECIACAOITEM D
        INNER JOIN BEMPATRIMONIAL B ON (B.ID = D.BEMPATRIMONIAL_ID)
        WHERE DOMINIOSTATUS_ID = v_statusBemBaixado 
        AND round((B.VALORBRUTOATUAL*B.PERCENTUALNAODEPRECIAVEL), 2) <> round(B.VALORLIQUIDO, 2)
        AND B.DOMINIOSTATUSDEPRECIACAO_ID IS NULL
      LOOP
         UPDATE PUBLIC.BEMPATRIMONIAL
            SET dominiostatusdepreciacao_id = v_tipoStatusDepreciavel
          WHERE ID = rBEM.id;      
      END LOOP;    
    END$$;  
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE NAO ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL
    DO $$
    DECLARE
      rBEM     RECORD;
      v_tipoStatusAlmox int;       
    BEGIN
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=2 into v_tipoStatusAlmox;           
      -- RECUPERA OS BENS PATRIMONIAIS QUE ESTAO NO ALMOXARIFADO
      FOR rBEM IN 
        SELECT ID 
        FROM BEMPATRIMONIAL 
        WHERE UNIDADEATUAL_ID IN (SELECT E.ID 
                      FROM ESTRUTURAORGANIZACIONAL E 
                      INNER JOIN estruturaorganizacionalpatrim EP ON (EP.ESTRUTURAORGANIZACIONAL_ID = E.ID) 
                      WHERE EP.ISALMOXARIFADO IS TRUE)
      LOOP
         UPDATE PUBLIC.BEMPATRIMONIAL
            SET dominiostatusdepreciacao_id = v_tipoStatusAlmox
          WHERE ID = rBEM.id;      
      END LOOP;    
    END$$;   
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL


-- ################                                                                                         ################
-- ################             )))))  VERIFICAR O ANOMES ATUAL DA REFERENCIA DO CLIENTE  (((((             ################
-- ################                                                                                         ################
-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL
    DO $$
    DECLARE
      rBEM     RECORD;
      v_tipoStatusPronto int;       
    BEGIN
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=6 into v_tipoStatusPronto;           
      -- RECUPERA OS BENS PATRIMONIAIS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO
      FOR rBEM IN 
        SELECT ID 
        FROM BEMPATRIMONIAL 
        WHERE TO_CHAR(DATACONTABIL, 'YYYYMM') = '201606' -- << ALTERAR PARA ANOMES CONFORME CLIENTE >>
          AND UNIDADEATUAL_ID NOT IN (SELECT E.ID 
                                      FROM ESTRUTURAORGANIZACIONAL E 
                                      INNER JOIN ESTRUTURAORGANIZACIONALPATRIM EP ON (EP.ESTRUTURAORGANIZACIONAL_ID = E.ID) 
                                      WHERE EP.ISALMOXARIFADO IS TRUE)
      LOOP
         UPDATE PUBLIC.BEMPATRIMONIAL
            SET DOMINIOSTATUSDEPRECIACAO_ID = v_tipoStatusPronto
          WHERE ID = rBEM.id;      
      END LOOP;    
    END$$; 
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL


-- ################                                                                                         ################
-- ################             )))))  VERIFICAR A DATACONTABIL INICIAL PARA DEPRECIACAO  (((((             ################
-- ################                                                                                         ################
-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL
    DO $$
    DECLARE
      rBEM     RECORD;
      v_tipoStatusNaoDepreciavel int;
    BEGIN
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=4 into v_tipoStatusNaoDepreciavel;
      -- RECUPERA OS BENS PATRIMONIAIS QUE AINDA NAO POSSUEM STATUSDEPRECIACAO E QUE TEM DATA CONTABIL INFERIOR A 2010 E NAO SOFRERAM REAVALIACAO
      FOR rBEM IN 
        SELECT ID 
        FROM PUBLIC.BEMPATRIMONIAL 
        WHERE DATACONTABIL < TO_TIMESTAMP('20100101', 'YYYYMMDD') -- << ALTERAR PARA ANOMES CONFORME CLIENTE >>
        AND ID NOT IN (SELECT DISTINCT BEMPATRIMONIAL_ID 
                       FROM BEMPATRIMONIALALTERACAO 
                       WHERE MOTIVOALTERACAO_ID = (SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoMotivoAlteracaoBem' AND CODIGO=3)) 
        AND DOMINIOSTATUSDEPRECIACAO_ID IS NULL
      LOOP
         UPDATE PUBLIC.BEMPATRIMONIAL
            SET DOMINIOSTATUSDEPRECIACAO_ID = v_tipoStatusNaoDepreciavel
          WHERE ID = rBEM.id;      
      END LOOP;    
    END$$;         
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE JA ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL
    DO $$
    DECLARE
      rBEM     RECORD;
      v_tipoStatusDepreciacaoFinalizada int;
    BEGIN
      SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=3 into v_tipoStatusDepreciacaoFinalizada;     
      -- RECUPERA OS BENS PATRIMONIAIS QUE AINDA NAO POSSUEM STATUSDEPRECIACAO E JA ATINGIRAM O VALOR RESIDUAL
      FOR rBEM IN 
        SELECT DISTINCT BEMPATRIMONIAL_ID AS ID
        FROM PUBLIC.DEPRECIACAOITEM D
        INNER JOIN BEMPATRIMONIAL B ON (B.ID = D.BEMPATRIMONIAL_ID)  WHERE round((B.VALORBRUTOATUAL*B.PERCENTUALNAODEPRECIAVEL), 2) = round(B.VALORLIQUIDO, 2) AND B.DOMINIOSTATUSDEPRECIACAO_ID IS NULL
      LOOP
         UPDATE PUBLIC.BEMPATRIMONIAL
            SET DOMINIOSTATUSDEPRECIACAO_ID = v_tipoStatusDepreciacaoFinalizada
          WHERE ID = rBEM.id;      
      END LOOP;    
    END$$; 
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE JA ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL 


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE NAO SE ADEQUARAM NAS CONDICOES ANTERIORES (SAO TODOS DEPRECIAVEIS) >> BEMPATRIMONIAL
  BEGIN;
    UPDATE public.bempatrimonial 
       SET dominiostatusdepreciacao_id = (SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=1) 
     WHERE dominiostatusdepreciacao_id is null;
  COMMIT;

  BEGIN;
    UPDATE public.bempatrimonial 
       SET naodepreciar = true 
     WHERE dominiostatusdepreciacao_id = (SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=4);
  COMMIT;
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE NAO SE ADEQUARAM NAS CONDICOES ANTERIORES (SAO TODOS DEPRECIAVEIS) >> BEMPATRIMONIAL


BEGIN;  -- #INI :: GERACAO DE SALDOS E CONFIGURACOES A PARTIR DE 2011-12
    --> LANCAMENTO DE SALDOS DO MES 2012-01
    INSERT INTO public.contacontabilsaldo
         ( id, datacriacao, dataedicao, version, datareferencia, depreciacaoacumulada,  depreciacaomensal,  
           reavaliacaoperiodo, reavaliacaoacumulada, reducaoperiodo, reducaoacumulada, contacontabil_id, valor )
    VALUES
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142120400' LIMIT 1), 6621.63),    -- APARELHOS DE MEDICAO
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142120600' LIMIT 1), 57532.48),   -- APARELHOS E EQUIPDE COMUNICACAO
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142120800' LIMIT 1), 5217.00),    -- AP EQUIP/UTENS.MED/ODON/HOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142121000' LIMIT 1), 104350.21),  -- AP E EQUIP ESPORTES DIVERSOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142121200' LIMIT 1), 328972.89),  -- AP E UTENSILIOS DOMESTICOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142121800' LIMIT 1), 503231.35),  -- COLECOES E MAT BIBLIOGRAFICOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142121900' LIMIT 1), 3346.00),    -- DISCOTECAS E FILMOTECAS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142122400' LIMIT 1), 35435.00),   -- EQUIP PROTECAO SEG SOC SOBR
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142122800' LIMIT 1), 8354.80),    -- MAQ EQUIP DE NAT INDUSTRIAL
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142123000' LIMIT 1), 423986.42),  -- MAQ AP E EQUIP ENERGETICOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142123200' LIMIT 1), 39660.01),   -- MAQ AP EQUIP GRAFICOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142123300' LIMIT 1), 486983.93),  -- EQUIP P/ AUDIO. VIDEO E FOTO
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142123400' LIMIT 1), 239030.34),  -- MAQ AP E EQUIP DIVERSOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142123500' LIMIT 1), 3447468.60), -- EQUIPAMENTOS PROCESSAMENTO DADOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142123600' LIMIT 1), 16807.18),   -- MAQ AP E UTENSDE ESCRITORIO
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142123800' LIMIT 1), 16109.14),   -- MAQ FER E UTENSILIOS OFICINA
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142123900' LIMIT 1), 8431.46),    -- EQUIP HIDRAULICOS E ELETRICOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142124000' LIMIT 1), 4140.00),    -- MAQ TRATORES E EQUIP AGRIC ROD
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142124200' LIMIT 1), 1784137.37), -- MOBILIARIO EM GERAL
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142124400' LIMIT 1), 1800.63),    -- OBRAS DE ARTE E PECAS P/ MUSEU
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142124800' LIMIT 1), 18536.91),   -- VEICULOS DIVERSOS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142125100' LIMIT 1), 100374.82),  -- PECAS NAO INCORP A IMOVEIS
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142125200' LIMIT 1), 235396.08),  -- VEICULOS DE TRACAO MECANICA
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142128700' LIMIT 1), 182),        -- MATERIAL DE CONSUMO DE USO DURADOURO
         ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'), 0, 0, 0, 0, 0, 0, (SELECT ID FROM PUBLIC.CONTACONTABIL WHERE CODIGO='142129900' LIMIT 1), 35175.05);   -- OUTROS MATERIAIS PERMANENTES

    --> LANCA SALDO ZERO PARA AS DEMAIS CONTAS DE MATERIAL PEMANENTE
    INSERT INTO public.contacontabilsaldo
         ( id, datacriacao, dataedicao, version, datareferencia, depreciacaoacumulada,  depreciacaomensal,  
           reavaliacaoperiodo, reavaliacaoacumulada, reducaoperiodo, reducaoacumulada, contacontabil_id, valor )
    SELECT NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, TO_DATE('2011-12-01 09:26:25','YYYY-MM-DD HH24:MI:SS'),
           0, 0, 0, 0, 0, 0, C.ID, 0
      FROM PUBLIC.CONTACONTABIL C 
     WHERE C.ID NOT IN (SELECT CONTACONTABIL_ID FROM PUBLIC.CONTACONTABILSALDO)
       AND C.DOMINIOTIPOMATERIAL_ID = (SELECT ID FROM PUBLIC.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=2);
COMMIT; -- #FIM :: GERACAO DE SALDOS E CONFIGURACOES A PARTIR DE 2011-12


-- ################                                                                                         ################
-- ################             )))))  VERIFICAR O ANOMES ATUAL DA REFERENCIA DO CLIENTE  (((((             ################
-- ################                                                                                         ################
-- #INI :: GERACAO DE SALDOS COM DADOS DEPRECIACAO >> CONTACONTABILSALDO
    /*
      SCRIPT QUE GERA O SALDO
      =======================
      1. Definir o mesAtual e anoAtual a partir dos quais você quer gerar o saldo
      2. Definir o mesAnterior e anoAnterior ao saldo que você quer gerar 
         (os saldos já devem estar gerados para esse mês)
      3. Apos o insert definir onde você quer que a funcao pare de gerar saldo,
         ou seja o ultimo mes de referencia fechado no banco
    */
    DO $$
    DECLARE
      v_moventOrcamentaria      int;
      v_moventExtraOrcamentaria int;
      v_movbai     int;
      v_movbaiEo   int;
      v_matperm    int;
      v_dtaini_ant timestamp without time zone;
      v_dtafin_ant timestamp without time zone;
      v_dtaini_ref timestamp without time zone;
      v_dtafin_ref timestamp without time zone;
      v_anomes_fin timestamp without time zone;
      v_ccmId      bigint;
      v_anomes     char(6);
      r RECORD;
    BEGIN
      SELECT ID INTO v_moventOrcamentaria
        FROM PUBLIC.DOMINIO 
       WHERE CHAVE  = 'tipoMovimentoContaContabil' 
         AND CODIGO = 1;
         
      SELECT ID INTO v_moventExtraOrcamentaria
        FROM PUBLIC.DOMINIO 
       WHERE CHAVE  = 'tipoMovimentoContaContabil' 
         AND CODIGO = 3;         
      
      SELECT ID INTO v_movbai
        FROM PUBLIC.DOMINIO
       WHERE CHAVE  = 'tipoMovimentoContaContabil'
         AND CODIGO = 2;
         
      SELECT ID INTO v_movbaiEo
        FROM PUBLIC.DOMINIO
       WHERE CHAVE  = 'tipoMovimentoContaContabil'
         AND CODIGO = 4;      
      
      SELECT ID INTO v_matperm
        FROM PUBLIC.DOMINIO
       WHERE CHAVE  = 'tipoMaterial'
         AND CODIGO = 2;
      
      v_anomes_fin := TO_TIMESTAMP('20160601','YYYYMMDD')::timestamp without time zone;

      v_dtaini_ant := TO_TIMESTAMP('20111201','YYYYMMDD')::timestamp without time zone;
      v_dtafin_ant := v_dtaini_ant + interval '1 month' - interval '1 second';

      v_dtaini_ref := TO_TIMESTAMP('20120101','YYYYMMDD')::timestamp without time zone;
      v_dtafin_ref := v_dtaini_ref + interval '1 month' - interval '1 second';

      LOOP 
         V_ANOMES = TO_CHAR(v_dtaini_ref, 'YYYYMM');
         RAISE NOTICE 'AnoMes %d', v_anomes;      
         FOR R IN 
             SELECT CONTACONTABIL.ID
                  , CONTACONTABIL.CODIGO AS CONTA
                  , SALDO.VALOR          AS SALDOANTERIOR
                  , COALESCE(
                      (SELECT SUM(M.VALOR) AS ENTRADATOTAL 
                         FROM CONTACONTABILMOVIMENTO M
                        WHERE CONTACONTABIL_ID = CONTACONTABIL.ID 
                          AND M.DATAREFERENCIA BETWEEN v_dtaini_ref AND v_dtafin_ref
                          AND TIPOMOVIMENTOCONTACONTABIL_ID in (v_moventOrcamentaria, v_moventExtraOrcamentaria))
                      , 0) AS ENTRADAGRP
                  , COALESCE(
                      (SELECT SUM(M.VALOR) AS SAIDA 
                         FROM CONTACONTABILMOVIMENTO M 
                        WHERE CONTACONTABIL_ID = CONTACONTABIL.ID
                          AND M.DATAREFERENCIA BETWEEN v_dtaini_ref AND v_dtafin_ref
                          AND TIPOMOVIMENTOCONTACONTABIL_ID in (v_movbai, v_movbaiEo))
                      , 0) AS SAIDAGRP
              FROM CONTACONTABIL
              LEFT JOIN CONTACONTABILSALDO SALDO ON SALDO.CONTACONTABIL_ID = CONTACONTABIL.ID 
                    AND SALDO.DATAREFERENCIA BETWEEN v_dtaini_ant AND v_dtafin_ant
              WHERE CONTACONTABIL.DATAINATIVO IS NULL
                AND DOMINIOTIPOMATERIAL_ID = v_matperm    
              ORDER BY CONTACONTABIL.ID
         LOOP
             RAISE NOTICE 'CONTACONTABIL CODIGO: %D', R.CONTA;
             SELECT NEXTVAL('hibernate_sequence') INTO v_ccmId;
             INSERT INTO public.contacontabilsaldo
                  ( id
                  , datacriacao
                  , dataedicao
                  , version
                  , datareferencia
                  , valor
                  , contacontabil_id
                  , depreciacaoacumulada
                  , depreciacaomensal
                  , reavaliacaoperiodo
                  , reavaliacaoacumulada
                  , reducaoperiodo
                  , reducaoacumulada
                  )
             VALUES
                  ( v_ccmId
                  , LOCALTIMESTAMP
                  , LOCALTIMESTAMP
                  , 0
                  , v_dtaini_ref
                  , (R.SALDOANTERIOR+R.ENTRADAGRP)+R.SAIDAGRP
                  , R.ID
                  , 0
                  , 0
                  , 0
                  , 0
                  , 0
                  , 0
                  );
             UPDATE PUBLIC.contacontabilsaldo S
                SET depreciacaoacumulada = P.DEPRECIACAOACUMULADA, depreciacaomensal = P.DEPRECIACAOATUAL
               FROM
                  (
                    SELECT SUM(I.VALORDEPRECIACAOACUMULADAATUAL) AS DEPRECIACAOACUMULADA, SUM(I.VALORDEPRECIACAOATUAL) AS DEPRECIACAOATUAL
                    FROM   DEPRECIACAOITEM I 
                    WHERE  I.CONTACONTABIL_ID = r.id AND I.ANOMES = v_anomes
                  ) AS P
               WHERE s.id = v_ccmId;
             
               UPDATE PUBLIC.contacontabilsaldo S
                  SET reavaliacaoperiodo = P.REAVALIACAOPERIODO, reducaoperiodo = P.REDUCAOPERIODO
                 FROM
                    (
                      SELECT SUM(P.VALORREAVALIACAO) AS REAVALIACAOPERIODO, SUM(P.VALORREDUCAO) AS REDUCAOPERIODO
                      FROM   CONTACONTABILMOVPATRIMONIO P
                      INNER  JOIN CONTACONTABILMOVIMENTO M ON (M.ID = P.ID)
                      WHERE  M.CONTACONTABIL_ID = r.id AND M.DATAREFERENCIA BETWEEN v_dtaini_ref AND v_dtafin_ref
                    ) AS P
               WHERE S.id = v_ccmId;
             
               UPDATE PUBLIC.contacontabilsaldo S
                  SET reavaliacaoacumulada = P.REAVALIACAOACUMULADA, reducaoacumulada = P.REDUCAOACUMULADA
                 FROM
                    (
                      SELECT SUM(P.VALORREAVALIACAO) AS REAVALIACAOACUMULADA, SUM(P.VALORREDUCAO) AS REDUCAOACUMULADA
                      FROM   CONTACONTABILMOVPATRIMONIO P
                      INNER  JOIN CONTACONTABILMOVIMENTO M ON (M.ID = P.ID)
                      WHERE  M.CONTACONTABIL_ID = r.id AND M.DATAREFERENCIA <= v_dtafin_ref
                    ) AS P
               WHERE S.id = v_ccmId;
         END LOOP;
         
         IF DATE_TRUNC('month',v_dtaini_ref) = DATE_TRUNC('month', v_anomes_fin) THEN 
           -- Quando termina de gerar os saldos eu atribuo o ultimo no contacontabilsaldoanterior_id na tabela contacontabil (Necessario para o RMB e fechamento de mes)
           UPDATE PUBLIC.CONTACONTABIL C
              SET CONTACONTABILSALDOANTERIOR_ID = (SELECT S.ID FROM PUBLIC.CONTACONTABILSALDO S WHERE S.CONTACONTABIL_ID = C.ID ORDER BY DATAREFERENCIA DESC LIMIT 1);
           RETURN;
         END IF;
         
         v_dtaini_ref := v_dtaini_ref + interval '1 month';
         v_dtafin_ref := v_dtaini_ref + interval '1 month' - interval '1 second';
         
         v_dtaini_ant := v_dtaini_ant + interval '1 month';
         v_dtafin_ant := v_dtaini_ant + interval '1 month' - interval '1 second';
      END LOOP;
    END$$; 
-- #FIM :: GERACAO DE SALDOS COM DADOS DEPRECIACAO >> CONTACONTABILSALDO 


BEGIN;  -- #INI :: ZERA OS SALDOS DAS CONTAS COM VALOR NULO >> CONTACONTABILSALDO
    UPDATE CONTACONTABILSALDO SET VALOR=0.0
    WHERE VALOR IS NULL;
COMMIT; -- #FIM :: ZERA OS SALDOS DAS CONTAS COM VALOR NULO >> CONTACONTABILSALDO



-- #INI :: GERA SALDOS DE MATERIAIS EM ESTOQUE >> MATERIALESTOQUESALDO
	CREATE INDEX ix01_movimentoestoque_material  ON public.movimentoestoque (material_id);
	CREATE INDEX ix01_movimentoestoque_data  ON public.movimentoestoque (datamovimento);
	CREATE INDEX ix01_materialestoquesaldo_material  ON public.materialestoquesaldo (material_id);
	CREATE INDEX ix01_materialestoquesaldo_dataRef  ON public.materialestoquesaldo (datareferencia);

    DO $$
    DECLARE
      rTotaisMovimento record;
      rSaldo record;
      rMateriais record;
      v_ValorMes numeric;
      v_QuantidadeMes numeric;      
      
      v_dtaIni timestamp without time zone;
      v_dtaIniAnterior timestamp without time zone;
      v_dtaFim timestamp without time zone;
      v_anoMesAtual char(6);
      v_anoMesAnt char(6);
      v_anoMesInicioSaldos char(6);
      v_anoMesFimSaldos char(6);      
      v_organizacao bigint;
      v_localEstoque bigint;
      v_tipoFechamento bigint;
      
    BEGIN
	    v_anoMesInicioSaldos := TO_CHAR((SELECT min(DATAMOVIMENTO) FROM MOVIMENTOESTOQUE), 'YYYYMM');
	    v_anoMesFimSaldos := TO_CHAR((SELECT max(DATAMOVIMENTO) FROM MOVIMENTOESTOQUE), 'YYYYMM');

	    RAISE NOTICE 'ANOMES %', v_anoMesInicioSaldos;
	    RAISE NOTICE 'ANOMES %', v_anoMesFimSaldos;

	    v_dtaIni := TO_TIMESTAMP(v_anoMesInicioSaldos||'01','YYYYMMDD')::timestamp without time zone;	          
	    v_dtaFim := v_dtaIni + interval '1 month' - interval '1 second';	    
	    v_dtaIniAnterior := v_dtaIni - interval '1 month';
	    v_anoMesAnt := TO_CHAR(v_dtaIniAnterior, 'YYYYMM');
	    v_anoMesAtual := TO_CHAR(v_dtaIni, 'YYYYMM');
            

      LOOP            

            RAISE NOTICE 'ANOMES %', v_anoMesAtual;
            Raise notice 'ANOMES Ant %', v_anoMesAnt;

	    FOR rMateriais IN		
		select m.id as material_id, c.UNIDADEARMAZENAMENTO_ID
		from material m
		inner join materialconsumo c on (m.id = c.id)
		--where m.id = 17063667
	    LOOP

		   select
			coalesce(sum(me.quantidade), 0) as qtd,
			coalesce(sum(me.valormedia),0) as total
		   from movimentoestoque me 		   
		   where me.material_id = rMateriais.material_id and me.datamovimento between v_dtaIni and v_dtaFim INTO rTotaisMovimento;		

		  select 
		  	coalesce(s.quantidade, 0) as saldoAnt,
			coalesce(s.valorfechado, 0) as valorAnt
		  from materialestoquesaldo s
		  where s.material_id = rMateriais.material_id and s.datareferencia = v_dtaIniAnterior INTO rSaldo;

		   if ((rTotaisMovimento is not null) and (rTotaisMovimento.qtd > 0 and rTotaisMovimento.total > 0)) or ((rSaldo is not null) and (rSaldo.saldoAnt is not null or rSaldo.saldoAnt > 0) and (rSaldo.valorAnt is not null or rSaldo.valorAnt > 0)) then
			  
			   SELECT ID FROM ORGANIZACAO INTO v_organizacao;
			   SELECT ID FROM LOCALESTOQUE LIMIT 1 INTO v_localEstoque;		
			   SELECT ID FROM DOMINIO WHERE CHAVE = 'tipoFechamentoAlmoxarifado' and CODIGO = 2 into v_tipoFechamento;
			    

			    v_QuantidadeMes = coalesce(coalesce(rSaldo.saldoAnt, 0)+coalesce(rTotaisMovimento.qtd, 0), 0);
			    v_ValorMes = coalesce(coalesce(rSaldo.valorAnt, 0)+coalesce(rTotaisMovimento.total, 0), 0);

			    IF v_QuantidadeMes = 0 then

			    end if;
			   
			    INSERT INTO PUBLIC.MATERIALESTOQUESALDO
			    (
				id,
				datacriacao,
				dataedicao,
				version,
				datareferencia,
				quantidade,
				valorfechado,
				organizacao_id,
				localestoque_id,
				material_id,
				tipofechamento_id,
				unidademedidamaterial_id
			    )
			    VALUES
			    (	NEXTVAL('hibernate_sequence')
				,LOCALTIMESTAMP
				,LOCALTIMESTAMP
				,0 
				,v_dtaIni
				,v_QuantidadeMes
				,v_ValorMes
				,v_organizacao
				,v_localEstoque
				,rMateriais.material_id
				,v_tipoFechamento
				,rMateriais.UNIDADEARMAZENAMENTO_ID
			   );

			   UPDATE MOVIMENTOESTOQUE
			   SET MATERIALESTOQUESALDO_ID = (SELECT MAX(ID) FROM MATERIALESTOQUESALDO)
			   WHERE (MATERIAL_ID = rMateriais.material_id) and (DATAMOVIMENTO BETWEEN v_dtaIni and v_dtaFim);
		 End if;

          END LOOP;

          IF v_anoMesAtual = v_anoMesFimSaldos THEN
		RETURN;
          END IF;

	    v_dtaIniAnterior := v_dtaIni;
            v_dtaIni := v_dtaIni + interval '1 month';	          
	    v_dtaFim := v_dtaIni + interval '1 month' - interval '1 second';	    
	    
	    v_anoMesAnt := to_char(v_dtaIniAnterior, 'YYYYMM');
	    v_anoMesAtual := to_char(v_dtaIni, 'YYYYMM');
      END LOOP;    
	  
    END$$;
	
	--9,23 min maquina Ju para todos os materiais
-- #FIM :: GERA SALDOS DE MATERIAIS EM ESTOQUE >> MATERIALESTOQUESALDO


--===========================================================================--
-- ##FIM :: CARGAS E ATUALIZACOES DE SALDOS CONTABEIS/ESTOQUE/MOVIMENTOS     --
--===========================================================================--