--===========================================================================--
-- ##INI :: AJUSTE FINAIS DA MIGRACAO                                        --
--===========================================================================--

-- #INI :: GERACAO DE CONFIGURACAO DE CONTAS PARA O RMA/RMB >> CONTACONTABILCONFIGREFERENCIA
    /*
    SCRIPT QUE GERA A REFERENCIA DE CONTAS
    ======================================
    1. Definir v_dtaini_ref e v_dtafin_ref com o período inicial que você quer gerar a referência
    2. Definir v_anomes_ant com o mês de referência anterior ao saldo que você quer gerar 
       (os saldos já devem estar gerados para esse mês)
    3. Apos o insert definir onde você quer quer a função pare de gerar a referência,
       ou seja o ultimo mes de referencia fechado no banco
    */
    DO $$
    DECLARE
      r  RECORD;
      v_anomes_ant timestamp without time zone;
      v_dtaini_ref timestamp without time zone;
      v_dtafin_ref timestamp without time zone;
      v_anomes_fin timestamp without time zone;
      v_rma boolean;
      v_rmb boolean;
    BEGIN

      v_anomes_fin := TO_TIMESTAMP('20151101','YYYYMMDD')::timestamp without time zone;
      v_anomes_ant := TO_TIMESTAMP('20141201','YYYYMMDD')::timestamp without time zone;
      v_dtaini_ref := TO_TIMESTAMP('20150101','YYYYMMDD')::timestamp without time zone;
      v_dtafin_ref := v_dtaini_ref + interval '1 month' - interval '1 second';

      LOOP
        FOR r IN 
          SELECT C.ID, D.NOME FROM PUBLIC.CONTACONTABIL C
          INNER JOIN PUBLIC.DOMINIO D ON (D.ID = DOMINIOTIPOMATERIAL_ID) 
          ORDER BY 1
        LOOP
          
          --> A PRINCIPIO NAO APARECE NEM NO RMA NEM NO RMB
          v_rmb := FALSE;
          v_rma := FALSE;

          --> VERIFICA SE A CONTA TEM MOVIMENTO
          IF EXISTS (SELECT 'X' FROM CONTACONTABILMOVIMENTO M 
                      WHERE M.DATAREFERENCIA BETWEEN v_dtaini_ref AND v_dtafin_ref
                        AND M.CONTACONTABIL_ID = r.ID)
          THEN
            v_rmb := (r.NOME='PERMANENTE');
            v_rma := (r.NOME='CONSUMO');
          END IF;

          --> OU SE A CONTA TEM SALDO
          IF EXISTS (SELECT 'X' FROM CONTACONTABILSALDO S 
                      WHERE S.DATAREFERENCIA BETWEEN v_dtaini_ref AND v_dtafin_ref
                        AND S.CONTACONTABIL_ID = r.ID AND S.VALOR > 0.0)
          THEN
            v_rmb := (r.NOME='PERMANENTE');
            v_rma := (r.NOME='CONSUMO');
          END IF;
		  
          --> OU SE A CONTA JA APARECEU ALGUMA VEZ NO RELATORIO (RMA)
          IF EXISTS (SELECT 'X' FROM CONTACONTABILMOVIMENTO M 
                      WHERE M.DATAREFERENCIA <= v_dtafin_ref
                        AND M.CONTACONTABIL_ID = r.ID )
          THEN            
            v_rma := (r.NOME='CONSUMO');
          END IF;  		  

          --> INSERE UM REGISTRO EM CONFIGURACAO PARA CADA CONTA / MESREFERENCIA
          INSERT INTO public.contacontabilconfigreferencia
               ( ID, datacriacao, dataedicao, version, apresentarma,
                 apresentarmb, apresentaRelatorioDepreciacao, mesreferencia, contacontabil_id )
          VALUES 
               ( NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, v_rma,
                 v_rmb, v_rmb, v_dtaini_ref, r.ID );

        END LOOP;
       
        IF DATE_TRUNC('month',v_dtaini_ref) = DATE_TRUNC('month', v_anomes_fin) THEN 
          return;
        END IF;

        v_dtaini_ref := v_dtaini_ref + interval '1 month';
        v_dtafin_ref := v_dtaini_ref + interval '1 month' - interval '1 second';

      END LOOP;         
      --Maquina Ju 0,02 min
    END$$;
-- #FIM :: GERACAO DE CONFIGURACAO DE CONTAS PARA O RMA/RMB >> CONTACONTABILCONFIGREFERENCIA

--configref para o ultimo mes sem fechamento
BEGIN;  -- #INI :: AJUSTA CONFIGURACAO DE CONTAS PARA ULTIMO MESREFERENCIA >> CONTACONTABILCONFIGREFERENCIA
    INSERT INTO public.contacontabilconfigreferencia
         ( id, datacriacao, dataedicao, version, apresentarma,
           apresentarmb, apresentarelatoriodepreciacao, mesreferencia, contacontabil_id )
    SELECT NEXTVAL('hibernate_sequence'), localtimestamp, localtimestamp, 0, r.apresentarma, r.apresentarmb,
           r.apresentarmb, TO_TIMESTAMP('20151201','YYYYMMDD')::timestamp without time zone, r.contacontabil_id
    FROM CONTACONTABILCONFIGREFERENCIA R 
    WHERE R.MESREFERENCIA = (SELECT MAX(MESREFERENCIA) FROM CONTACONTABILCONFIGREFERENCIA);
COMMIT; -- #FIM :: AJUSTA CONFIGURACAO DE CONTAS PARA ULTIMO MESREFERENCIA >> CONTACONTABILCONFIGREFERENCIA

BEGIN; -- #INI :: DEFINICAO DAS CARACTERISTICAS FILTRAVEIS PARA O ICMBIO (DECIDIR QUAIS SAO AS CARACTERISTICAS FILTRAVEIS DO ICMBIO)
	/*UPDATE CARACTERISTICA SET filtro = true where ID = (SELECT ID FROM CARACTERISTICA WHERE descricao like 'DESCRICAO' AND DATABLOQUEIO IS NULL LIMIT 1);
	UPDATE CARACTERISTICA SET filtro = true where ID = (SELECT ID FROM CARACTERISTICA WHERE descricao like 'MARCA' AND DATABLOQUEIO IS NULL LIMIT 1);
	UPDATE CARACTERISTICA SET filtro = true where ID = (SELECT ID FROM CARACTERISTICA WHERE descricao like 'MODELO'AND DATABLOQUEIO IS NULL LIMIT 1);
	UPDATE CARACTERISTICA SET filtro = true where ID = (SELECT ID FROM CARACTERISTICA WHERE descricao like 'SERIE' AND DATABLOQUEIO IS NULL LIMIT 1);
	UPDATE CARACTERISTICA SET filtro = true where ID = (SELECT ID FROM CARACTERISTICA WHERE descricao like 'PLACA' AND DATABLOQUEIO IS NULL LIMIT 1);
	UPDATE CARACTERISTICA SET filtro = true where ID = (SELECT ID FROM CARACTERISTICA WHERE descricao like 'RENAVAM' AND DATABLOQUEIO IS NULL LIMIT 1);
	UPDATE CARACTERISTICA SET filtro = true where ID = (SELECT ID FROM CARACTERISTICA WHERE descricao like 'TÍTULO' AND DATABLOQUEIO IS NULL LIMIT 1);
	UPDATE CARACTERISTICA SET filtro = true where ID = (SELECT ID FROM CARACTERISTICA WHERE descricao like 'AUTOR' AND DATABLOQUEIO IS NULL LIMIT 1);*/
COMMIT; -- #FIM :: DEFINICAO DAS CARACTERISTICAS FILTRAVEIS PARA O MPOG (FUTURAMENTE O USUARIO PODERA ESCOLHER MAIS CARACTERISTICAS NO SOFTWARE)

BEGIN; -- GARANTINDO QUE AS CONTAS SEM SALDO ANTERIOR, TENHAM UM SALDO ZERADO
	insert into CONTACONTABILSALDO (ID, datacriacao, dataedicao, version, datareferencia, valor, contacontabil_id, depreciacaoacumulada, depreciacaomensal,
							   reavaliacaoperiodo, reavaliacaoacumulada, reducaoperiodo, reducaoacumulada)
	SELECT NEXTVAL('hibernate_sequence'), '2015-09-01 00:00:00.000', '2015-09-01 00:00:00.000', 0, '2015-09-01 00:00:00.000', 0, id, 0, 0, 0, 0, 0, 0 from CONTACONTABIL
	where CONTACONTABILSALDOANTERIOR_ID is null;

	-- Referenciar um conta contabil ha um registro do conta contabil
	UPDATE PUBLIC.CONTACONTABIL C SET CONTACONTABILSALDOANTERIOR_ID = (SELECT S.ID FROM PUBLIC.CONTACONTABILSALDO S WHERE S.CONTACONTABIL_ID = C.ID ORDER BY DATAREFERENCIA DESC LIMIT 1);

COMMIT;

--Arrumando o codigo da conta para tirar o caracteres especiais
 update public.contacontabil set codigo = regexp_replace(codigo ,'[^0-9]+','');

--===========================================================================--
-- ##FIM :: AJUSTE FINAIS DA MIGRACAO                                        --
--===========================================================================--