--===========================================================================--
-- ##INI :: IMPORTACAO TABELAS DE APOIO AO NEGOCIO                           --
--===========================================================================--
SET NOCOUNT ON


-- #INI :: INICIALIZA AS TABELAS, SE FOR O CASO
    /* 
    BEGIN TRANSACTION
    GO
    
    DELETE FROM dbo.funcao;
    DELETE FROM dbo.endereco;
    DELETE FROM dbo.contato;
    DELETE FROM dbo.classificacaomaterial;
    DELETE FROM dbo.material;
    DELETE FROM dbo.materialcaracteristica;
    DELETE FROM dbo.materialconsumo;
    DELETE FROM dbo.matconsumotipounidadeentrada;
    DELETE FROM dbo.materialimagem;
    DELETE FROM dbo.materialpermanente;
    DELETE FROM dbo.materialpermanenteconsumo;
    DELETE FROM dbo.parceiro_colaborador;
    DELETE FROM dbo.parceiro_portador;  
    DELETE FROM dbo.fornecedor;
    DELETE FROM dbo.orgaoexterno;
    DELETE FROM dbo.parceiro;
    DELETE FROM dbo.telefone;
    DELETE FROM dbo.pessoajuridica;
    DELETE FROM dbo.pessoafisica;
    DELETE FROM dbo.pessoa;
    DELETE FROM dbo.estruturaorganizacionalresp;
    DELETE FROM dbo.comissao;
    DELETE FROM dbo.comissaointegrante;
    DELETE FROM dbo.caracteristica;
    DELETE FROM dbo.dominio where chave like 'tipoCaract%';
    DELETE FROM dbo.seguranca_usuario;
    DELETE FROM dbo.seguranca_privilegio;
    DELETE FROM dbo.seguranca_usuario_privilegio;

    COMMIT
    */
-- #FIM :: INICIALIZA AS TABELAS, SE FOR O CASO
GO


-- #INI :: IMPORTACAO DAS FUNCOES >> FUNCAO
    BEGIN TRANSACTION
    GO
    
    INSERT INTO dbo.funcao
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , nome
         , inativador_id
         , autor_id
         , editor_id
         , organizacao_id
         )
    SELECT NULL                AS databloqueio
         , NULL                AS datainativo
         , GETDATE()           AS datacriacao
         , GETDATE()           AS dataedicao
         , 0                   AS "version"
         , F.CD_TP_FUNCAO_HIER AS CODIGO
         , F.NM_TP_FUNCAO_HIER AS nome
         , NULL                AS inativador_id
         , NULL                AS autor_id
         , NULL                AS editor_id
         , 1                   AS organizacao_id
    FROM ASI_HOMOLOGA..CR_TP_FUNCAO_HIER F
    ORDER BY F.CD_TP_FUNCAO_HIER;

    -- TOTALIZADORES
    PRINT 'IMPORTACAO DAS FUNCOES >> FUNCAO';
    DECLARE @count_asi bigint = (SELECT COUNT(*) FROM ASI_HOMOLOGA..CR_TP_FUNCAO_HIER);
    DECLARE @count_grp bigint = (SELECT COUNT(*) FROM DBO.FUNCAO);
    PRINT 'Total de registros do ASI ' + CAST(@count_asi AS NVARCHAR)
    PRINT 'Total de registros no GRP ' + CAST(@count_grp AS NVARCHAR)
    PRINT ' ';
    
    COMMIT
-- #FIM :: IMPORTACAO DAS FUNCOES >> FUNCAO
GO


-- #INI :: IMPORTACAO DOS AGENTES >> PESSOAS
    BEGIN TRANSACTION
    GO
    
    PRINT '--> PESSOAS :: TIPO DE AGENTE :: INDIFERENTE >> PESSOA'
    INSERT INTO dbo.pessoa
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , email
         , nome
         , inativador_id
         , autor_id
         , editor_id
         , organizacao_id
         , dominio_pessoa
         , agente_id
         )
    SELECT NULL                    AS databloqueio
         , NULL                    AS datainativo
         , COALESCE(A.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()               AS dataedicao
         , 0                       AS "version"
         , A.CD_AGENTE             AS codigo
         , CASE WHEN CHARINDEX('@',A.NM_EMAIL,1) > 0 
             THEN A.NM_EMAIL 
             ELSE ' '
           END                     AS email
         , A.NM_AGENTE             AS nome
         , NULL                    AS inativador_id
         , NULL                    AS autor_id
         , NULL                    AS editor_id
         , 1                       AS organizacao_id
         , CASE 
             WHEN A.CD_TP_SIT_JURIDICA = '1' THEN -- PESSOA JURIDICA
               (SELECT ID FROM DBO.DOMINIO WHERE CHAVE = 'tipoPessoa' AND CODIGO = 2) 
             WHEN A.CD_TP_SIT_JURIDICA = '2' THEN -- PESSOA FISICA
               (SELECT ID FROM DBO.DOMINIO WHERE CHAVE = 'tipoPessoa' AND CODIGO = 1)
           END                     AS dominio_pessoa
         , A.CD_AGENTE             AS agente_id -- PARA FACILITAR VINCULAR PARCEIROS
    FROM ASI_HOMOLOGA..CR_AGENTE A
    ORDER BY A.ID_AGENTE;

    PRINT '--> PESSOAS :: NÃO AGENTES :: FUNCIONARIOS >> PESSOA'
    INSERT INTO dbo.pessoa
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , email
         , nome
         , inativador_id
         , autor_id
         , editor_id
         , organizacao_id
         , dominio_pessoa
         , agente_id
         )
    SELECT F.DT_BLOQUEIO           AS databloqueio
         , NULL                    AS datainativo
         , COALESCE(F.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()               AS dataedicao
         , 0                       AS "version"
         , F.CD_FUNCIONARIO        AS codigo
         , CASE WHEN CHARINDEX('@',F.NM_EMAIL,1) > 0 
             THEN F.NM_EMAIL 
             ELSE ' '
           END                     AS email
         , F.NM_FUNCIONARIO        AS nome
         , NULL                    AS inativador_id
         , NULL                    AS autor_id
         , NULL                    AS editor_id
         , 1                       AS orgao_id
         , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoPessoa' AND CODIGO=1) AS dominio_pessoa -- PESSOA FISICA
         , F.CD_FUNCIONARIO        AS agente_id -- PARA FACILITAR VINCULAR PARCEIROS
    FROM ASI_HOMOLOGA..CR_FUNCIONARIO F
    ORDER BY F.CD_FUNCIONARIO;

    PRINT '--> PESSOAS :: FISICAS :: NÃO AGENTES :: FUNCIONARIOS >> PESSOAFISICA'
    INSERT INTO dbo.pessoafisica 
         ( databloqueio
         , datainativo
         , cpf
         , datanascimento
         , nomemae
         , nomepai
         , numeropassaporte
         , rg
         , tituloeleitor
         , pessoa_id
         , inativador_id
         , dominio_estado_civil
         , dominio_sexo
         )
    SELECT F.DT_BLOQUEIO           AS databloqueio
         , NULL                    AS datainativo
         , REPLACE(
             REPLACE(
               F.NR_CPF,'.',''     -- RETIRA PONTOS
             ),'-',''              -- RETIRA TRAÇO
           )                       AS cpf
         , CONVERT(DATETIME,'1900-01-01',102) AS datanascimento
         , NULL                    AS nomemae
         , NULL                    AS nomepai
         , NULL                    AS numeropassaporte
         , F.NR_RG                 AS rg
         , NULL                    AS tituloeleitor
         , PES.ID                  AS pessoa_id
         , NULL                    AS inativador_id
         , NULL                    AS dominio_estado_civil
         , NULL                    AS dominio_sexo
    FROM ASI_HOMOLOGA..CR_FUNCIONARIO F
    INNER JOIN DBO.PESSOA PES ON (PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI =F.CD_FUNCIONARIO AND PES.DOMINIO_PESSOA = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoPessoa' AND CODIGO=1))
    ORDER BY F.CD_FUNCIONARIO;

    --> ENDERECOS DE PESSOAS :: NÃO AGENTES :: FUNCIONARIOS
    --  ASI_HOMOLOGA..CR_FUNCIONARIO NAO TEM ENDERECOS

    --> CONTATOS DE PESSOAS :: NÃO AGENTES :: FUNCIONARIOS
    --  ASI_HOMOLOGA..CR_FUNCIONARIO NAO TEM VINCULO COM CR_CONTATOS

    PRINT '--> VINCULO DE PARCEIRO :: PESSOAS NÃO AGENTES :: FUNCIONARIOS >> PARCEIRO'
    INSERT INTO dbo.parceiro 
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , inativador_id
         , autor_id
         , editor_id
         , classeparceiro_id
         , pessoa_id
         , agente_id
         )
    SELECT F.DT_BLOQUEIO           AS databloqueio
         , NULL                    AS datainativo
         , COALESCE(F.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()               AS dataedicao
         , 0                       AS "version"
         , F.CD_FUNCIONARIO        AS codigo
         , NULL                    AS inativador_id
         , NULL                    AS autor_id
         , NULL                    AS editor_id
         , (SELECT ID FROM DBO.CLASSEPARCEIRO WHERE DOMINIOTIPOPARCEIRO_ID = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoParceiro' AND CODIGO=1)) AS classeparceiro_id -- 1 COLABORADOR, 2 - ORGÃO EXTERNO, 3 - PORTADOR, 4 - FORNECEDOR
         , PES.ID                  AS pessoa_id
         , F.CD_FUNCIONARIO        AS agente_id
    FROM ASI_HOMOLOGA..CR_FUNCIONARIO F
    INNER JOIN DBO.PESSOA PES ON (PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_FUNCIONARIO AND PES.DOMINIO_PESSOA = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoPessoa' AND CODIGO=1))
    ORDER BY F.CD_FUNCIONARIO;

    PRINT '--> DADOS DE PARCEIRO :: PESSOAS NÃO AGENTES :: FUNCIONARIOS >> PARCEIRO_COLABORADOR'
    INSERT INTO dbo.parceiro_colaborador
         ( id
         , cargo
         , matricula
         , estruturaorganizacional_id
         , funcao_id
         )
    SELECT P.ID                     AS id
         , F.NM_CARGO               AS cargo
         , F.CD_FUNCIONARIO         AS matricula
         , COALESCE(E.ID,(SELECT TOP 1 ID FROM DBO.ESTRUTURAORGANIZACIONAL WHERE TIPOESTRUTURAORGANIZACIONAL_ID = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoEstruturaOrganizacional' AND CODIGO=1))) AS estruturaorganizacional_id
         , (SELECT COALESCE(ID,1) FROM DBO.FUNCAO WHERE NOME COLLATE SQL_Latin1_General_CP1_CI_AI= F.NM_FUNCAO) AS funcao_id
    FROM ASI_HOMOLOGA..CR_FUNCIONARIO F
    INNER JOIN DBO.PARCEIRO P ON P.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_FUNCIONARIO
     LEFT JOIN DBO.ESTRUTURAORGANIZACIONAL E ON E.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_UA
    ORDER BY F.CD_FUNCIONARIO;

    --> TELEFONES :: PESSOAS :: NÃO AGENTES :: FUNCIONARIOS
    --  ASI_HOMOLOGA..CR_FUNCIONARIO NAO TEM NUMEROS DE TELEFONES

    PRINT '--> PESSOAS :: FISICAS :: TIPO DE AGENTE :: PORTADOR >> PESSOAFISICA'
    INSERT INTO dbo.pessoafisica 
         ( databloqueio
         , datainativo
         , cpf
         , datanascimento
         , nomemae
         , nomepai
         , numeropassaporte
         , rg
         , tituloeleitor
         , pessoa_id
         , inativador_id
         , dominio_estado_civil
         , dominio_sexo
         )
    SELECT A.DT_BLOQUEIO           AS databloqueio
         , NULL                    AS datainativo
         , REPLACE(
             REPLACE(
               A.NR_IDENT_AGENTE,'.',''-- RETIRA PONTOS
             ),'-',''                  -- RETIRA TRAÇO
           )                       AS cpf
         , CONVERT(DATETIME,'1900-01-01',102) AS datanascimento
         , NULL                    AS nomemae
         , NULL                    AS nomepai
         , P.NR_PASSAPORTE         AS numeropassaporte
         , P.NR_RG                 AS rg
         , NULL                    AS tituloeleitor
         , PES.ID                  AS pessoa_id
         , NULL                    AS inativador_id
         , NULL                    AS dominio_estado_civil
         , NULL                    AS dominio_sexo
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..BP_PORTADOR P ON P.CD_AGENTE COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '6'         -- "6";"PORTADOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> ENDERECOS :: PESSOAS FISICAS :: TIPO DE AGENTE :: PORTADOR >> ENDERECO'
    INSERT INTO dbo.endereco
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , cep
         , codigo
         , complemento
         , latitude
         , logradouro
         , longitude
         , nome
         , numero
         , inativador_id
         , autor_id
         , editor_id
         , bairro_id
         , cidade_id
         , dominiotipoendereco_id
         , pessoa_id
         )
    SELECT A.DT_BLOQUEIO                     AS databloqueio
         , NULL                              AS datainativo
         , COALESCE(A.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()                         AS dataedicao
         , 0                                 AS "version"
         , REPLACE(
             REPLACE(
               A.NR_CEP,'.',''     -- RETIRA PONTOS
             ),'-',''              -- RETIRA TRAÇO
           )                                 AS cep
         , A.CD_AGENTE                       AS codigo
         , NULL                              AS complemento
         , NULL                              AS latitude
         , A.ED_AGENTE                       AS logradouro
         , NULL                              AS longitude
         , NULL                              AS nome
         , NULL                              AS numero
         , NULL                              AS inativador_id
         , NULL                              AS autor_id
         , NULL                              AS editor_id
         , 1                                 AS bairro_id
         --, DBO.GETIDBAIRRO(A.NM_BAIRRO, A.CD_CIDADE, A.CD_AGENTE, A.DT_BLOQUEIO, A.DT_CADASTRO) AS bairro_id
         , (SELECT ID FROM DBO.CIDADE  WHERE CODIGO=A.CD_CIDADE COLLATE SQL_Latin1_General_CP1_CI_AI) AS cidade_id
         , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoEndereco' AND CODIGO=1) AS dominiotipoendereco_id
         , PES.ID                            AS pessoa_id
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..BP_PORTADOR P ON P.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '6'         -- "6";"PORTADOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> CONTATOS :: PESSOAS FISICAS :: TIPO DE AGENTE :: PORTADOR >> CONTATO'
    INSERT INTO dbo.contato
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , cargo
         , cpf
         , email
         , nome
         , ordem
         , representantelegal
         , telefone
         , inativador_id
         , autor_id
         , editor_id
         , pessoa_id
         )
    SELECT C.DT_BLOQUEIO                     AS databloqueio
         , NULL                              AS datainativo
         , COALESCE(C.DT_VALIDACAO,GETDATE()) AS datacriacao
         , GETDATE()                         AS dataedicao
         , 0                                 AS "version"
         , C.NM_CARGO                        AS cargo
         , REPLACE(
             REPLACE(
               C.NR_CPF,'.',''               -- RETIRA PONTOS
             ),'-',''                        -- RETIRA TRAÇO
           )                                 AS cpf
         , C.NM_EMAIL                        AS email
         , C.NM_CONTATO                      AS nome
         , C.SQ_CONTATO                      AS ordem
         , CASE WHEN C.IN_RESPONSAVEL = 'S'
             THEN 1
             ELSE 0
           END                               AS representantelegal
         , CONCAT(C.NR_DDD,' ',C.NR_FONE)    AS telefone
         , NULL                              AS inativador_id
         , NULL                              AS autor_id
         , NULL                              AS editor_id
         , PES.ID                            AS pessoa_id
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_CONTATO C ON C.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '6'         -- "6";"PORTADOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> VINCULO PARCEIRO :: PESSOAS FISICAS :: TIPO DE AGENTE :: PORTADOR >> PARCEIRO'
    INSERT INTO dbo.parceiro 
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , inativador_id
         , autor_id
         , editor_id
         , classeparceiro_id
         , pessoa_id
         , agente_id
         )
    SELECT A.DT_BLOQUEIO           AS databloqueio
         , NULL                    AS datainativo
         , COALESCE(A.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()               AS dataedicao
         , 0                       AS "version"
         , A.CD_AGENTE             AS codigo
         , NULL                    AS inativador_id
         , NULL                    AS autor_id
         , NULL                    AS editor_id
         , (SELECT ID FROM CLASSEPARCEIRO WHERE DOMINIOTIPOPARCEIRO_ID = (SELECT ID FROM DOMINIO WHERE CHAVE='tipoParceiro' AND CODIGO=3))  AS classeparceiro_id -- 1 COLABORADOR, 2 - ORGÃO EXTERNO, 3 - PORTADOR, 4 - FORNECEDOR
         , PES.ID                  AS pessoa_id
         , A.CD_AGENTE             AS agente_id  -- PARA FACILITAR VINCULAR PARCEIROS
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '6'         -- "6";"PORTADOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> DADOS DO PARCEIRO :: PESSOAS FISICAS :: TIPO DE AGENTE :: PORTADOR >> PARCEIRO_PORTADOR'
    INSERT INTO dbo.parceiro_portador
         (
           id
         )
    SELECT PAR.ID AS id
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN DBO.PARCEIRO PAR ON PAR.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '6'         -- "6";"PORTADOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> PESSOAS :: FISICAS :: TIPO DE AGENTE :: FORNECEDOR >> PESSOAFISICA'
    INSERT INTO dbo.pessoafisica 
         ( databloqueio
         , datainativo
         , cpf
         , datanascimento
         , nomemae
         , nomepai
         , numeropassaporte
         , rg
         , tituloeleitor
         , pessoa_id
         , inativador_id
         , dominio_estado_civil
         , dominio_sexo
         )
    SELECT A.DT_BLOQUEIO           AS databloqueio
         , NULL                    AS datainativo
         , REPLACE(
             REPLACE(
               A.NR_IDENT_AGENTE,'.',''-- RETIRA PONTOS
             ),'-',''                  -- RETIRA TRAÇO
           )                       AS cpf
         , CONVERT(DATETIME,'1900-01-01',102) AS datanascimento
         , NULL                    AS nomemae
         , NULL                    AS nomepai
         , NULL                    AS numeropassaporte
         , F.NR_RG                 AS rg
         , NULL                    AS tituloeleitor
         , PES.ID                  AS pessoa_id
         , NULL                    AS inativador_id
         , NULL                    AS dominio_estado_civil
         , NULL                    AS dominio_sexo
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_FORNECEDOR F ON F.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR" 
    ORDER BY A.ID_AGENTE;

    PRINT '--> ENDERECOS :: PESSOAS FISICAS :: TIPO DE AGENTE :: FORNECEDOR >> ENDERECO'
    INSERT INTO dbo.endereco
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , cep
         , codigo
         , complemento
         , latitude
         , logradouro
         , longitude
         , nome
         , numero
         , inativador_id
         , autor_id
         , editor_id
         , bairro_id
         , cidade_id
         , dominiotipoendereco_id
         , pessoa_id
         )
    SELECT A.DT_BLOQUEIO                     AS databloqueio
         , NULL                              AS datainativo
         , COALESCE(A.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()                         AS dataedicao
         , 0                                 AS "version"
         , REPLACE(
             REPLACE(
               A.NR_CEP,'.',''     -- RETIRA PONTOS
             ),'-',''              -- RETIRA TRAÇO
           )                                 AS cep
         , A.CD_AGENTE                       AS codigo
         , NULL                              AS complemento
         , NULL                              AS latitude
         , A.ED_AGENTE                       AS logradouro
         , NULL                              AS longitude
         , NULL                              AS nome
         , NULL                              AS numero
         , NULL                              AS inativador_id
         , NULL                              AS autor_id
         , NULL                              AS editor_id
         , 1                                 AS bairro_id
         --, DBO.GETIDBAIRRO(A.NM_BAIRRO, A.CD_CIDADE, A.CD_AGENTE, A.DT_BLOQUEIO, A.DT_CADASTRO) AS bairro_id
         , (SELECT ID FROM DBO.CIDADE WHERE CODIGO=A.CD_CIDADE COLLATE SQL_Latin1_General_CP1_CI_AI) AS cidade_id
         , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoEndereco' AND CODIGO=2) AS dominiotipoendereco_id
         , PES.ID                            AS pessoa_id
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_FORNECEDOR F ON F.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR" 
    ORDER BY A.ID_AGENTE;

    PRINT '--> CONTATOS :: PESSOAS FISICAS :: TIPO DE AGENTE :: FORNECEDOR >> CONTATO'
    INSERT INTO dbo.contato
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , cargo
         , cpf
         , email
         , nome
         , ordem
         , representantelegal
         , telefone
         , inativador_id
         , autor_id
         , editor_id
         , pessoa_id
         )
    SELECT C.DT_BLOQUEIO                     AS databloqueio
         , NULL                              AS datainativo
         , COALESCE(C.DT_VALIDACAO, GETDATE()) AS datacriacao
         , GETDATE()                         AS dataedicao
         , 0                                 AS "version"
         , C.NM_CARGO                        AS cargo
         , REPLACE(
             REPLACE(
               C.NR_CPF,'.',''     -- RETIRA PONTOS
             ),'-',''              -- RETIRA TRAÇO
           )                                 AS cpf
         , C.NM_EMAIL                        AS email
         , C.NM_CONTATO                      AS nome
         , C.SQ_CONTATO                      AS ordem
         , CASE WHEN C.IN_RESPONSAVEL = 'S'
             THEN 1
             ELSE 0
           END                               AS representantelegal
         , CONCAT(C.NR_DDD,' ',C.NR_FONE)    AS telefone
         , NULL                              AS inativador_id
         , NULL                              AS autor_id
         , NULL                              AS editor_id
         , PES.ID                            AS pessoa_id    
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_CONTATO C ON C.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR" 
    ORDER BY A.ID_AGENTE;

    PRINT '--> VINCULO PARCEIRO :: PESSOAS FISICAS :: TIPO DE AGENTE :: FORNECEDOR >> PARCEIRO'
    INSERT INTO dbo.parceiro 
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , inativador_id
         , autor_id
         , editor_id
         , classeparceiro_id
         , pessoa_id
         , agente_id
         )
    SELECT A.DT_BLOQUEIO           AS databloqueio
         , NULL                    AS datainativo
         , COALESCE(A.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()               AS dataedicao
         , 0                       AS "version"
         , A.CD_AGENTE             AS codigo
         , NULL                    AS inativador_id
         , NULL                    AS autor_id
         , NULL                    AS editor_id
         , (SELECT ID FROM CLASSEPARCEIRO WHERE DOMINIOTIPOPARCEIRO_ID = (SELECT ID FROM DOMINIO WHERE CHAVE='tipoParceiro' AND CODIGO=4)) AS classeparceiro_id -- 1 COLABORADOR, 2 - ORGÃO EXTERNO, 3 - PORTADOR, 4 - FORNECEDOR
         , PES.ID                  AS pessoa_id
         , A.CD_AGENTE             AS agente_id -- PARA FACILITAR VINCULAR PARCEIROS
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> DADOS DO PARCEIRO :: PESSOAS FISICAS :: TIPO DE AGENTE :: FORNECEDOR >> FORNECEDOR'
    INSERT INTO dbo.fornecedor
         ( id
         , compraseletronicas
         , estrangeiro
         )
    SELECT PAR.ID      AS id
         , CASE WHEN F.IN_COMPRA_ELETRONICA = 'S' 
            THEN 1
            ELSE 0
           END         AS compraseletronicas
         , 0           AS estrangeiro
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_FORNECEDOR F ON F.CD_AGENTE COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    INNER JOIN DBO.PARCEIRO PAR ON PAR.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '2' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> PESSOAS :: JURIDICAS :: TIPO DE AGENTE :: ORGAO EXTERNO >> PESSOAJURIDICA'
    INSERT INTO dbo.pessoajuridica
         ( databloqueio
         , datainativo
         , cnpj
         , filantropico
         , filial
         , impostosimples
         , inscricaoestadual
         , inscricaomunicipal
         , nomefantasia
         , razaosocial
         , site
         , pessoa_id
         , inativador_id
         , dominio_abrangencia
         , dominio_porte
         )
    SELECT A.DT_BLOQUEIO                 AS databloqueio
         , NULL                          AS datainativo
         , REPLACE(
             REPLACE(
               REPLACE(
                 A.NR_IDENT_AGENTE,'.',''-- RETIRA PONTOS
               ),'/',''                  -- RETIRA BARRAS
             ),'-',''                    -- RETIRA TRAÇO
           )                             AS cnpj
         , 0                             AS filantropico
         , 0                             AS filial
         , 0                             AS impostosimples
         , NULL                          AS inscricaoestadual
         , NULL                          AS inscricaomunicipal
         , O.SG_ORGAO_EXTERNO            AS nomefantasia
         , A.NM_AGENTE                   AS razaosocial
         , CASE WHEN CHARINDEX('www.',LOWER(A.NM_EMAIL),1) > 0 
             THEN A.NM_EMAIL 
             ELSE ' '
           END                           AS site
         , PES.ID                        AS pessoa_id
         , NULL                          AS inativador_id
         , NULL                          AS dominio_abrangencia
         , NULL                          AS dominio_porte
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_ORGAO_EXTERNO O ON O.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '4'         -- "4";"ORGAO EXTERNO"
    ORDER BY A.ID_AGENTE;

    PRINT '--> ENDERECOS :: PESSOAS JURIDICAS :: TIPO DE AGENTE :: ORGAO EXTERNO >> ENDERECO'
    INSERT INTO dbo.endereco
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , cep
         , codigo
         , complemento
         , latitude
         , logradouro
         , longitude
         , nome
         , numero
         , inativador_id
         , autor_id
         , editor_id
         , bairro_id
         , cidade_id
         , dominiotipoendereco_id
         , pessoa_id
         )
    SELECT A.DT_BLOQUEIO                     AS databloqueio
         , NULL                              AS datainativo
         , COALESCE(A.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()                         AS dataedicao
         , 0                                 AS "version"
         , REPLACE(
             REPLACE(
               A.NR_CEP,'.',''     -- RETIRA PONTOS
             ),'-',''              -- RETIRA TRAÇO
           )                                 AS cep
         , A.CD_AGENTE                       AS codigo
         , NULL                              AS complemento
         , NULL                              AS latitude
         , A.ED_AGENTE                       AS logradouro
         , NULL                              AS longitude
         , NULL                              AS nome
         , NULL                              AS numero
         , NULL                              AS inativador_id
         , NULL                              AS autor_id
         , NULL                              AS editor_id
         , 1                                 AS bairro_id
         --, DBO.GETIDBAIRRO(A.NM_BAIRRO, A.CD_CIDADE, A.CD_AGENTE, A.DT_BLOQUEIO, A.DT_CADASTRO) AS bairro_id
         , (SELECT ID FROM DBO.CIDADE WHERE CODIGO=A.CD_CIDADE COLLATE SQL_Latin1_General_CP1_CI_AI) AS cidade_id
         , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoEndereco' AND CODIGO=2) AS dominiotipoendereco_id
         , PES.ID                            AS pessoa_id
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_ORGAO_EXTERNO O ON O.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '4'         -- "4";"ORGAO EXTERNO"
    ORDER BY A.ID_AGENTE;

    PRINT '--> CONTATOS :: PESSOAS JURIDICAS :: TIPO DE AGENTE :: ORGAO EXTERNO >> CONTATO'
    INSERT INTO dbo.contato
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , cargo
         , cpf
         , email
         , nome
         , ordem
         , representantelegal
         , telefone
         , inativador_id
         , autor_id
         , editor_id
         , pessoa_id
         )
    SELECT C.DT_BLOQUEIO                     AS databloqueio
         , NULL                              AS datainativo
         , COALESCE(C.DT_VALIDACAO,GETDATE()) AS datacriacao
         , GETDATE()                         AS dataedicao
         , 0                                 AS "version"
         , C.NM_CARGO                        AS cargo
         , REPLACE(
             REPLACE(
               C.NR_CPF,'.',''     -- RETIRA PONTOS
             ),'-',''              -- RETIRA TRAÇO
           )                                 AS cpf
         , C.NM_EMAIL                        AS email
         , C.NM_CONTATO                      AS nome
         , C.SQ_CONTATO                      AS ordem
         , CASE WHEN C.IN_RESPONSAVEL = 'S'
             THEN 1
             ELSE 0
           END                               AS representantelegal
         , CONCAT(C.NR_DDD,' ',C.NR_FONE)    AS telefone
         , NULL                              AS inativador_id
         , NULL                              AS autor_id
         , NULL                              AS editor_id
         , PES.ID                            AS pessoa_id    
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_CONTATO C ON C.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '4'         -- "4";"ORGAO EXTERNO" 
    ORDER BY A.ID_AGENTE;

    PRINT '--> VINCULO PARCEIRO :: PESSOAS JURIDICAS :: TIPO DE AGENTE :: ORGAO EXTERNO >> PARCEIRO'
    INSERT INTO dbo.parceiro 
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , inativador_id
         , autor_id
         , editor_id
         , classeparceiro_id
         , pessoa_id
         , agente_id
         )
    SELECT A.DT_BLOQUEIO           AS databloqueio
         , NULL                    AS datainativo
         , COALESCE(A.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()               AS dataedicao
         , 0                       AS "version"
         , A.CD_AGENTE             AS codigo
         , NULL                    AS inativador_id
         , NULL                    AS autor_id
         , NULL                    AS editor_id
         , (SELECT ID FROM CLASSEPARCEIRO WHERE DOMINIOTIPOPARCEIRO_ID = (SELECT ID FROM DOMINIO WHERE CHAVE='tipoParceiro' AND CODIGO=2))  AS classeparceiro_id -- 1 COLABORADOR, 2 - ORGÃO EXTERNO, 3 - PORTADOR, 4 - FORNECEDOR
         , PES.ID                  AS pessoa_id
         , A.CD_AGENTE             AS agente_id
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '4'         -- "4";"ORGAO EXTERNO"
    ORDER BY A.ID_AGENTE;

    PRINT '--> DADOS DO PARCEIRO :: PESSOAS JURIDICAS :: TIPO DE AGENTE :: ORGAO EXTERNO >> ORGAOEXTERNO'
    INSERT INTO dbo.orgaoexterno
         ( id
         , sigla
         )
    SELECT PAR.ID             AS id
         , O.SG_ORGAO_EXTERNO AS sigla
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_ORGAO_EXTERNO O ON O.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PARCEIRO PAR ON PAR.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '4'         -- "4";"ORGAO EXTERNO" 
    ORDER BY A.ID_AGENTE;

    PRINT '--> PESSOAS :: JURIDICAS :: TIPO DE AGENTE :: FORNECEDOR >> PESSOAJURIDICAS'
    INSERT INTO dbo.pessoajuridica
         ( databloqueio
         , datainativo
         , cnpj
         , filantropico
         , filial
         , impostosimples
         , inscricaoestadual
         , inscricaomunicipal
         , nomefantasia
         , razaosocial
         , site
         , pessoa_id
         , inativador_id
         , dominio_abrangencia
         , dominio_porte
         )
    SELECT A.DT_BLOQUEIO                 AS databloqueio
         , NULL                          AS datainativo
         , REPLACE(
             REPLACE(
               REPLACE(
                 A.NR_IDENT_AGENTE,'.',''-- RETIRA PONTOS
               ),'/',''                  -- RETIRA BARRAS
             ),'-',''                    -- RETIRA TRAÇO
           )                             AS cnpj
         , CASE
             WHEN F.IN_FILANTROPICO = 'S'
               THEN 1
               ELSE 0
           END                           AS filantropico
         , 0                             AS filial
         , CASE
             WHEN F.IN_IMPOSTO_SIMPLES = 'S'
               THEN 1
               ELSE 0
           END                           AS impostosimples
         , F.NR_INSC_ESTAD               AS inscricaoestadual
         , F.NR_INSC_MUNICIPAL           AS inscricaomunicipal
         , F.NM_RAZAO_SOCIAL             AS nomefantasia
         , F.NM_RAZAO_SOCIAL             AS razaosocial
         , COALESCE(
             F.DS_URL,
             CASE WHEN CHARINDEX('www.',LOWER(A.NM_EMAIL),1) > 0 
               THEN A.NM_EMAIL 
               ELSE ' '
             END)                        AS site
         , PES.ID                        AS pessoa_id
         , NULL                          AS inativador_id
         , (SELECT ID_GRP FROM DBO.DOMINIO_ASI_GRP WHERE TP_GRP='tipoAbrangencia' AND CD_ASI COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_TP_FOR_ABRANG) AS dominio_abrangencia
         , (SELECT ID_GRP FROM DBO.DOMINIO_ASI_GRP WHERE TP_GRP='tipoPorte' AND CD_ASI COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_TP_FOR_PORTE) AS dominio_porte
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_FORNECEDOR F ON F.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> ENDERECOS :: PESSOAS JURIDICAS :: TIPO DE AGENTE :: FORNECEDOR >> ENDERECO'
    INSERT INTO dbo.endereco
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , cep
         , codigo
         , complemento
         , latitude
         , logradouro
         , longitude
         , nome
         , numero
         , inativador_id
         , autor_id
         , editor_id
         , bairro_id
         , cidade_id
         , dominiotipoendereco_id
         , pessoa_id
         )
    SELECT A.DT_BLOQUEIO                     AS databloqueio
         , NULL                              AS datainativo
         , COALESCE(A.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()                         AS dataedicao
         , 0                                 AS "version"
         , REPLACE(
             REPLACE(
               A.NR_CEP,'.',''     -- RETIRA PONTOS
             ),'-',''              -- RETIRA TRAÇO
           )                                 AS cep
         , A.CD_AGENTE                       AS codigo
         , NULL                              AS complemento
         , NULL                              AS latitude
         , A.ED_AGENTE                       AS logradouro
         , NULL                              AS longitude
         , NULL                              AS nome
         , NULL                              AS numero
         , NULL                              AS inativador_id
         , NULL                              AS autor_id
         , NULL                              AS editor_id
         , 1                                 AS bairro_id
         --, DBO.GETIDBAIRRO(A.NM_BAIRRO, A.CD_CIDADE, A.CD_AGENTE, A.DT_BLOQUEIO, A.DT_CADASTRO) AS bairro_id
         , (SELECT ID FROM DBO.CIDADE WHERE CODIGO=A.CD_CIDADE COLLATE SQL_Latin1_General_CP1_CI_AI) AS cidade_id
         , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoEndereco' AND CODIGO=2) AS dominiotipoendereco_id
         , PES.ID                            AS pessoa_id
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_FORNECEDOR F ON F.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> CONTATOS :: PESSOAS JURIDICAS :: TIPO DE AGENTE :: FORNECEDOR >> CONTATO'
    INSERT INTO dbo.contato
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , cargo
         , cpf
         , email
         , nome
         , ordem
         , representantelegal
         , telefone
         , inativador_id
         , autor_id
         , editor_id
         , pessoa_id
         )
    SELECT C.DT_BLOQUEIO                     AS databloqueio
         , NULL                              AS datainativo
         , COALESCE(C.DT_VALIDACAO,GETDATE()) AS datacriacao
         , GETDATE()                         AS dataedicao
         , 0                                 AS "version"
         , C.NM_CARGO                        AS cargo
         , REPLACE(
             REPLACE(
               C.NR_CPF,'.',''     -- RETIRA PONTOS
             ),'-',''              -- RETIRA TRAÇO
           )                                 AS cpf
         , C.NM_EMAIL                        AS email
         , C.NM_CONTATO                      AS nome
         , C.SQ_CONTATO                      AS ordem
         , CASE WHEN C.IN_RESPONSAVEL = 'S'
               THEN 1
               ELSE 0
           END                               AS representantelegal
         , CONCAT(C.NR_DDD,' ',C.NR_FONE)    AS telefone
         , NULL                              AS inativador_id
         , NULL                              AS autor_id
         , NULL                              AS editor_id
         , PES.ID                            AS pessoa_id    
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_CONTATO C ON C.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> VINCULO PARCEIRO :: PESSOAS JURIDICAS :: TIPO DE AGENTE :: FORNECEDOR >> PARCEIRO'
    INSERT INTO dbo.parceiro 
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , inativador_id
         , autor_id
         , editor_id
         , classeparceiro_id
         , pessoa_id
         , agente_id
         )
    SELECT A.DT_BLOQUEIO           AS databloqueio
         , NULL                    AS datainativo
         , COALESCE(A.DT_CADASTRO,GETDATE()) AS datacriacao
         , GETDATE()          AS dataedicao
         , 0                       AS "version"
         , A.CD_AGENTE             AS codigo
         , NULL                    AS inativador_id
         , NULL                    AS autor_id
         , NULL                    AS editor_id
         , (SELECT ID FROM CLASSEPARCEIRO WHERE DOMINIOTIPOPARCEIRO_ID = (SELECT ID FROM DOMINIO WHERE CHAVE='tipoParceiro' AND CODIGO=4)) AS classeparceiro_id -- 1 COLABORADOR, 2 - ORGÃO EXTERNO, 3 - PORTADOR, 4 - FORNECEDOR
         , PES.ID                  AS pessoa_id
         , A.CD_AGENTE             AS agente_id
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> DADOS DO PARCEIRO :: PESSOAS JURIDICAS :: TIPO DE AGENTE :: FORNECEDOR >> FORNECEDOR'
    INSERT INTO dbo.fornecedor
         ( id
         , compraseletronicas
         , estrangeiro
         )
    SELECT PAR.ID      AS id
         , CASE WHEN F.IN_COMPRA_ELETRONICA = 'S' 
             THEN 1
             ELSE 0
           END         AS compraseletronicas
         , 0           AS estrangeiro
    FROM ASI_HOMOLOGA..CR_AGENTE A
    INNER JOIN ASI_HOMOLOGA..CR_FORNECEDOR F ON F.CD_AGENTE=A.CD_AGENTE
    INNER JOIN DBO.PARCEIRO PAR ON PAR.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
    WHERE A.CD_TP_SIT_JURIDICA = '1' -- "1";"PESSOA JURIDICA" "2";"PESSOA FISICA"
    AND A.CD_TP_AGENTE = '1'         -- "1";"FORNECEDOR"
    ORDER BY A.ID_AGENTE;

    PRINT '--> TELEFONES :: PESSOAS :: TIPO AGENTE :: INDIFERENTE >> TELEFONE'
    INSERT INTO dbo.telefone
         ( databloqueio
         , datacriacao
         , dataedicao
         , [version]
         , numero
         , dominio_telefone
         , pessoa_id
         ) 
    SELECT FONE.databloqueio
         , FONE.datacriacao
         , FONE.dataedicao
         , FONE.[version]
         , FONE.telefone
         , FONE.dominio_telefone
         , FONE.pessoa_id
    FROM ( SELECT A.DT_BLOQUEIO                     AS databloqueio
                , A.DT_CADASTRO                     AS datacriacao
                , GETDATE()                         AS dataedicao
                , 0                                 AS "version"
                , LTRIM(RTRIM(COALESCE(A.NR_DDD1,' ')))+' '+LTRIM(RTRIM(COALESCE(A.NR_FONE1,' '))) AS telefone
                , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoTelefone' AND CODIGO=1) AS dominio_telefone
                , PES.ID                            AS pessoa_id
           FROM ASI_HOMOLOGA..CR_AGENTE A
           INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
           UNION
           SELECT A.DT_BLOQUEIO                     AS databloqueio
                , A.DT_CADASTRO                     AS datacriacao
                , GETDATE()                         AS dataedicao
                , 0                                 AS "version"
                , LTRIM(RTRIM(COALESCE(A.NR_DDD2,' ')))+' '+LTRIM(RTRIM(COALESCE(A.NR_FONE2,' '))) AS telefone
                , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoTelefone' AND CODIGO=1) AS dominio_telefone
                , PES.ID                            AS pessoa_id
           FROM ASI_HOMOLOGA..CR_AGENTE A
           INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
           UNION
           SELECT A.DT_BLOQUEIO                     AS databloqueio
                , A.DT_CADASTRO                     AS datacriacao
                , GETDATE()                         AS dataedicao
                , 0                                 AS "version"
                , LTRIM(RTRIM(COALESCE(A.NR_DDD_FAX,' ')))+' '+LTRIM(RTRIM(COALESCE(A.NR_FAX,' '))) AS telefone
                , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoTelefone' AND CODIGO=1) AS dominio_telefone
                , PES.ID                            AS pessoa_id
           FROM ASI_HOMOLOGA..CR_AGENTE A
           INNER JOIN DBO.PESSOA PES ON PES.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=A.CD_AGENTE
          ) AS FONE 
    ORDER BY FONE.DATAEDICAO;

    -- TOTALIZADORES
    PRINT 'IMPORTACAO DAS FUNCOES >> FUNCAO';
    DECLARE @count_asi bigint = (SELECT COUNT(*) FROM ASI_HOMOLOGA..CR_TP_FUNCAO_HIER);
    DECLARE @count_grp bigint = (SELECT COUNT(*) FROM DBO.FUNCAO);
    PRINT 'Total de registros do ASI ' + CAST(@count_asi AS NVARCHAR)
    PRINT 'Total de registros no GRP ' + CAST(@count_grp AS NVARCHAR)
    PRINT ' ';

    PRINT 'VINCULO DE PARCEIRO :: PESSOAS NÃO AGENTES :: FUNCIONARIOS >> PARCEIRO';
    SET @count_asi = (SELECT COUNT(*) FROM ASI_HOMOLOGA..CR_FUNCIONARIO);
    SET @count_grp = (SELECT COUNT(*) FROM DBO.PARCEIRO WHERE CLASSEPARCEIRO_ID = (SELECT ID FROM CLASSEPARCEIRO WHERE DOMINIOTIPOPARCEIRO_ID = (SELECT ID FROM DOMINIO WHERE CHAVE='tipoParceiro' AND CODIGO=1)));
    PRINT 'Total de registros do ASI ' + CAST(@count_asi AS NVARCHAR)
    PRINT 'Total de registros no GRP ' + CAST(@count_grp AS NVARCHAR)
    PRINT ' ';

    PRINT 'REGISTROS DE PESSOA JURIDICA';
    SET @count_asi = (SELECT COUNT(*) FROM ASI_HOMOLOGA..CR_AGENTE A WHERE A.CD_TP_SIT_JURIDICA = '1');
    SET @count_grp = (SELECT COUNT(*) FROM DBO.PESSOAJURIDICA);
    PRINT 'Total de registros do ASI ' + CAST(@count_asi AS NVARCHAR)
    PRINT 'Total de registros no GRP ' + CAST(@count_grp AS NVARCHAR)
    PRINT ' ';

    PRINT 'REGISTROS DE PESSOA FISICA';
    SET @count_asi = (SELECT COUNT(*) FROM ASI_HOMOLOGA..CR_AGENTE A WHERE A.CD_TP_SIT_JURIDICA = '2')+(SELECT COUNT(*) FROM ASI_HOMOLOGA..CR_FUNCIONARIO);
    SET @count_grp = (SELECT COUNT(*) FROM DBO.PESSOAFISICA);
    PRINT 'Total de registros do ASI ' + CAST(@count_asi AS NVARCHAR)
    PRINT 'Total de registros no GRP ' + CAST(@count_grp AS NVARCHAR)
    PRINT ' ';
    
    COMMIT
-- #FIM :: IMPORTACAO DOS AGENTES >> PESSOAS
GO


-- #INI :: MIGRACAO DAS ESTRUTURAS ORGANIZACIONAIS RESPONSAVEL DAS UAS
    BEGIN TRANSACTION
    GO
    
    DECLARE @unidade_id BIGINT;
    
    -- RECUPERA AS ESTRUTURAS ORGANIZACIONAIS DO TIPO UA QUE TEM RESPONSAVEIS ATRIBUIDOS
    DECLARE ua_cursor CURSOR FAST_FORWARD FOR  
        SELECT DISTINCT UND.ID
        FROM ASI_HOMOLOGA..CR_UA UA
        INNER JOIN DBO.ESTRUTURAORGANIZACIONAL UND ON UA.CD_UA=UND.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI
        INNER JOIN ASI_HOMOLOGA..CR_HIERARQUIA_UA HUA ON UA.CD_ORGAO=HUA.CD_ORGAO AND UA.CD_UA=HUA.CD_UA
        INNER JOIN ASI_HOMOLOGA..CR_FUNCIONARIO F ON F.CD_FUNCIONARIO=HUA.CD_FUNCIONARIO AND F.CD_ORGAO=HUA.CD_ORGAO
        INNER JOIN DBO.PARCEIRO PAR ON PAR.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_FUNCIONARIO
        INNER JOIN DBO.PARCEIRO_COLABORADOR PRC ON PRC.ID=PAR.ID
        ORDER BY UND.ID;
        
    PRINT 'Importando responsáveis das unidades administrativas...'
    OPEN ua_cursor   
    FETCH NEXT FROM ua_cursor INTO @unidade_id   
    
    WHILE @@FETCH_STATUS = 0   
    BEGIN   
        INSERT INTO dbo.estruturaorganizacionalresp
             ( databloqueio
             , datainativo
             , datacriacao
             , dataedicao
             , [version]
             , ordem
             , inativador_id
             , autor_id
             , editor_id
             , estruturaorganizacional_id
             , responsavel_id
             )
        SELECT HUA.DT_FIM           AS databloqueio
             , NULL                 AS datainativo
             , COALESCE(HUA.DT_INICIO,GETDATE()) AS datacriacao
             , COALESCE(HUA.DT_INICIO,GETDATE()) AS dataedicao
             , 0                    AS "version"
             , (ROW_NUMBER() OVER (ORDER BY HUA.CD_UA, HUA.SQ_HIERARQUIA)) AS ordem
             , NULL                 AS inativador_id
             , NULL                 AS autor_id
             , NULL                 AS editor_id
             , UND.ID               AS estruturaorganizacional_id         
             , PRC.ID               AS responsavel_id
        FROM ASI_HOMOLOGA..CR_UA UA
        INNER JOIN DBO.ESTRUTURAORGANIZACIONAL UND ON UA.CD_UA=UND.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI
        INNER JOIN ASI_HOMOLOGA..CR_HIERARQUIA_UA HUA ON UA.CD_ORGAO=HUA.CD_ORGAO AND UA.CD_UA=HUA.CD_UA
        INNER JOIN ASI_HOMOLOGA..CR_FUNCIONARIO F ON F.CD_FUNCIONARIO=HUA.CD_FUNCIONARIO AND F.CD_ORGAO=HUA.CD_ORGAO
        INNER JOIN DBO.PARCEIRO PAR ON PAR.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_FUNCIONARIO
        INNER JOIN DBO.PARCEIRO_COLABORADOR PRC ON PRC.ID=PAR.ID
        WHERE UND.ID = @unidade_id
        ORDER BY UND.ID, HUA.SQ_HIERARQUIA;
    
        FETCH NEXT FROM ua_cursor INTO @unidade_id
    END
    
    CLOSE ua_cursor   
    DEALLOCATE ua_cursor
    COMMIT
-- #FIM :: MIGRACAO DAS ESTRUTURAS ORGANIZACIONAIS RESPONSAVEL DAS UAS 
GO


-- #INI :: MIGRACAO DAS ESTRUTURAS ORGANIZACIONAIS RESPONSAVEL DAS ULS
    BEGIN TRANSACTION
    GO

    DECLARE @unidade_id BIGINT;

    -- RECUPERA AS ESTRUTURAS ORGANIZACIONAIS DO TIPO UL QUE TEM RESPONSAVEIS ATRIBUIDOS
    DECLARE ul_cursor CURSOR FAST_FORWARD FOR  
        SELECT DISTINCT UND.ID
        FROM ASI_HOMOLOGA..CR_UL UL
        INNER JOIN DBO.ESTRUTURAORGANIZACIONAL UND ON UL.CD_UL=UND.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI
        INNER JOIN ASI_HOMOLOGA..CR_HIERARQUIA_UL HUL ON UL.CD_ORGAO=HUL.CD_ORGAO AND UL.CD_UL=HUL.CD_UL
        INNER JOIN ASI_HOMOLOGA..CR_FUNCIONARIO F ON F.CD_FUNCIONARIO=HUL.CD_FUNCIONARIO AND F.CD_ORGAO=HUL.CD_ORGAO
        INNER JOIN DBO.PARCEIRO PAR ON PAR.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_FUNCIONARIO
        INNER JOIN DBO.PARCEIRO_COLABORADOR PRC ON PRC.ID=PAR.ID
        ORDER BY UND.ID

    PRINT 'Importando responsáveis das unidades administrativas...'
    OPEN ul_cursor   
    FETCH NEXT FROM ul_cursor INTO @unidade_id   

    WHILE @@FETCH_STATUS = 0   
    BEGIN   
        INSERT INTO dbo.estruturaorganizacionalresp
             ( databloqueio
             , datainativo
             , datacriacao
             , dataedicao
             , [version]
             , ordem
             , inativador_id
             , autor_id
             , editor_id
             , estruturaorganizacional_id
             , responsavel_id
             )
        SELECT HUL.DT_FIM           AS databloqueio 
             , NULL                 AS datainativo
             , COALESCE(HUL.DT_INICIO,GETDATE()) AS datacriacao
             , COALESCE(HUL.DT_INICIO,GETDATE()) AS dataedicao
             , 0                    AS "version"
             , (ROW_NUMBER() OVER (ORDER BY HUL.CD_UL, HUL.SQ_HIERARQUIA)) AS ordem
             , NULL                 AS inativador_id
             , NULL                 AS autor_id
             , NULL                 AS editor_id
             , UND.ID               AS estruturaorganizacional_id
             , PRC.ID               AS responsavel_id
        FROM ASI_HOMOLOGA..CR_UL UL
        INNER JOIN DBO.ESTRUTURAORGANIZACIONAL UND ON UL.CD_UL=UND.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI
        INNER JOIN ASI_HOMOLOGA..CR_HIERARQUIA_UL HUL ON UL.CD_ORGAO=HUL.CD_ORGAO AND UL.CD_UL=HUL.CD_UL
        INNER JOIN ASI_HOMOLOGA..CR_FUNCIONARIO F ON F.CD_FUNCIONARIO=HUL.CD_FUNCIONARIO AND F.CD_ORGAO=HUL.CD_ORGAO
        INNER JOIN DBO.PARCEIRO PAR ON PAR.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_FUNCIONARIO
        INNER JOIN DBO.PARCEIRO_COLABORADOR PRC ON PRC.ID=PAR.ID
        WHERE UND.ID = @unidade_id
        ORDER BY UND.ID, HUL.SQ_HIERARQUIA;

        FETCH NEXT FROM ul_cursor INTO @unidade_id
    END

    CLOSE ul_cursor   
    DEALLOCATE ul_cursor
    COMMIT
-- #FIM :: MIGRACAO DAS ESTRUTURAS ORGANIZACIONAIS RESPONSAVEL DAS ULS
GO


-- #INI :: IMPORTACAO DAS COMISSOES DE INVENTARIO >> INVENTARIOCOMISSAO
    BEGIN TRANSACTION
    GO
    
    PRINT 'Importando comissões...'
    INSERT INTO dbo.comissao
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , dataextincao
         , dataformacao
         , nome
         , numprocesso
         , portaria
         , inativador_id
         , autor_id
         , editor_id
         , organizacao_id
         , presidente_id
         , dominiotipocomissao_id
         )
    SELECT NULL                 AS databloqueio 
         , NULL                 AS datainativo
         , GETDATE()            AS datacriacao
         , GETDATE()            AS dataedicao
         , 0                    AS "version"
         , C.CD_COMISSAO        AS codigo
         , C.DT_EXTINCAO        AS dataextincao
         , C.DT_FORMACAO        AS dataformacao
         , C.NM_COMISSAO        AS nome
         , C.NR_PROCESSO        AS numprocesso
         , C.NR_PORTARIA        AS portaria
         , NULL                 AS inativador_id
         , NULL                 AS autor_id
         , NULL                 AS editor_id
         , 1                     AS organizacao_id
         , PRC.ID               AS presidente_id
         , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoComissao' AND CODIGO=1) AS dominioTipoComissao_id
    FROM ASI_HOMOLOGA..BP_COMISSAO_INV C   
    INNER JOIN ASI_HOMOLOGA..BP_COMISSAO_REPR R ON C.CD_COMISSAO = R.CD_COMISSAO
    INNER JOIN DBO.ESTRUTURAORGANIZACIONAL U ON C.CD_UG=U.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI
    INNER JOIN ASI_HOMOLOGA..CR_FUNCIONARIO F ON F.CD_FUNCIONARIO=R.CD_FUNCIONARIO AND F.CD_ORGAO=C.CD_ORGAO
    INNER JOIN DBO.PARCEIRO PAR ON PAR.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_FUNCIONARIO
    INNER JOIN DBO.PARCEIRO_COLABORADOR PRC ON PRC.ID=PAR.ID
    WHERE R.IN_PRESIDENTE = 'S';

    PRINT 'Importando membros das comissões...'
    INSERT INTO dbo.comissaointegrante
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , sequencia
         , inativador_id
         , autor_id
         , editor_id
         , integrante_id
         , comissao_id
         , comissaoinativo_id
         )
    SELECT NULL                 AS databloqueio 
         , NULL                 AS datainativo
         , GETDATE()            AS datacriacao
         , GETDATE()            AS dataedicao
         , 0                    AS "version"
         , (ROW_NUMBER() OVER (ORDER BY R.CD_COMISSAO)) AS sequencia
         , NULL                 AS inativador_id
         , NULL                 AS autor_id
         , NULL                 AS editor_id
         , PRC.ID               AS integrante_id
         , I.ID                 AS inventariocomissao_id
         , NULL                 AS inventariocomissaoinativo_id
    FROM ASI_HOMOLOGA..BP_COMISSAO_REPR R 
    INNER JOIN ASI_HOMOLOGA..BP_COMISSAO_INV C ON C.CD_COMISSAO = R.CD_COMISSAO
    INNER JOIN DBO.COMISSAO I ON I.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI= C.CD_COMISSAO
    INNER JOIN ASI_HOMOLOGA..CR_FUNCIONARIO F ON F.CD_FUNCIONARIO=R.CD_FUNCIONARIO AND F.CD_ORGAO=C.CD_ORGAO
    INNER JOIN DBO.PARCEIRO PAR ON PAR.AGENTE_ID COLLATE SQL_Latin1_General_CP1_CI_AI=F.CD_FUNCIONARIO
    INNER JOIN DBO.PARCEIRO_COLABORADOR PRC ON PRC.ID=PAR.ID;

    COMMIT
-- #FIM :: IMPORTACAO DAS COMISSOES DE INVENTARIO >> INVENTARIOCOMISSAO
GO


-- #INI :: IMPORTACAO CR_BEM_GENERICO >> CLASSIFICACAOMATERIAL
    BEGIN TRANSACTION
    GO
    
    PRINT '--> NIVEIS  :: "CLASSE">>GRUPO">>"SUB_GRUPO">>"MATERIAL"'
    SET IDENTITY_INSERT dbo.classificacaomaterial ON;
    INSERT INTO dbo.classificacaomaterial
         ( id
         , databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , descricao
         , inativador_id
         , autor_id
         , editor_id
         , organizacao_id
         , classificacaomaterialparent_id
         , tipoclassificacaomaterial_id
         , dominiotipomaterial_id
         )
    SELECT C.ID_BEM_GENERICO AS id
         , NULL              AS databloqueio
         , NULL              AS datainativo
         , GETDATE()         AS datacriacao
         , GETDATE()         AS dataedicao
         , 0                 AS "version"
         , C.CD_BEM_GENERICO AS codigo
         , C.DS_BEM_GENERICO AS descricao
         , NULL              AS inativador_id
         , NULL              AS autor_id
         , NULL              AS editor_id
         , 1                 AS organizacao_id
         , CASE 
             WHEN C.CD_GRAU = 0 THEN NULL 
             ELSE (SELECT S.ID_BEM_GENERICO FROM ASI_HOMOLOGA..CR_BEM_GENERICO S WHERE S.CD_BEM_GENERICO=C.CD_BEM_GEN_SUP)
           END               AS classificacaomaterialparent_id
         , CASE 
             WHEN C.CD_GRAU = 0 THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoClassificacaoMaterial' AND CODIGO=0)
             WHEN C.CD_GRAU = 1 THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoClassificacaoMaterial' AND CODIGO=1)
             WHEN C.CD_GRAU = 2 THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoClassificacaoMaterial' AND CODIGO=2)
             WHEN C.CD_GRAU = 3 THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoClassificacaoMaterial' AND CODIGO=3)
           END               AS tipoclassificacaomaterial_id
         , CASE 
             WHEN C.CD_TIPO_BS='C' THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=1)
             WHEN C.CD_TIPO_BS='P' THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=2)
             WHEN C.CD_TIPO_BS='S' THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=3)
           END               AS dominiotipomaterial_id
    FROM ASI_HOMOLOGA..CR_BEM_GENERICO C
    WHERE C.CD_GRAU != 4
    ORDER BY C.ID_BEM_GENERICO;        
    SET IDENTITY_INSERT dbo.classificacaomaterial OFF;

    PRINT '--> NIVEL :: "DETALHE"'
    INSERT INTO dbo.classificacaomaterial
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , descricao
         , inativador_id
         , autor_id
         , editor_id
         , organizacao_id
         , classificacaomaterialparent_id
         , tipoclassificacaomaterial_id
         , dominiotipomaterial_id
         )
    SELECT NULL                 AS databloqueio
         , NULL                 AS datainativo
         , GETDATE()            AS datacriacao
         , GETDATE()            AS dataedicao
         , 0                    AS "version"
         , 'D'+B.CD_BEM_SERVICO AS codigo
         , B.DS_COMPLETA        AS descricao
         , NULL                 AS inativador_id
         , NULL                 AS autor_id
         , NULL                 AS editor_id
         , 1                    AS organizacao_id
         , C.ID_BEM_GENERICO    AS classificacaomaterialparent_id
         , (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoClassificacaoMaterial' AND CODIGO=4) AS tipoclassificacaomaterial_id
         , CASE 
             WHEN C.CD_TIPO_BS='C' THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=1)
             WHEN C.CD_TIPO_BS='P' THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=2)
             WHEN C.CD_TIPO_BS='S' THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=3)
           END                  AS dominiotipomaterial_id
    FROM ASI_HOMOLOGA..CR_BEM_SERVICO B
    INNER JOIN ASI_HOMOLOGA..CR_BEM_GENERICO C ON C.CD_BEM_GENERICO=B.CD_BEM_GENERICO
    ORDER BY B.ID_BEM_SERVICO;

    COMMIT
-- #FIM :: IMPORTACAO CR_BEM_GENERICO >> CLASSIFICACAOMATERIAL
GO


-- #INI :: IMPORTACAO CARACTERISTICAS DE MATERIAIS >> CARACTERISTICA
    BEGIN TRANSACTION
    GO
    
    PRINT 'CARACTERISTICAS --> PRIMEIRO INSERIMOS TODAS :: TABELADAS OU NAO'
    INSERT INTO dbo.caracteristica
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , chavedominio
         , codigo
         , descricao
         , expressaoregular
         , tamanho
         , inativador_id
         , autor_id
         , editor_id
         , organizacao_id
         , dominiotipodado_id
         , dominiotiporestricao_id
         )
    SELECT DISTINCT
           -- C.ID_CARACTERISTICA AS id
           C.DT_BLOQUEIO       AS databloqueio
         , NULL                AS datainativo
         , GETDATE()           AS datacriacao
         , GETDATE()           AS dataedicao
         , 0                   AS "version"
         , CASE 
             WHEN C.IN_TABELADO = 'S'
             THEN 'tipoCaract' + dbo.InitCap(NM_CARACTERISTICA) 
             ELSE NULL
           END                 AS chavedominio
         , C.CD_CARACTERISTICA AS codigo
         , C.NM_CARACTERISTICA AS descricao
         , C.DS_MASCARA        AS expressaoregular
         , C.NR_TAMANHO        AS tamanho
         , NULL                AS inativador_id
         , NULL                AS autor_id
         , NULL                AS editor_id
         , 1                   AS organizacao_id
         , D.ID                AS dominiotipodado_id
         , NULL                AS dominiotiporestricao_id
    FROM ASI_HOMOLOGA..CR_CARACTERISTICA C
    INNER JOIN ( SELECT ID
                      , CASE 
                          WHEN NOME = 'TEXT_FIELD' THEN 'CH'
                          WHEN NOME = 'TEXT_AREA'  THEN 'TX'
                          WHEN NOME = 'NUMBER'     THEN 'NM'
                          WHEN NOME = 'ARQUIVO'    THEN 'IM'
                        END AS tipo
                   FROM DBO.DOMINIO 
                  WHERE CHAVE = 'tipoDado' 
                    AND NOME IN ('TEXT_FIELD', 'TEXT_AREA', 'NUMBER', 'ARQUIVO')
                ) AS D ON D.TIPO = C.TP_DADO;

    PRINT 'CARACTERISTICAS --> DEPOIS, AJUSTAMOS O DOMINIO DO TIPO DE DADOS PARA CARACTERISTICAS TABELADAS'
    UPDATE dbo.caracteristica
       SET dominiotipodado_id = 
         ( SELECT ID 
              FROM DBO.DOMINIO 
             WHERE CHAVE='tipoDado' 
               AND CODIGO=6 )
     WHERE codigo IN 
         ( SELECT C.CD_CARACTERISTICA COLLATE SQL_Latin1_General_CP1_CI_AI
              FROM ASI_HOMOLOGA..CR_CARACTERISTICA C 
            WHERE C.IN_TABELADO = 'S' )
       AND chavedominio IS NOT NULL;

    PRINT 'CARACTERISTICAS --> POR FIM, CRIAMOS AS ENTRADAS NO DOMINIO PARA OS ITENS DAS TABELADAS'
    INSERT INTO dbo.dominio
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , chave
         , codigo
         , descricao
         , nome
         , inativador_id
         , autor_id
         , editor_id
         , ispadrao
         )
    SELECT DISTINCT
           T.DT_BLOQUEIO            AS databloqueio
         , NULL                     AS datainativo
         , GETDATE()                AS datacriacao
         , GETDATE()                AS dataedicao
         , 0                        AS "version"
         , 'tipoCaract' + dbo.InitCap(C.NM_CARACTERISTICA) + CAST(C.ID_CARACTERISTICA AS VARCHAR) AS chave
         , T.SQ_CARACT_TAB          AS codigo
         , dbo.InitCap(T.NM_CARACT_TAB) AS descricao
         , T.NM_CARACT_TAB          AS nome
         , NULL                     AS inativador_id
         , NULL                     AS autor_id
         , NULL                     AS editor_id
         , 0                        AS ispadrao
    FROM ASI_HOMOLOGA..CR_CARACT_TAB T
    INNER JOIN ASI_HOMOLOGA..CR_CARACTERISTICA C ON C.CD_CARACTERISTICA = T.CD_CARACTERISTICA
    WHERE C.IN_TABELADO = 'S';

    COMMIT
-- #FIM :: IMPORTACAO CARACTERISTICAS DE MATERIAIS >> CARACTERISTICA
GO


-- #INI :: IMPORTACAO MATERIAIS >> MATERIAL
    BEGIN TRANSACTION
    GO
    
    PRINT '--> MATERIAIS  ::  INDIFERENTE'
    INSERT INTO dbo.material
         ( databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , descricao
         , emplaquetavel
         , inativador_id
         , autor_id
         , editor_id
         , organizacao_id
         , classificacaomaterial_id
         , contacontabil_id
         , dominiotipomaterial_id
         )
    SELECT B.DT_BLOQUEIO    AS databloqueio
         , NULL             AS datainativo
         , B.DT_CADASTRO    AS datacriacao
         , GETDATE()        AS dataedicao
         , 0                AS "version"
         , B.CD_BEM_SERVICO AS codigo
         , B.DS_COMPLETA    AS descricao
         , CASE WHEN B.IN_EMPLAQUETAVEL = 'S'
             THEN 1
             ELSE 0
           END              AS emplaquetavel
         , NULL             AS inativador_id
         , NULL             AS autor_id
         , NULL             AS editor_id
         , 1                AS organizacao_id
         , (SELECT ID FROM DBO.CLASSIFICACAOMATERIAL WHERE CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI='D'+B.CD_BEM_SERVICO) AS classificacaomaterial_id
         , CASE 
             WHEN C.CD_TIPO_BS='C' THEN (SELECT COALESCE(ID,1) FROM DBO.CONTACONTABIL WHERE CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI =B.CD_CONTA)
             WHEN C.CD_TIPO_BS='P' THEN (SELECT COALESCE(ID,2) FROM DBO.CONTACONTABIL WHERE CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI =B.CD_CONTA)
             WHEN C.CD_TIPO_BS='S' THEN (SELECT COALESCE(ID,3) FROM DBO.CONTACONTABIL WHERE CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI =B.CD_CONTA)
           END              AS contacontabil_id
         , CASE 
             WHEN C.CD_TIPO_BS='C' THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=1)
             WHEN C.CD_TIPO_BS='P' THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=2)
             WHEN C.CD_TIPO_BS='S' THEN (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=3)
           END              AS dominiotipomaterial_id
    FROM ASI_HOMOLOGA..CR_BEM_SERVICO B
    INNER JOIN ASI_HOMOLOGA..CR_BEM_GENERICO C ON C.CD_BEM_GENERICO=B.CD_BEM_GENERICO
    ORDER BY B.ID_BEM_SERVICO;

    PRINT '--> MATERIAIS :: CARACTERISTICAS DE BENS E SERVICOS :: MATERIALCARACTERISTICA'
    SET IDENTITY_INSERT dbo.materialcaracteristica ON;
    INSERT INTO dbo.materialcaracteristica
         ( id
         , databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , codigo
         , generico
         , imprimeconteudo
         , obrigatorio
         , sequencia
         , inativador_id
         , autor_id
         , editor_id
         , caracteristica_id
         , material_id
         , materialremocao_id
         )
    SELECT C.ID_CAR_BS_POSSIVEL   AS id
         , C.DT_BLOQUEIO          AS databloqueio
         , NULL                   AS datainativo
         , GETDATE()              AS datacriacao
         , GETDATE()              AS dataedicao
         , 0                      AS "version"
         , C.CD_CARACTERISTICA    AS codigo
         , CASE WHEN C.IN_CAR_GENERICA = 'S' THEN 1
                WHEN C.IN_CAR_GENERICA = 'N' THEN 0
           END                    AS generico
         , CASE WHEN C.IN_DESCR_MATERIAL = 'S' THEN 1
                WHEN C.IN_DESCR_MATERIAL = 'N' THEN 0
           END                    AS imprimeconteudo
         , CASE WHEN C.IN_OBRIGATORIO = 'S' THEN 1
                WHEN C.IN_OBRIGATORIO = 'N' THEN 0
           END                    AS obrigatorio
         , C.NR_ORDEM             AS sequencia
         , NULL                   AS inativador_id
         , NULL                   AS autor_id
         , NULL                   AS editor_id
         , G.ID                   AS caracteristica_id
         , M.ID                   AS material_id
         , NULL                   AS materialremocao_id
    FROM ASI_HOMOLOGA..CR_CAR_BS_POSSIVEL C
    INNER JOIN ASI_HOMOLOGA..CR_BEM_SERVICO B ON B.CD_BEM_SERVICO=C.CD_BEM_SERVICO
    INNER JOIN DBO.MATERIAL M ON M.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=B.CD_BEM_SERVICO
    INNER JOIN DBO.CARACTERISTICA G ON G.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=C.CD_CARACTERISTICA
    ORDER BY B.ID_BEM_SERVICO;
    SET IDENTITY_INSERT dbo.materialcaracteristica OFF;

    PRINT '--> MATERIAIS :: BEM SERVICO  :: MATERIALCONSUMO'
    INSERT INTO dbo.materialconsumo
         ( elementodespesa
         , id
         , unidadearmazenamento_id
         )
    SELECT NULL    AS elementodespesa
         , M.ID    AS id_material
         , U.ID    AS unidadearmazenamento_id
    FROM ASI_HOMOLOGA..CR_BEM_SERVICO B
    INNER JOIN ASI_HOMOLOGA..CR_BEM_GENERICO C ON C.CD_BEM_GENERICO=B.CD_BEM_GENERICO
    INNER JOIN DBO.MATERIAL M ON M.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=B.CD_BEM_SERVICO
    INNER JOIN DBO.UNIDADEMEDIDA U ON U.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=B.CD_UM_ELEMENTAR
    WHERE C.CD_TIPO_BS IN ('C','S')  -- REVER MODELO PARA CONTEMPLAR 'SERVICO' TAMBEM
    ORDER BY B.ID_BEM_SERVICO;

    PRINT '--> MATERIAIS :: CARGA UNIDADE MEDIDA ENTRADA :: MATCONSUMOTIPOUNIDADEENTRADA'
    SET IDENTITY_INSERT dbo.matconsumotipounidadeentrada ON;
    INSERT INTO dbo.matconsumotipounidadeentrada
         ( id
         , databloqueio
         , datainativo
         , inativador_id
         , materialconsumo_id
         , materialconsumoremocao_id
         , unidademedida_id
         )
    SELECT B.ID_BEM_SERVICO       AS id
         , B.DT_BLOQUEIO          AS databloqueio
         , NULL                   AS datainativo
         , NULL                   AS inativador_id
         , MC.ID         AS materialconsumo_id
         , NULL                   AS materialconsumoremocao_id
         , U.ID                   AS unidademedida_id
    FROM ASI_HOMOLOGA..CR_BEM_SERVICO B
    INNER JOIN ASI_HOMOLOGA..CR_BEM_GENERICO C ON C.CD_BEM_GENERICO=B.CD_BEM_GENERICO
    INNER JOIN DBO.MATERIAL M ON M.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=B.CD_BEM_SERVICO
    INNER JOIN DBO.MATERIALCONSUMO MC ON MC.ID=M.ID
    INNER JOIN DBO.UNIDADEMEDIDA U ON U.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=B.CD_UM_ELEMENTAR
    WHERE C.CD_TIPO_BS IN ('C','S')  -- REVER MODELO PARA CONTEMPLAR 'SERVICO' TAMBEM
    ORDER BY B.ID_BEM_SERVICO;
    SET IDENTITY_INSERT dbo.matconsumotipounidadeentrada OFF;

    PRINT '--> MATERIAIS :: CARGA UNIDADE MEDIDA ENTRADA  :: MATERIALIMAGEM'
    SET IDENTITY_INSERT dbo.materialimagem ON;
    INSERT INTO dbo.materialimagem
         ( id
         , databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , anexo
         , descricao
         , tamanho
         , inativador_id
         , autor_id
         , editor_id
         , material_id
         , materialinativo_id
         )
    SELECT I.ID_IMAGEM_BEM_SERV AS id
         , NULL                 AS databloqueio
         , NULL                 AS datainativo
         , GETDATE()            AS datacriacao
         , GETDATE()            AS dataedicao
         , 0                    AS "version"
         , NULL                 AS anexo  -- NM_ARQUIVO PARECE REFERENCIAR A IMAGEM NO FILESYSTEM 
         , I.NM_IMAGEM_BEM_SERV AS descricao
         , NULL                 AS tamanho
         , NULL                 AS inativador_id
         , NULL                 AS autor_id
         , NULL                 AS editor_id
         , M.ID                 AS material_id
         , NULL                 AS materialinativo_id
    FROM ASI_HOMOLOGA..CR_IMAGEM_BEM_SERV I
    INNER JOIN ASI_HOMOLOGA..CR_BEM_SERVICO B ON B.CD_BEM_SERVICO=I.CD_BEM_SERVICO
    INNER JOIN DBO.MATERIAL M ON M.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=B.CD_BEM_SERVICO
    ORDER BY I.ID_IMAGEM_BEM_SERV;
    SET IDENTITY_INSERT dbo.materialimagem OFF;

    PRINT '--> MATERIAIS :: BEM SERVICO  :: MATERIALPERMANENTE'
    INSERT INTO dbo.materialpermanente
         ( id
         , unidademedida_id  -- REVER NO MODELO :: ALTEREI A REFERENCIA DE DOMINIO PARA UNIDADEMEDIDA
         )
    SELECT M.ID         AS id_material
         , U.ID         AS unidademedida_id
    FROM ASI_HOMOLOGA..CR_BEM_SERVICO B
    INNER JOIN ASI_HOMOLOGA..CR_BEM_GENERICO C ON C.CD_BEM_GENERICO=B.CD_BEM_GENERICO
    INNER JOIN DBO.MATERIAL M ON M.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=B.CD_BEM_SERVICO
    INNER JOIN DBO.UNIDADEMEDIDA U ON U.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=B.CD_UM_ELEMENTAR
    WHERE C.CD_TIPO_BS='P'
    ORDER BY B.ID_BEM_SERVICO;

    PRINT '--> MATERIAIS :: BEM SERVICO  :: MATERIALPERMANENTE'
    SET IDENTITY_INSERT dbo.materialpermanenteconsumo ON;
    INSERT INTO dbo.materialpermanenteconsumo
         ( id
         , databloqueio
         , datainativo
         , datacriacao
         , dataedicao
         , [version]
         , inativador_id
         , autor_id
         , editor_id
         , materialconsumo_id
         , materialpermanente_id
         )
    SELECT B.ID_BEM_SERVICO AS id
         , NULL             AS databloqueio
         , NULL             AS datainativo
         , GETDATE()        AS datacriacao
         , GETDATE()        AS dataedicao
         , 0                AS "version"
         , NULL             AS inativador_id
         , NULL             AS autor_id
         , NULL             AS editor_id
         , MC.ID            AS materialconsumo_id
         , MP.ID            AS materialpermanente_id
    FROM ASI_HOMOLOGA..CR_BEM_SUBORDINADO S
    INNER JOIN ASI_HOMOLOGA..CR_BEM_SERVICO B ON B.CD_BEM_SERVICO=S.CD_BEM_SERVICO_PRI
    INNER JOIN DBO.MATERIAL M ON M.CODIGO COLLATE SQL_Latin1_General_CP1_CI_AI=B.CD_BEM_SERVICO
    INNER JOIN DBO.MATERIALPERMANENTE MP ON MP.ID=M.ID
    INNER JOIN DBO.MATERIALCONSUMO MC ON MC.ID=M.ID
    ORDER BY B.ID_BEM_SERVICO;
    SET IDENTITY_INSERT dbo.materialpermanenteconsumo OFF;

    COMMIT
-- #FIM :: IMPORTACAO MATERIAIS >> MATERIAL
GO


-- #INI :: IMPORTACAO USUARIOS >> SEGURANCA_USUARIO
    BEGIN TRANSACTION
    GO
    
    PRINT '-->IMPORTACAO USUARIOS'
    INSERT INTO dbo.seguranca_usuario
         ( datacriacao
         , dataedicao
         , [version]
         , contabloqueada
         , contaexpirada
         , contahabilitada
         , credencialexpirada
         , email
         , [password]
         , passwordmobile
         , passwordhint
         , semprenovaaba
         , username
         , organizacao_id
         , logindb 
         )
    SELECT GETDATE()          AS datacriacao
         , GETDATE()          AS dataedicao
         , 0                  AS "version"
         , 1                  AS contabloqueada
         , 1                  AS contaexpirada
         , 0                  AS contahabilitada
         , 1                  AS credencialexpirada
         , 'email@domain.com' AS email
         , '$2a$10$/mCLiZIxHplKbJBQOt2Hhu6q/1xvxsKNh3AwBAO0JkLs2wjU8jIyq' AS "password"
         , '$2a$10$/mCLiZIxHplKbJBQOt2Hhu6q/1xvxsKNh3AwBAO0JkLs2wjU8jIyq' as passwordMobile
         , 'PADRAO'           AS passwordhint
         , 0                  AS semprenovaaba
         , 'admin'            AS username
         , 1                  AS organizacao_id
         , 0                  AS logindb;

    INSERT INTO dbo.seguranca_usuario
         ( datacriacao
         , dataedicao
         , [version]
         , contabloqueada
         , contaexpirada
         , contahabilitada
         , credencialexpirada
         , email
         , [password]
         , passwordhint
         , semprenovaaba
         , username
         , organizacao_id
         , logindb
         )
    SELECT GETDATE()          AS datacriacao
         , GETDATE()          AS dataedicao
         , 0                  AS "version"
         , CASE WHEN U.DT_BLOQUEIO IS NULL
             THEN 1
             ELSE 0 
           END                AS contabloqueada
         , 1              AS contaexpirada
         , CASE WHEN U.DT_BLOQUEIO IS NULL
             THEN 0
             ELSE 1
           END                AS contahabilitada
         , 1              AS credencialexpirada
         , 'email@domain.com' AS email
         , '$2a$10$/bFXp.iaFrDI6.XgRslgq.ofM5a2xQ7e37K5SUPVBUev/gYSXjNdS' AS "password"
         , 'GRP @ MP'         AS passwordhint
         , 0               AS semprenovaaba
         , U.CD_FUNCIONARIO   AS username
         , 1                  AS organizacao_id
         , 0               AS logindb 
    FROM ASI_HOMOLOGA..SG_USUARIO U;

    PRINT '-- CRIA PRIVILEGIOS DE ACESSO'
    INSERT INTO dbo.seguranca_privilegio
        ( databloqueio, datainativo, datacriacao, dataedicao, [version],
          descricao, nome, inativador_id, autor_id, editor_id ) 
    VALUES
        ( NULL, NULL, GETDATE(), GETDATE(), 0,
         'ROLE_ADMIN', 'ROLE_ADMIN', NULL, NULL, NULL),
        ( NULL, NULL, GETDATE(), GETDATE(), 0,
         'ROLE_USER', 'ROLE_USER', NULL, NULL, NULL);

    PRINT '-- ATRIBUI OS PRIVILEGIOS AO USUARIO'
    INSERT INTO dbo.seguranca_usuario_privilegio
         ( datacriacao
         , dataedicao
         , [version]
         , inativador_id
         , autor_id
         , editor_id
         , privilegio_id
         , usuario_id
         , usuarioinativo_id
         )
    SELECT GETDATE() AS datacriacao
         , GETDATE() AS dataedicao
         , 0         AS "version" 
         , NULL      AS inativador_id
         , NULL      AS autor_id
         , NULL      AS editor_id
         , (SELECT TOP 1 id FROM DBO.SEGURANCA_PRIVILEGIO WHERE NOME='ROLE_USER') AS privilegio_id
         , S.ID      AS usuario_id
         , NULL      AS usuarioinativo_id
    FROM ASI_HOMOLOGA..SG_USUARIO U
    INNER JOIN DBO.SEGURANCA_USUARIO S ON U.CD_FUNCIONARIO=S.USERNAME COLLATE SQL_Latin1_General_CP1_CI_AI;

    PRINT '-- ATRIBUI OS PRIVILEGIOS AO USUARIO ADMIN'
    INSERT INTO dbo.seguranca_usuario_privilegio
         ( datacriacao
         , dataedicao
         , [version]
         , inativador_id
         , autor_id
         , editor_id
         , privilegio_id
         , usuario_id
         , usuarioinativo_id
         )
    VALUES
         ( GETDATE()
         , GETDATE()
         , 0        
         , NULL     
         , NULL     
         , NULL     
         , (SELECT TOP 1 ID FROM DBO.SEGURANCA_PRIVILEGIO WHERE NOME='ROLE_ADMIN')
         , (SELECT TOP 1 ID FROM DBO.SEGURANCA_USUARIO WHERE USERNAME='admin')
         , NULL
    );

    SET IDENTITY_INSERT dbo.seguranca_usuario_privilegio ON;
    INSERT INTO dbo.seguranca_usuario_privilegio
         ( id
         , datacriacao
         , dataedicao
         , [version]
         , inativador_id
         , autor_id
         , editor_id
         , privilegio_id
         , usuario_id
         , usuarioinativo_id
         )
    SELECT (M.MAX + 1) AS id
         , GETDATE()   AS datacriacao
         , GETDATE()   AS dataedicao
         , 0           AS "version"
         , NULL        AS inativador_id
         , NULL        AS autor_id
         , NULL        AS editor_id
         , (SELECT TOP 1 ID FROM DBO.SEGURANCA_PRIVILEGIO WHERE NOME='SYSADMIN') AS privilegio_id
         , (SELECT TOP 1 ID FROM DBO.SEGURANCA_USUARIO WHERE USERNAME='admin') AS usuario_id
         , NULL        AS usuarioinativo_id
    FROM (SELECT COALESCE(MAX(ID),0) AS MAX FROM DBO.SEGURANCA_USUARIO_PRIVILEGIO) M;    
    SET IDENTITY_INSERT dbo.seguranca_usuario_privilegio OFF;

    UPDATE dbo.pessoa  
      SET usuario_id = U.ID
     FROM
        ( 
            SELECT ID, USERNAME
            FROM DBO.SEGURANCA_USUARIO
        ) AS U
      WHERE U.USERNAME=CODIGO;
    
    COMMIT
-- #FIM :: IMPORTACAO USUARIOS >> SEGURANCA_USUARIO
GO


SET NOCOUNT OFF
--===========================================================================--
-- ##FIM :: IMPORTACAO TABELAS DE APOIO AO NEGOCIO                           --
--===========================================================================-- 