--===========================================================================--
-- ##INI :: CARGAS E ATUALIZACOES DE SALDOS CONTABEIS/ESTOQUE/MOVIMENTOS     --
--===========================================================================--
SET NOCOUNT ON

-- ############################################################################
-- #### -Esses scripts devem ser executados após as depreciações de bens  #####
-- #### -Verificar o anomes referência/data contábil do cliente e ajustar #####
-- ############################################################################


-- #INI :: MIGRACAO DE MOVIMENTOS DE DEPRECIACAO >> CONTACONTABILMOVIMENTO E CONTACONTABILMOVPATRIMONIO
    BEGIN TRANSACTION
    GO
    
    DECLARE @dtaref_ant DATETIME = GETDATE()
          , @data_refer DATETIME
          , @dom_refdep BIGINT
          , @dom_movent BIGINT
          , @row_id     BIGINT
          , @ccm_id     BIGINT
    
    SET @dom_movent = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE  = 'tipoMovimentoContaContabil' AND CODIGO = 3)
    SET @dom_refdep = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE  = 'classeReferencia' AND CODIGO = 7)
    
    PRINT 'Criando tabela temporária com os dados de depreciação...'
    SELECT ROW_NUMBER() OVER(ORDER BY D.DATADEPRECIACAO) AS row_id
         , D.DATADEPRECIACAO          AS datareferencia
         , DI.VALORDEPRECIACAOATUAL   AS valor
         , DI.CONTACONTABIL_ID        AS contacontabil_id
         , D.ID                       AS depreciacao_id
         , DI.BEMPATRIMONIAL_ID       AS bempatrimonial_id
    INTO #TMP_DEPRECIACAO
    FROM DEPRECIACAO D
    INNER JOIN DEPRECIACAOITEM DI ON (DI.DEPRECIACAO_ID = D.ID)
    ORDER BY D.DATADEPRECIACAO
    
    DECLARE cur_depreciacao CURSOR FAST_FORWARD FOR
        SELECT row_id, datareferencia FROM #TMP_DEPRECIACAO
    
    OPEN cur_depreciacao
    FETCH NEXT FROM cur_depreciacao 
        INTO @row_id, @data_refer
    
    WHILE @@FETCH_STATUS = 0
    BEGIN
        IF (@dtaref_ant<>@data_refer)
        BEGIN
            PRINT 'Inserindo movimentos da referência (' + CONVERT(VARCHAR(6), @data_refer, 112) +')...'
            SET @dtaref_ant = @data_refer
        END

        INSERT INTO dbo.ContaContabilMovimento
             ( datacriacao, dataedicao, [version], datareferencia
             , valor, contacontabil_id, tipomovimentocontacontabil_id
             , dominioclassereferencia_id, idclassereferencia )
        SELECT GETDATE(), GETDATE(), 0, R.DATAREFERENCIA
             , 0, R.CONTACONTABIL_ID, @dom_movent, @dom_refdep, R.DEPRECIACAO_ID
        FROM #TMP_DEPRECIACAO R
        WHERE R.ROW_ID = @row_id
        SET @ccm_id = (SELECT IDENT_CURRENT(N'ContaContabilMovimento'))

        INSERT INTO dbo.ContaContabilMovPatrimonio
             ( id, reavaliacao, valordepreciacao, valorreavaliacao, valorreducao
             , bempatrimonial_id, transferencia_id )
        SELECT @ccm_id, 0, R.VALOR, 0, 0
             , R.BEMPATRIMONIAL_ID, NULL
        FROM #TMP_DEPRECIACAO R
        WHERE R.ROW_ID = @row_id
        
        FETCH NEXT FROM cur_depreciacao 
            INTO @row_id, @data_refer
    END
    CLOSE cur_depreciacao
    DEALLOCATE cur_depreciacao
    COMMIT
    PRINT 'Finalizada migração de movimentos de depreciação!'
-- #FIM :: MIGRACAO DE MOVIMENTOS DE DEPRECIACAO >> CONTACONTABILMOVIMENTO E CONTACONTABILMOVPATRIMONIO
GO


-- #INI :: INICIALIZA STATUS DEPRECIACAO DOS BENS >> BEMPATRIMONIAL
    BEGIN TRANSACTION
    GO
    
    UPDATE dbo.BemPatrimonial
       SET dominiostatusdepreciacao_id = NULL
    GO

    COMMIT
-- #FIM :: INICIALIZA STATUS DEPRECIACAO DOS BENS >> BEMPATRIMONIAL
GO


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE NEM CHEGARAM A SER DEPRECIADOS >> BEMPATRIMONIAL
    BEGIN TRANSACTION
    GO
    
    DECLARE @dom_st_dep BIGINT
          , @dom_st_bem BIGINT
          , @bem_id     BIGINT
      
    SET @dom_st_dep = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=5)
    SET @dom_st_bem = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusBem' AND CODIGO=2)

    -- RECUPERA OS BENS PATRIMONIAIS QUE ESTAO NA TABELA DE DEPRECIACAO
    DECLARE cur_bem CURSOR FAST_FORWARD FOR 
        SELECT ID FROM DBO.BEMPATRIMONIAL
         WHERE ID IN ( SELECT ID FROM DBO.BEMPATRIMONIAL
                       EXCEPT
                       SELECT BEMPATRIMONIAL_ID FROM DEPRECIACAOITEM ) 
           AND DOMINIOSTATUS_ID= @dom_st_bem
           
    OPEN cur_bem
    FETCH NEXT FROM cur_bem 
        INTO @bem_id
    
    WHILE @@FETCH_STATUS=0
    BEGIN
         UPDATE dbo.bempatrimonial
            SET dominiostatusdepreciacao_id = @dom_st_dep
          WHERE ID = @bem_id
      FETCH NEXT FROM cur_bem INTO @bem_id
    END
    CLOSE cur_bem
    DEALLOCATE cur_bem
    COMMIT
    PRINT 'Finalizada ajustes status de depreciação de bens baixados sem depreciação!'
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE NEM CHEGARAM A SER DEPRECIADOS >> BEMPATRIMONIAL
GO


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL
    BEGIN TRANSACTION
    GO
    
    DECLARE @dom_st_dep BIGINT
          , @dom_st_bem BIGINT
          , @bem_id     BIGINT

    SET @dom_st_dep = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=3)
    SET @dom_st_bem = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusBem' AND CODIGO=2)

    -- RECUPERA OS BENS PATRIMONIAIS BAIXADOS QUE ESTAO NA TABELA DE DEPRECIACAO E JA ATINGIRAM O VALOR RESIDUAL
    DECLARE cur_bem CURSOR FAST_FORWARD FOR
        SELECT DISTINCT BEMPATRIMONIAL_ID AS ID
        FROM DEPRECIACAOITEM D
        INNER JOIN BEMPATRIMONIAL B ON (B.ID = D.BEMPATRIMONIAL_ID)
        WHERE DOMINIOSTATUS_ID = @dom_st_bem 
        AND B.VALORBRUTOCALCULO = B.VALORLIQUIDO

    OPEN cur_bem
    FETCH NEXT FROM cur_bem INTO @bem_id
    WHILE @@FETCH_STATUS = 0
    BEGIN
         UPDATE dbo.BEMPATRIMONIAL
            SET dominiostatusdepreciacao_id = @dom_st_dep
         WHERE ID = @bem_id
     FETCH NEXT FROM cur_bem INTO @bem_id 
    END
    CLOSE cur_bem
    DEALLOCATE cur_bem
    COMMIT
    PRINT 'Finalizada ajustes status de depreciação de bens baixados que atingiram valor residual!'
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL
GO


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE NAO ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL
    BEGIN TRANSACTION
    GO
    
    DECLARE @dom_st_dep BIGINT
          , @dom_st_bem BIGINT
          , @bem_id     BIGINT
    
    SET @dom_st_dep = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=1)
    SET @dom_st_bem = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusBem' AND CODIGO=2) 
      
    -- RECUPERA OS BENS PATRIMONIAIS BAIXADOS QUE ESTAO NA TABELA DE DEPRECIACAO E NAO ATINGIRAM O VALOR RESIDUAL
    DECLARE cur_bem CURSOR FAST_FORWARD FOR
        SELECT DISTINCT BEMPATRIMONIAL_ID AS ID
        FROM DBO.DEPRECIACAOITEM D
        INNER JOIN BEMPATRIMONIAL B ON (B.ID = D.BEMPATRIMONIAL_ID)
        WHERE DOMINIOSTATUS_ID = @dom_st_bem 
        AND B.VALORBRUTOCALCULO <> B.VALORLIQUIDO
        AND B.DOMINIOSTATUSDEPRECIACAO_ID IS NULL

    OPEN cur_bem
    FETCH NEXT FROM cur_bem INTO @bem_id

    WHILE @@FETCH_STATUS = 0
    BEGIN
        UPDATE dbo.BEMPATRIMONIAL
        SET dominiostatusdepreciacao_id = @dom_st_dep
        WHERE ID = @bem_id
    FETCH NEXT FROM cur_bem INTO @bem_id
    END

    CLOSE cur_bem
    DEALLOCATE cur_bem
    COMMIT
    PRINT 'Finalizada ajustes status de depreciação de bens baixados que não atingiram valor residual!'
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS BAIXADOS QUE NAO ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL
GO


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL
    BEGIN TRANSACTION
    GO
    
    DECLARE @dom_st_dep BIGINT
          , @bem_id     BIGINT

    SET @dom_st_dep = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=2)

    -- RECUPERA OS BENS PATRIMONIAIS QUE ESTAO NO ALMOXARIFADO
    DECLARE cur_bem CURSOR FAST_FORWARD FOR
    SELECT B.ID 
        FROM DBO.BEMPATRIMONIAL B
        WHERE B.UNIDADEATUAL_ID IN 
            ( SELECT E.ID 
              FROM DBO.ESTRUTURAORGANIZACIONAL E
              INNER JOIN DBO.ESTRUTURAORGANIZACIONALPATRIM EP ON (EP.ESTRUTURAORGANIZACIONAL_ID = E.ID)
              WHERE EP.ISALMOXARIFADO = 1 )

    OPEN cur_bem
    FETCH NEXT FROM cur_bem INTO @bem_id
    WHILE @@FETCH_STATUS = 0
    BEGIN
        UPDATE dbo.bempatrimonial
        SET dominiostatusdepreciacao_id = @dom_st_dep
        WHERE ID = @bem_id
        
        FETCH NEXT FROM cur_bem INTO @bem_id
    END
    CLOSE cur_bem
    DEALLOCATE cur_bem
    COMMIT
    PRINT 'Finalizada ajustes status de depreciação de bens que estão no almoxarifado!'
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL
GO


-- ################                                                                                         ################
-- ################             )))))  VERIFICAR O ANOMES ATUAL DA REFERENCIA DO CLIENTE  (((((             ################
-- ################                                                                                         ################
-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL
    BEGIN TRANSACTION
    GO
    
    DECLARE @dom_st_dep BIGINT
          , @bem_id     BIGINT

    SET @dom_st_dep = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=6)

    -- RECUPERA OS BENS PATRIMONIAIS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO
    DECLARE cur_bem CURSOR FAST_FORWARD FOR
        SELECT ID
        FROM BEMPATRIMONIAL 
        WHERE CONVERT(VARCHAR(6),DATACONTABIL, 112) = '201002' 
          AND UNIDADEATUAL_ID NOT IN 
            ( SELECT E.ID 
              FROM ESTRUTURAORGANIZACIONAL E 
              INNER JOIN estruturaorganizacionalpatrim EP ON (EP.ESTRUTURAORGANIZACIONAL_ID = E.ID) 
              WHERE EP.ISALMOXARIFADO = 1 )
    
    OPEN cur_bem
    FETCH NEXT FROM cur_bem INTO @bem_id
    
    WHILE @@FETCH_STATUS = 0
    BEGIN
        UPDATE dbo.BEMPATRIMONIAL
           SET dominiostatusdepreciacao_id = @dom_st_dep
        WHERE ID = @bem_id
        FETCH NEXT FROM cur_bem INTO @bem_id
    END
    CLOSE cur_bem
    DEALLOCATE cur_bem
    
    COMMIT
    PRINT 'Finalizada ajustes status de depreciação de bens do almoxarifado que tem datacontabil!'
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL
GO


-- ################                                                                                         ################
-- ################             )))))  VERIFICAR A DATACONTABIL INICIAL PARA DEPRECIACAO  (((((             ################
-- ################                                                                                         ################
-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL
    BEGIN TRANSACTION
    GO
    
    DECLARE @dom_st_dep BIGINT
          , @bem_id     BIGINT

    SET @dom_st_dep = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=4)
    
    -- RECUPERA OS BENS PATRIMONIAIS QUE AINDA NAO POSSUEM STATUSDEPRECIACAO E QUE TEM DATA CONTABIL INFERIOR A 2010 E NAO SOFRERAM REAVALIACAO
    DECLARE cur_bem CURSOR FAST_FORWARD FOR
        SELECT ID 
        FROM DBO.BEMPATRIMONIAL
        WHERE DATACONTABIL < CAST('20100101' AS DATETIME)
        AND ID NOT IN (SELECT DISTINCT BEMPATRIMONIAL_ID 
                       FROM DBO.BEMPATRIMONIALALTERACAO 
                       WHERE MOTIVOALTERACAO_ID = (SELECT ID FROM dbo.DOMINIO WHERE CHAVE='tipoMotivoAlteracaoBem' AND CODIGO=3)) 
        AND DOMINIOSTATUSDEPRECIACAO_ID IS NULL
    OPEN cur_bem
    FETCH NEXT FROM cur_bem INTO @bem_id
    WHILE @@FETCH_STATUS = 0
    BEGIN
         UPDATE dbo.bempatrimonial
            SET dominiostatusdepreciacao_id = @dom_st_dep
          WHERE ID = @bem_id
     FETCH NEXT FROM cur_bem INTO @bem_id
    END
    CLOSE cur_bem
    DEALLOCATE cur_bem
    COMMIT
    PRINT 'Finalizada ajustes status de depreciação de bens fora do almoxarifado que tem datacontabil!'
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE TEM DATACONTABIL NESSE MES E NAO ESTAO NO ALMOXARIFADO >> BEMPATRIMONIAL
GO


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE JA ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL
    BEGIN TRANSACTION
    GO
    
    DECLARE @dom_st_dep BIGINT
          , @bem_id BIGINT

    SET @dom_st_dep = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=3)
      
    -- RECUPERA OS BENS PATRIMONIAIS QUE AINDA NAO POSSUEM STATUSDEPRECIACAO E JA ATINGIRAM O VALOR RESIDUAL
    DECLARE cur_bem CURSOR FAST_FORWARD FOR
        SELECT DISTINCT BEMPATRIMONIAL_ID AS ID
        FROM DBO.DEPRECIACAOITEM D
        INNER JOIN BEMPATRIMONIAL B ON (B.ID = D.BEMPATRIMONIAL_ID)
        WHERE B.VALORBRUTOCALCULO = B.VALORLIQUIDO AND B.DOMINIOSTATUSDEPRECIACAO_ID IS NULL

    OPEN cur_bem
    FETCH NEXT FROM cur_bem INTO @bem_id

    WHILE @@FETCH_STATUS = 0
    BEGIN
        UPDATE dbo.BEMPATRIMONIAL
           SET dominiostatusdepreciacao_id = @dom_st_dep
         WHERE ID = @bem_id
        FETCH NEXT FROM cur_bem INTO @bem_id
    END

    CLOSE cur_bem
    DEALLOCATE cur_bem
    
    COMMIT
    PRINT 'Finalizada ajustes status de depreciação de bens que atingiram valor residual!'
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE JA ATINGIRAM O VALOR RESIDUAL >> BEMPATRIMONIAL 
GO


-- #INI :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE NAO SE ADEQUARAM NAS CONDICOES ANTERIORES (SAO TODOS DEPRECIAVEIS) >> BEMPATRIMONIAL
    BEGIN TRANSACTION
    GO

    UPDATE dbo.bempatrimonial 
       SET dominiostatusdepreciacao_id = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=1) 
     WHERE dominiostatusdepreciacao_id IS NULL;
    COMMIT

    BEGIN TRANSACTION
    GO

    UPDATE dbo.bempatrimonial 
       SET naodepreciar = 1 
     WHERE dominiostatusdepreciacao_id = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoStatusDepreciacao' AND CODIGO=4) 
    COMMIT
    PRINT 'Finalizada ajustes status de depreciação demais bens!'
-- #FIM :: ATUALIZA STATUS DEPRECIACAO DOS BENS QUE NAO SE ADEQUARAM NAS CONDICOES ANTERIORES (SAO TODOS DEPRECIAVEIS) >> BEMPATRIMONIAL
GO


-- #INI :: RETORNANDO AS CONSTRAINTS DESABILITADAS
    USE ASI_HOMOLOGA
    GO
    
    BEGIN TRANSACTION
    GO

    PRINT 'Retornando as constraints da tabela BP_TRANSF_INT_BEM'
    ALTER TABLE BP_TRANSF_INT_BEM WITH CHECK CHECK CONSTRAINT ALL;
    COMMIT

    USE GRPDB
    GO

    BEGIN TRANSACTION
    GO

    ALTER TABLE dbo.Depreciacao WITH CHECK CHECK CONSTRAINT ALL;
    ALTER TABLE dbo.DepreciacaoItem WITH CHECK CHECK CONSTRAINT ALL;
    ALTER TABLE dbo.ContaContabilMovimento WITH CHECK CHECK CONSTRAINT ALL;
    ALTER TABLE dbo.ContaContabilMovPatrimonio WITH CHECK CHECK CONSTRAINT ALL;
    
    COMMIT
    PRINT 'Finalizado retorno das constraints!'
-- #FIM :: RETORNANDO AS CONSTRAINTS DESABILITADAS
GO


-- #INI :: CARGA EM CONTACONTABILSALDO :: ESPECIFICO MCTI >> LANCAMENTO DE SALDOS DO MES MAI-2007
    BEGIN TRANSACTION
    GO

    PRINT 'Criando saldos inicais com base no RMB de Mês Fechamento: 200705 ...'
    INSERT INTO dbo.contacontabilsaldo
         ( datacriacao, dataedicao, version, datareferencia, depreciacaoacumulada,  depreciacaomensal,  
           reavaliacaoperiodo, reavaliacaoacumulada, reducaoperiodo, reducaoacumulada, contacontabil_id, valor )
    VALUES
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='04'),   23696.96),  -- APARELHOS DE MEDICAO                
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='06'),  768338.21),  -- APARELHOS E EQUIP. DE COMUNICACAO   
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='08'),    9733.50),  -- APAR. EQUIP. MED. ODONT. LAB. HOSP. 
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='10'),       0.01),  -- AP. E EQUIP. P/ ESPORTE E DIVERSOES 
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='12'),  457305.12),  -- APARELHOS E UTENSILIOS DOMESTICOS   
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='16'),    1100.02),  -- BANDEIRAS, FLAMULAS E INSIGNIAS     
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='18'),    9390.00),  -- COLECOES E MATERIAIS BIBLIOGRAFICOS 
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='24'),   25680.24),  -- EQUIP. PROTECAO SEGURANCA E SOCORRO 
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='28'),     478.35),  -- MAQ.E EQUIP. DE NATUREZA INDUSTRIAL 
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='30'),  191150.23),  -- MAQUINAS E EQUIPAMENTOS ENERGETICOS 
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='32'),   97694.61),  -- MAQUINAS E EQUIPAMENTOS GRAFICOS    
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='33'), 1043665.31),  -- EQUIP.P/ AUDIO VIDEO E FOTO         
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='34'),  248643.20),  -- MAQ. UTENSILIOS E EQUIP. DIVERSOS   
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='35'), 8552683.71),  -- EQUIP. DE PROCESSAMENTO DE DADOS    
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='36'),   31716.84),  -- MAQ. INST.E UTENSILIOS DE ESCRITORIO
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='38'),   14487.87),  -- MAQ., FERRAM. E UTENS. DE OFICINA   
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='40'),       2.59),  -- MAQ. E EQUIP. AGRIC. E RODOVIARIIOS 
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='42'),  877791.25),  -- MOBILIARIO EM GERAL                 
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='44'),       0.30),  -- OBRAS DE ARTE E PECAS PARA MUSEU    
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='48'),    6264.55),  -- VEICULOS DIVERSOS                   
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='51'),    3960.04),  -- PECAS NAO INCORPORAVEIS A IMOVEIS   
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='52'),  159901.29),  -- VEICULOS DE TRACAO MECANICA         
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='87'),   44712.54),  -- MATERIAL DE USO DURADOURO           
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='92'), 1383544.31),  -- ESTOQUE                             
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='93'), 1133514.76),  -- BENS MÓVEIS EM OUTRA UNID. OU TERC. 
         ( GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME), 0, 0, 0, 0, 0, 0, (SELECT TOP 1 ID FROM DBO.CONTACONTABIL WHERE CODIGO='99'),     336.00);  -- OUTROS MATERIAIS PERMANENTES        

    PRINT 'Inicializa saldos zerado para demais contas que não constam no RMB de Mês Fechamento: 200705'
    INSERT INTO dbo.contacontabilsaldo
         ( datacriacao, dataedicao, version, datareferencia, depreciacaoacumulada,  depreciacaomensal,  
           reavaliacaoperiodo, reavaliacaoacumulada, reducaoperiodo, reducaoacumulada, contacontabil_id, valor )
    SELECT GETDATE(), GETDATE(), 0, CAST('2007-07-01 09:26:25' AS DATETIME),
           0, 0, 0, 0, 0, 0, C.ID, 0
      FROM DBO.CONTACONTABIL C 
     WHERE C.ID NOT IN (SELECT CONTACONTABIL_ID FROM DBO.CONTACONTABILSALDO)
       AND C.DOMINIOTIPOMATERIAL_ID = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE='tipoMaterial' AND CODIGO=2);
    
    COMMIT
    PRINT 'Finalizada carga saldo inicial!'
-- #FIM :: CARGA EM CONTACONTABILSALDO :: ESPECIFICO MCTI >> LANCAMENTO DE SALDOS DO MES MAI-2007
GO


-- ################                                                                                         ################
-- ################             )))))  VERIFICAR O ANOMES ATUAL DA REFERENCIA DO CLIENTE  (((((             ################
-- ################                                                                                         ################
-- #INI :: GERACAO DE SALDOS COM DADOS DEPRECIACAO >> CONTACONTABILSALDO
    BEGIN TRANSACTION
    GO

    /*
      SCRIPT QUE GERA O SALDO
      =======================
      1. Definir o mesAtual e anoAtual a partir dos quais você quer gerar o saldo
      2. Definir o mesAnterior e anoAnterior ao saldo que você quer gerar 
         (os saldos já devem estar gerados para esse mês)
      3. Apos o insert definir onde você quer que a funcao pare de gerar saldo,
         ou seja o ultimo mes de referencia fechado no banco
    */
    DECLARE @dom_movent_o BIGINT
          , @dom_movent_e BIGINT
          , @dom_movbai_o BIGINT
          , @dom_movbai_e BIGINT
          , @dom_mat_perm BIGINT
          , @ref_ant_fday DATETIME
          , @ref_ant_lday DATETIME
          , @ref_atu_fday DATETIME
          , @ref_atu_lday DATETIME
          , @ref_fin_fday DATETIME
          , @ref_ant_prnt DATETIME = GETDATE()
          , @conta_cnt_cd NVARCHAR(30)
          , @conta_cnt_id BIGINT
          , @ccs_id       BIGINT

    SET @dom_movent_o = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE = 'tipoMovimentoContaContabil' AND CODIGO = 1)
    SET @dom_movent_e = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE = 'tipoMovimentoContaContabil' AND CODIGO = 3)
    SET @dom_movbai_o = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE = 'tipoMovimentoContaContabil' AND CODIGO = 2)
    SET @dom_movbai_e = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE = 'tipoMovimentoContaContabil' AND CODIGO = 4)
    SET @dom_mat_perm = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE = 'tipoMaterial' AND CODIGO = 2)
    SET @ref_fin_fday = '20100201'
    SET @ref_ant_fday = '20070501'
    SET @ref_ant_lday = DATEADD(MONTH, 1, @ref_ant_fday) - '00:00:01'

    SET @ref_atu_fday = '20070601'
    SET @ref_atu_lday = DATEADD(MONTH, 1, @ref_atu_fday) - '00:00:01'

    PRINT 'Gerando saldos entre [' + CONVERT(VARCHAR(8),@ref_atu_fday,112) + '] e [' + CONVERT(VARCHAR(8),@ref_fin_fday,112) + '] ...'
    WHILE DATEPART(MONTH,@ref_atu_fday) <= DATEPART(MONTH,@ref_fin_fday)
    BEGIN
        IF (@ref_atu_fday<>@ref_ant_prnt)
        BEGIN
            PRINT '  Mês: [' + CONVERT(VARCHAR(6), @ref_atu_fday, 112) + ']...'
            SET @ref_ant_prnt = @ref_atu_fday
        END
 
        SELECT CC.ID     AS contacontabil_id
             , CC.CODIGO AS contacontabil_cd
             , SDO.VALOR AS saldoanterior
             , COALESCE(
                 (SELECT SUM(M.VALOR) -- ENTRADATOTAL
                    FROM CONTACONTABILMOVIMENTO M
                   WHERE CONTACONTABIL_ID = CC.ID 
                     AND M.DATAREFERENCIA BETWEEN @ref_atu_fday AND @ref_atu_lday
                     AND TIPOMOVIMENTOCONTACONTABIL_ID in (@dom_movent_o, @dom_movent_e))
                 , 0)    AS entrada_grp
             , COALESCE(
                 (SELECT SUM(M.VALOR) -- SAIDA
                    FROM CONTACONTABILMOVIMENTO M 
                   WHERE CONTACONTABIL_ID = CC.ID
                     AND M.DATAREFERENCIA BETWEEN @ref_atu_fday AND @ref_atu_lday
                     AND TIPOMOVIMENTOCONTACONTABIL_ID in (@dom_movbai_o, @dom_movbai_e))
                 , 0)    AS saida_grp
        INTO #TMP_SALDO
        FROM DBO.CONTACONTABIL CC
        LEFT JOIN CONTACONTABILSALDO SDO ON SDO.CONTACONTABIL_ID = CC.ID
        AND SDO.DATAREFERENCIA BETWEEN @ref_ant_fday AND @ref_ant_lday
        WHERE CC.DATAINATIVO IS NULL
        AND DOMINIOTIPOMATERIAL_ID = @dom_mat_perm
        ORDER BY CC.ID

        DECLARE cur_ccs CURSOR FAST_FORWARD FOR
            SELECT contacontabil_id, contacontabil_cd
            FROM #TMP_SALDO
        
        OPEN cur_ccs
        FETCH NEXT FROM cur_ccs
            INTO @conta_cnt_id, @conta_cnt_cd
        
        WHILE @@FETCH_STATUS = 0
        BEGIN
             PRINT '    Conta: ' + @conta_cnt_cd;
             INSERT INTO dbo.contacontabilsaldo
                  ( datacriacao
                  , dataedicao
                  , [version]
                  , datareferencia
                  , valor
                  , contacontabil_id
                  , depreciacaoacumulada
                  , depreciacaomensal
                  , reavaliacaoperiodo
                  , reavaliacaoacumulada
                  , reducaoperiodo
                  , reducaoacumulada
                  )
             SELECT GETDATE()
                  , GETDATE()
                  , 0
                  , @ref_atu_fday
                  , (R.SALDOANTERIOR+R.ENTRADA_GRP)+R.SAIDA_GRP
                  , R.CONTACONTABIL_ID
                  , 0
                  , 0
                  , 0
                  , 0
                  , 0
                  , 0
                  FROM #TMP_SALDO R
                  WHERE R.CONTACONTABIL_ID = @conta_cnt_id
            SET @ccs_id = (SELECT IDENT_CURRENT(N'ContaContabilSaldo'))
            
            UPDATE dbo.contacontabilsaldo
               SET depreciacaoacumulada = P.DEPRECIACAOACUMULADA
           , depreciacaomensal = P.DEPRECIACAOATUAL
            FROM ( SELECT SUM(I.VALORDEPRECIACAOACUMULADAATUAL) AS DEPRECIACAOACUMULADA, SUM(I.VALORDEPRECIACAOATUAL) AS DEPRECIACAOATUAL
                   FROM DEPRECIACAOITEM I
                   INNER JOIN #TMP_SALDO R ON (I.CONTACONTABIL_ID = R.CONTACONTABIL_ID AND I.ANOMES = CONVERT(VARCHAR(6),@ref_atu_fday,112))
                  ) AS P
            WHERE id = @ccs_id;

            UPDATE dbo.contacontabilsaldo
               SET reavaliacaoperiodo = P.REAVALIACAOPERIODO, reducaoperiodo = P.REDUCAOPERIODO
            FROM ( SELECT SUM(P.VALORREAVALIACAO) AS REAVALIACAOPERIODO, SUM(P.VALORREDUCAO) AS REDUCAOPERIODO
                   FROM CONTACONTABILMOVPATRIMONIO P
                   INNER JOIN CONTACONTABILMOVIMENTO M ON (M.ID = P.ID)
                   INNER JOIN #TMP_SALDO R ON (M.CONTACONTABIL_ID = R.CONTACONTABIL_ID)
                   WHERE M.DATAREFERENCIA BETWEEN @ref_atu_fday AND @ref_atu_lday
                  ) AS P
            WHERE id = @ccs_id;

            UPDATE dbo.contacontabilsaldo
               SET reavaliacaoacumulada = P.REAVALIACAOACUMULADA, reducaoacumulada = P.REDUCAOACUMULADA
            FROM ( SELECT SUM(P.VALORREAVALIACAO) AS REAVALIACAOACUMULADA, SUM(P.VALORREDUCAO) AS REDUCAOACUMULADA
                   FROM CONTACONTABILMOVPATRIMONIO P
                   INNER JOIN CONTACONTABILMOVIMENTO M ON (M.ID = P.ID)
                   INNER JOIN #TMP_SALDO R ON (M.CONTACONTABIL_ID = R.CONTACONTABIL_ID)
                   WHERE M.DATAREFERENCIA <= @ref_atu_lday
                 ) AS P
            WHERE id = @ccs_id;

            FETCH NEXT FROM cur_ccs
                INTO @conta_cnt_id, @conta_cnt_cd
        END
        CLOSE cur_ccs
        DEALLOCATE cur_ccs
         
        IF DATEPART(month,@ref_atu_fday) = DATEPART(month, @ref_fin_fday)
        BEGIN 
            -- Quando termina de gerar os saldos, atribuir o último no contacontabilsaldoanterior_id
            -- na tabela contacontabil (Necessários para o RMB e fechamento de mês)
            UPDATE dbo.contacontabil
               SET contacontabilsaldoanterior_id =
                 ( SELECT TOP 1 S.ID 
                   FROM DBO.CONTACONTABILSALDO S
                   WHERE S.CONTACONTABIL_ID = ID
                   ORDER BY DATAREFERENCIA DESC );
        END
         
        SET @ref_atu_fday = DATEADD(MONTH, 1, @ref_atu_fday);
        SET @ref_atu_lday = DATEADD(MONTH, 1, @ref_atu_fday) - '00:00:01';

        SET @ref_ant_fday = DATEADD(MONTH, 1, @ref_ant_fday);
        SET @ref_ant_lday = DATEADD(MONTH, 1, @ref_ant_fday) - '00:00:01';
        DROP TABLE #TMP_SALDO
    END

    COMMIT
    PRINT 'Finalizada geração de saldos!'
-- #FIM :: GERACAO DE SALDOS COM DADOS DEPRECIACAO >> CONTACONTABILSALDO
GO


-- #INI :: ZERA OS SALDOS DAS CONTAS COM VALOR NULO >> CONTACONTABILSALDO
    BEGIN TRANSACTION
    GO

    UPDATE dbo.ContaContabilSaldo 
       SET valor = 0.0
     WHERE valor IS NULL

    COMMIT
-- #FIM :: ZERA OS SALDOS DAS CONTAS COM VALOR NULO >> CONTACONTABILSALDO
GO


-- #INI :: GERA SALDOS DE MATERIAIS EM ESTOQUE >> MATERIALESTOQUESALDO
    IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'ix01_movestoque_material' AND Object_ID = Object_ID(N'MovimentoEstoque'))
      CREATE INDEX ix01_movestoque_material ON dbo.MovimentoEstoque (material_id);
    ELSE
      PRINT 'Indice ix01_movestoque_material já existe na tabela MovimentoEstoque'
    GO

    IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'ix02_movestoque_data' AND Object_ID = Object_ID(N'MovimentoEstoque'))
      CREATE INDEX ix02_movestoque_data ON dbo.MovimentoEstoque (datamovimento);
    ELSE
      PRINT 'Indice ix02_movestoque_data já existe na tabela MovimentoEstoque'
    GO
    
    IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'ix01_matestsaldo_material' AND Object_ID = Object_ID(N'MaterialEstoqueSaldo'))
      CREATE INDEX ix01_matestsaldo_material  ON dbo.MaterialEstoqueSaldo (material_id);
    ELSE
      PRINT 'Indice ix01_matestsaldo_material já existe na tabela MaterialEstoqueSaldo'
    GO

    IF NOT EXISTS(SELECT * FROM sys.indexes WHERE Name = N'ix02_matestsaldo_data' AND Object_ID = Object_ID(N'MaterialEstoqueSaldo'))
      CREATE INDEX ix02_matestsaldo_data  ON dbo.MaterialEstoqueSaldo (datareferencia);
    ELSE
      PRINT 'Indice ix02_matestsaldo_data já existe na tabela MaterialEstoqueSaldo'
    GO

    BEGIN TRANSACTION
    GO
        
    DECLARE @ref_atu_fday DATETIME
          , @ref_atu_lday DATETIME
          , @ref_fin_fday DATETIME
          , @ref_ant_lday DATETIME
          , @ref_ant_fday DATETIME
          , @ref_ant_prnt DATETIME = GETDATE()
          , @dom_tp_fecha BIGINT
          , @localestoque BIGINT
          , @material_id  BIGINT
          , @armazena_id  BIGINT
          , @quantidade   NUMERIC(10,2)
          , @valor_media  NUMERIC(10,2)
          , @sdo_anterior NUMERIC(10,2)
          , @vlr_anterior NUMERIC(10,2)
          
    SET @ref_atu_fday = (SELECT CONVERT(DATETIME,CONCAT(CONVERT(VARCHAR(6),ISNULL(MIN(DATAMOVIMENTO),GETDATE()),112),'01'),112) FROM DBO.MOVIMENTOESTOQUE)
    SET @ref_atu_lday = DATEADD(MONTH, 1, @ref_atu_fday) - '00:00:01'

    SET @ref_fin_fday = (SELECT CONVERT(DATETIME,CONCAT(CONVERT(VARCHAR(6),ISNULL(MAX(DATAMOVIMENTO),GETDATE()),112),'01'),112) FROM DBO.MOVIMENTOESTOQUE)

    SET @ref_ant_fday = DATEADD(MONTH, -1, @ref_atu_fday)
    SET @ref_ant_lday = DATEADD(MONTH, 1, @ref_ant_fday) - '00:00:01'

    SET @dom_tp_fecha = (SELECT ID FROM DBO.DOMINIO WHERE CHAVE = 'tipoFechamentoAlmoxarifado' AND CODIGO=2)
    SET @localestoque = (SELECT TOP 1 ID FROM DBO.LOCALESTOQUE)

    PRINT 'Gerando saldos entre [' + CONVERT(VARCHAR(8),@ref_atu_fday,112) + '] e [' + CONVERT(VARCHAR(8),@ref_fin_fday,112) + '] ...'
    WHILE DATEPART(MONTH,@ref_atu_fday) <= DATEPART(MONTH,@ref_fin_fday)
    BEGIN
        IF (@ref_atu_fday<>@ref_ant_prnt)
        BEGIN
            PRINT '  Mês: [' + CONVERT(VARCHAR(6), @ref_atu_fday, 112) + ']...'
            SET @ref_ant_prnt = @ref_atu_fday
        END

        DECLARE cur_materiais CURSOR FAST_FORWARD FOR
            SELECT M.ID AS MATERIAL_ID, C.UNIDADEARMAZENAMENTO_ID
            FROM MATERIAL M
            INNER JOIN MATERIALCONSUMO C ON (M.ID = C.ID)
        
        OPEN cur_materiais
        FETCH NEXT FROM cur_materiais
            INTO @material_id, @armazena_id
        
        WHILE @@FETCH_STATUS = 0
        BEGIN
            SELECT COALESCE(SUM(ME.QUANTIDADE), 0) AS quantidade
                 , COALESCE(SUM(ME.VALORMEDIA), 0) AS valormedia
            INTO #TMP_TOTAISMOVIMENTO
            FROM DBO.MOVIMENTOESTOQUE ME
            WHERE ME.MATERIAL_ID = @material_id
            AND ME.DATAMOVIMENTO BETWEEN @ref_atu_fday AND @ref_atu_lday
            
            SET @quantidade  = (SELECT ISNULL(QUANTIDADE,0) FROM #TMP_TOTAISMOVIMENTO)
            SET @valor_media = (SELECT ISNULL(VALORMEDIA,0) FROM #TMP_TOTAISMOVIMENTO)

            SELECT COALESCE(MS.QUANTIDADE, 0)   AS saldoanterior
                 , COALESCE(MS.VALORFECHADO, 0) AS valoranterior
            INTO #TMP_SALDO
            FROM MATERIALESTOQUESALDO MS
            WHERE MS.MATERIAL_ID = @material_id
            AND MS.DATAREFERENCIA = @ref_ant_fday

            SET @sdo_anterior = (SELECT ISNULL(SALDOANTERIOR,0) FROM #TMP_SALDO)
            SET @vlr_anterior = (SELECT ISNULL(VALORANTERIOR,0) FROM #TMP_SALDO)
            
            IF (@quantidade>0 AND @valor_media>0) OR (@sdo_anterior>0 AND @vlr_anterior>0)
            BEGIN
                INSERT INTO dbo.materialestoquesaldo
                     ( datacriacao, dataedicao, [version], datareferencia
                     , quantidade, valorfechado, organizacao_id, localestoque_id
                     , material_id, tipofechamento_id, unidademedidamaterial_id )
                VALUES
                     ( GETDATE(), GETDATE(), 0, @ref_atu_fday
                     , (@sdo_anterior+@quantidade), (@vlr_anterior+@valor_media), 1, @localestoque
                     , @material_id, @dom_tp_fecha, @armazena_id )

                UPDATE dbo.movimentoestoque
                   SET materialestoquesaldo_id = (SELECT MAX(ID) FROM DBO.MATERIALESTOQUESALDO)
                 WHERE material_id = @material_id
                   AND datamovimento BETWEEN @ref_atu_fday AND @ref_atu_lday
            END
                
      DROP TABLE #TMP_TOTAISMOVIMENTO
      DROP TABLE #TMP_SALDO

            FETCH NEXT FROM cur_materiais
                INTO @material_id, @armazena_id
        END
        CLOSE cur_materiais
        DEALLOCATE cur_materiais
         
        SET @ref_ant_fday = @ref_atu_fday;
        SET @ref_atu_fday = DATEADD(MONTH, 1, @ref_atu_fday);
        SET @ref_atu_lday = DATEADD(MONTH, 1, @ref_atu_fday) - '00:00:01';
    END

    COMMIT
    PRINT 'Finalizada migração de saldos de materiais em estoque!'
-- #FIM :: GERA SALDOS DE MATERIAIS EM ESTOQUE >> MATERIALESTOQUESALDO
GO


SET NOCOUNT OFF
--===========================================================================--
-- ##FIM :: CARGAS E ATUALIZACOES DE SALDOS CONTABEIS/ESTOQUE/MOVIMENTOS     --
--===========================================================================--
