﻿
CREATE INDEX ix01_movimentoestoque_material  ON public.movimentoestoque (material_id);
CREATE INDEX ix01_movimentoestoque_data  ON public.movimentoestoque (datamovimento);
CREATE INDEX ix01_materialestoquesaldo_material  ON public.materialestoquesaldo (material_id);
CREATE INDEX ix01_materialestoquesaldo_dataRef  ON public.materialestoquesaldo (datareferencia);

    DO $$
    DECLARE
      rTotaisMovimento record;
      rSaldo record;
      rMateriais record;
      v_ValorMes numeric;
      v_QuantidadeMes numeric;      
      
      v_dtaIni timestamp without time zone;
      v_dtaIniAnterior timestamp without time zone;
      v_dtaFim timestamp without time zone;
      v_anoMesAtual char(6);
      v_anoMesAnt char(6);
      v_anoMesInicioSaldos char(6);
      v_anoMesFimSaldos char(6);      
      v_organizacao bigint;
      v_localEstoque bigint;
      v_tipoFechamento bigint;
      
    BEGIN
	    v_anoMesInicioSaldos := TO_CHAR((SELECT min(DATAMOVIMENTO) FROM MOVIMENTOESTOQUE), 'YYYYMM');
	    v_anoMesFimSaldos := TO_CHAR((SELECT max(DATAMOVIMENTO) FROM MOVIMENTOESTOQUE), 'YYYYMM');

	    RAISE NOTICE 'ANOMES %', v_anoMesInicioSaldos;
	    RAISE NOTICE 'ANOMES %', v_anoMesFimSaldos;

	    v_dtaIni := TO_TIMESTAMP(v_anoMesInicioSaldos||'01','YYYYMMDD')::timestamp without time zone;	          
	    v_dtaFim := v_dtaIni + interval '1 month' - interval '1 second';	    
	    v_dtaIniAnterior := v_dtaIni - interval '1 month';
	    v_anoMesAnt := TO_CHAR(v_dtaIniAnterior, 'YYYYMM');
	    v_anoMesAtual := TO_CHAR(v_dtaIni, 'YYYYMM');
            

      LOOP            

            RAISE NOTICE 'ANOMES %', v_anoMesAtual;
            Raise notice 'ANOMES Ant %', v_anoMesAnt;

	    FOR rMateriais IN		
		select m.id as material_id, c.UNIDADEARMAZENAMENTO_ID
		from material m
		inner join materialconsumo c on (m.id = c.id)
		--where m.id = 17063667
	    LOOP

		   select
			coalesce(sum(me.quantidade), 0) as qtd,
			coalesce(sum(me.valormedia),0) as total
		   from movimentoestoque me 		   
		   where me.material_id = rMateriais.material_id and me.datamovimento between v_dtaIni and v_dtaFim INTO rTotaisMovimento;		

		  select 
		  	coalesce(s.quantidade, 0) as saldoAnt,
			coalesce(s.valorfechado, 0) as valorAnt
		  from materialestoquesaldo s
		  where s.material_id = rMateriais.material_id and s.datareferencia = v_dtaIniAnterior INTO rSaldo;

		   if ((rTotaisMovimento is not null) and (rTotaisMovimento.qtd > 0 and rTotaisMovimento.total > 0)) or ((rSaldo is not null) and (rSaldo.saldoAnt is not null or rSaldo.saldoAnt > 0) and (rSaldo.valorAnt is not null or rSaldo.valorAnt > 0)) then
			  
			   SELECT ID FROM ORGANIZACAO INTO v_organizacao;
			   SELECT ID FROM LOCALESTOQUE LIMIT 1 INTO v_localEstoque;		
			   SELECT ID FROM DOMINIO WHERE CHAVE = 'tipoFechamentoAlmoxarifado' and CODIGO = 2 into v_tipoFechamento;
			    

			    v_QuantidadeMes = coalesce(coalesce(rSaldo.saldoAnt, 0)+coalesce(rTotaisMovimento.qtd, 0), 0);
			    v_ValorMes = coalesce(coalesce(rSaldo.valorAnt, 0)+coalesce(rTotaisMovimento.total, 0), 0);

			    IF v_QuantidadeMes = 0 then

			    end if;
			   
			    INSERT INTO PUBLIC.MATERIALESTOQUESALDO
			    (
				id,
				datacriacao,
				dataedicao,
				version,
				datareferencia,
				quantidade,
				valorfechado,
				organizacao_id,
				localestoque_id,
				material_id,
				tipofechamento_id,
				unidademedidamaterial_id
			    )
			    VALUES
			    (	NEXTVAL('hibernate_sequence')
				,LOCALTIMESTAMP
				,LOCALTIMESTAMP
				,0 
				,v_dtaIni
				,v_QuantidadeMes
				,v_ValorMes
				,v_organizacao
				,v_localEstoque
				,rMateriais.material_id
				,v_tipoFechamento
				,rMateriais.UNIDADEARMAZENAMENTO_ID
			   );

			   UPDATE MOVIMENTOESTOQUE
			   SET MATERIALESTOQUESALDO_ID = (SELECT MAX(ID) FROM MATERIALESTOQUESALDO)
			   WHERE (MATERIAL_ID = rMateriais.material_id) and (DATAMOVIMENTO BETWEEN v_dtaIni and v_dtaFim);
		 End if;

          END LOOP;

          IF v_anoMesAtual = v_anoMesFimSaldos THEN
		RETURN;
          END IF;

	    v_dtaIniAnterior := v_dtaIni;
            v_dtaIni := v_dtaIni + interval '1 month';	          
	    v_dtaFim := v_dtaIni + interval '1 month' - interval '1 second';	    
	    
	    v_anoMesAnt := to_char(v_dtaIniAnterior, 'YYYYMM');
	    v_anoMesAtual := to_char(v_dtaIni, 'YYYYMM');
      END LOOP;    
	  
    END$$;
	
	--9,23 min maquina Ju para todos os materiais