-- GEOVANE INICIO 03/05/2016

DROP TABLE movimentoestoque;
DROP TABLE materialestoquesaldo;
DROP TABLE materialpermanenteconsumo;
DROP TABLE matpermancons_aud;
DROP TABLE atendimentoreqconsumoitem;
DROP TABLE atendimentorequisicaoconsumo;
DROP TABLE baixaalmoxarifadoitem;
DROP TABLE baixaalmoxarifado;
DROP TABLE baixaalmoxarifado_aud;
DROP TABLE bemalmoxarifadocaracteristica;
DROP TABLE bemalmoxcaract_aud;
DROP TABLE catalogomaterialitem;
DROP TABLE catmaterialunidadeconsreqitem;
DROP TABLE catalogomaterial;
DROP TABLE confignotificacaoressupgrupo;
DROP TABLE confignotificacaoressupusuario;
DROP TABLE confignotificacaoressuprimento;
DROP TABLE devolucaodocumento;
DROP TABLE devolucaoitem;
DROP TABLE devolucaoobservacao;
DROP TABLE devolucao;
DROP TABLE localestoque;
DROP TABLE entradaalmoxarifadoitem;
DROP TABLE entradaalmoxarifadoitem_aud;
DROP TABLE entradaalmoxarifado;
DROP TABLE entradaalmoxarifado_aud;
DROP TABLE requisicaoconsumoitem;
DROP TABLE requisicaoobservacao;
DROP TABLE requisicaoconsumo;
DROP TABLE matconsumotipounidadeentrada;
DROP TABLE matconstpunentrada_aud;
DROP TABLE materialconsumo;
DROP TABLE materialconsumo_aud;
DROP TABLE materialestoquesaldomedio;

-- GEOVANE FIM 03/05/2016

-- GEOVANE INICIO 04/05/2016

CREATE TABLE alm_entrada
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  codigo character varying(30),
  codigoasi character varying(30),
  datacontabil timestamp without time zone,
  datarecebimento timestamp without time zone,
  datareferencia timestamp without time zone NOT NULL,
  iscontabilizada boolean,
  isentradaconcluida boolean,
  notarecebimento character varying(30),
  valortotalnota numeric(20,2),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  almoxarifado_id bigint NOT NULL,
  dominiofinalidade_id bigint NOT NULL,
  dominiotipoentrada_id bigint NOT NULL,
  dominiotiporecebimento_id bigint NOT NULL,
  fornecedor_id bigint NOT NULL,
  unidaderequisitante_id bigint,
  CONSTRAINT alm_entrada_pkey PRIMARY KEY (id),
  CONSTRAINT fk_1xygnb9br1ecqq6s6o0kxrh2b FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_38pxy1g1lvmp75l7t5q89xct9 FOREIGN KEY (fornecedor_id)
      REFERENCES parceiro (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_3om2l7txfuhrmx9x0gjpqqkrt FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_brn5q96f4hisac0125u7dohkb FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_gh15cehetkf5hhevjhwxf8the FOREIGN KEY (dominiotipoentrada_id)
      REFERENCES dominio (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ho50jimfjlhdyitgeatjn7vbq FOREIGN KEY (dominiofinalidade_id)
      REFERENCES dominio (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ijnhgxj6ypv2vw0v7dnunhdmn FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_je6bgbo1bdcqjsmi063lwwnke FOREIGN KEY (dominiotiporecebimento_id)
      REFERENCES dominio (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_lk0uf0t7k7x4jjayurj2dsjpn FOREIGN KEY (almoxarifado_id)
      REFERENCES estruturaorganizacional (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_r86yecl4llcsqej7tpu16wutp FOREIGN KEY (unidaderequisitante_id)
      REFERENCES estruturaorganizacional (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_entrada_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  codigo character varying(30),
  codigoasi character varying(30),
  datacontabil timestamp without time zone,
  datarecebimento timestamp without time zone,
  datareferencia timestamp without time zone,
  iscontabilizada boolean,
  isentradaconcluida boolean,
  notarecebimento character varying(30),
  valortotalnota numeric(20,2),
  autor_id bigint,
  editor_id bigint,
  almoxarifado_id bigint,
  dominiofinalidade_id bigint,
  dominiotipoentrada_id bigint,
  dominiotiporecebimento_id bigint,
  unidaderequisitante_id bigint,
  CONSTRAINT alm_entrada_aud_pkey PRIMARY KEY (id, rev)
);

CREATE TABLE alm_en_documento
(
  id bigint NOT NULL,
  entrada_id bigint,
  entradainativo_id bigint,
  CONSTRAINT alm_en_documento_pkey PRIMARY KEY (id),
  CONSTRAINT fk_8fru5v03lyhh1vwyvlmov1bxy FOREIGN KEY (entrada_id)
      REFERENCES alm_entrada (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_j00m6e8exawjgnu94fnpul4dd FOREIGN KEY (entradainativo_id)
      REFERENCES alm_entrada (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_mr2s56cixxm14rusoc1y2fvhx FOREIGN KEY (id)
      REFERENCES documento (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_en_documento_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  entrada_id bigint,
  entradainativo_id bigint,
  CONSTRAINT alm_en_documento_aud_pkey PRIMARY KEY (id, rev),
  CONSTRAINT fk_3212ajd7yw50pajor8ka9h52j FOREIGN KEY (id, rev)
      REFERENCES documento_aud (id, rev) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_en_observacao
(
  id bigint NOT NULL,
  entrada_id bigint NOT NULL,
  CONSTRAINT alm_en_observacao_pkey PRIMARY KEY (id),
  CONSTRAINT fk_9dk6k1lcoebg1bpfh3n1tw0cj FOREIGN KEY (entrada_id)
      REFERENCES alm_entrada (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_r89ae877jbrenwo0c9s1gv83n FOREIGN KEY (id)
      REFERENCES observacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_estoque
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  almoxarifado_id bigint NOT NULL,
  CONSTRAINT alm_estoque_pkey PRIMARY KEY (id),
  CONSTRAINT fk_1cljoqca3xplogdvv46oa9kax FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_2s26akyafrcm2sctj0klh94h4 FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_7v1dej078tr18555baf3e9n54 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_hgv7qtgwqcd7nnkyxg3e5yws6 FOREIGN KEY (almoxarifado_id)
      REFERENCES estruturaorganizacional (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_mcf55ysgw173k86e686tbgx6n FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT uk_hgv7qtgwqcd7nnkyxg3e5yws6 UNIQUE (almoxarifado_id)
);

CREATE TABLE alm_estoque_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  autor_id bigint,
  editor_id bigint,
  almoxarifado_id bigint,
  CONSTRAINT alm_estoque_aud_pkey PRIMARY KEY (id, rev)
);

CREATE TABLE alm_es_enderecoestoque
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  acomodamaterial boolean,
  codigo character varying(30) NOT NULL,
  descricao character varying(400) NOT NULL,
  endertodomaterial boolean,
  sigla character varying(30),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  endeestoqsuperior_id bigint,
  estoque_id bigint,
  estoqueinativo_id bigint,
  CONSTRAINT alm_es_enderecoestoque_pkey PRIMARY KEY (id),
  CONSTRAINT fk_6m42m9ufi8e091yhslto1xynw FOREIGN KEY (endeestoqsuperior_id)
      REFERENCES alm_es_enderecoestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_7cque00jpsdib3vrm26xkusdd FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_7ndaljqilpb1onj3i47ay28vr FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_b8va70srt4c9cyd2r3flqy3ts FOREIGN KEY (estoqueinativo_id)
      REFERENCES alm_estoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_lun8xpext1c1biblsrjhxhiip FOREIGN KEY (estoque_id)
      REFERENCES alm_estoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_mj0n25iy613xq928u7u31jjvk FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_npvxsokt3fcl4rl1v3ik2ky2k FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT uk_3tn2a36j7pjrt90mvi3o06drp UNIQUE (codigo)
);

CREATE TABLE alm_es_enderecoestoque_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  acomodamaterial boolean,
  codigo character varying(30),
  descricao character varying(400),
  endertodomaterial boolean,
  sigla character varying(30),
  autor_id bigint,
  editor_id bigint,
  endeestoqsuperior_id bigint,
  estoque_id bigint,
  estoqueinativo_id bigint,
  CONSTRAINT alm_es_enderecoestoque_aud_pkey PRIMARY KEY (id, rev)
);

CREATE TABLE alm_materialconsumo
(
  elementodespesa character varying(255),
  id bigint NOT NULL,
  unidadearmazenamento_id bigint NOT NULL,
  CONSTRAINT alm_materialconsumo_pkey PRIMARY KEY (id),
  CONSTRAINT fk_ng0jkg3o090umwff3jeio9jdf FOREIGN KEY (unidadearmazenamento_id)
      REFERENCES unidademedida (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_nv4tvt10k4j217w2v3uc7v9cv FOREIGN KEY (id)
      REFERENCES material (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_materialconsumo_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  elementodespesa character varying(255),
  unidadearmazenamento_id bigint,
  CONSTRAINT alm_materialconsumo_aud_pkey PRIMARY KEY (id, rev),
  CONSTRAINT fk_4tpas7nd065uq1w936621s597 FOREIGN KEY (id, rev)
      REFERENCES material_aud (id, rev) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_materialestoque
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  restomedio numeric(20,4),
  valorunitariomedio numeric(20,4),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  material_id bigint NOT NULL,
  CONSTRAINT alm_materialestoque_pkey PRIMARY KEY (id),
  CONSTRAINT fk_8uu05hib97ph5fx849uneyb1x FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_dmmv4h2uxjke1xmcaaq0cxpbe FOREIGN KEY (material_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_m6nafjqbl1qve5m6w19namkev FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_n9vlft46032ua66eao1iy1i6k FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_nhxlxgb6h6c3m1okq1vohfge FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT uk_dmmv4h2uxjke1xmcaaq0cxpbe UNIQUE (material_id)
);

CREATE TABLE alm_materialestoque_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  restomedio numeric(20,4),
  valorunitariomedio numeric(20,4),
  autor_id bigint,
  editor_id bigint,
  material_id bigint,
  CONSTRAINT alm_materialestoque_aud_pkey PRIMARY KEY (id, rev)
);

CREATE TABLE alm_me_localestoque
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  quantidade numeric(19,2),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  endereco_id bigint NOT NULL,
  enderecoinativo_id bigint,
  materialestoque_id bigint NOT NULL,
  materialestoqueinativo_id bigint,
  unidademedidaentrada_id bigint NOT NULL,
  CONSTRAINT alm_me_localestoque_pkey PRIMARY KEY (id),
  CONSTRAINT fk_438teo7y89v821sfi61hm127g FOREIGN KEY (unidademedidaentrada_id)
      REFERENCES unidademedida (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_edahikxmns0vs1pnoa6ovod82 FOREIGN KEY (materialestoqueinativo_id)
      REFERENCES alm_materialestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_foifpbnon1jfcybg9dlsro9c FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_i4iuf17nxlo7t9v26ejvlr6ud FOREIGN KEY (enderecoinativo_id)
      REFERENCES alm_es_enderecoestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_jsrcjmbvm7pnw3ql1hoiyhamj FOREIGN KEY (materialestoque_id)
      REFERENCES alm_materialestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_owi6smnhuil706bc0ahndgo89 FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_qm5wppxgajf0asko3ov9ykn07 FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_qnx0r3sv9yxte5bholpq15k4p FOREIGN KEY (endereco_id)
      REFERENCES alm_es_enderecoestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_rqrp8dor6nqoh91p9bv9u9yyi FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT uk_jsrcjmbvm7pnw3ql1hoiyhamj UNIQUE (materialestoque_id),
  CONSTRAINT uk_qnx0r3sv9yxte5bholpq15k4p UNIQUE (endereco_id)
);

CREATE TABLE alm_me_localestoque_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  quantidade numeric(19,2),
  autor_id bigint,
  editor_id bigint,
  endereco_id bigint,
  enderecoinativo_id bigint,
  materialestoque_id bigint,
  materialestoqueinativo_id bigint,
  unidademedidaentrada_id bigint,
  CONSTRAINT alm_me_localestoque_aud_pkey PRIMARY KEY (id, rev)
);

CREATE TABLE alm_me_fifoitem
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  quantidadeinicial numeric(20,4) NOT NULL,
  quantidaderestante numeric(20,4) NOT NULL,
  valorsobra numeric(20,4) NOT NULL,
  valortotal numeric(20,4) NOT NULL,
  valorunitario numeric(20,4) NOT NULL,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  material_id bigint NOT NULL,
  materialestoque_id bigint,
  materialestoqueinativo_id bigint,
  CONSTRAINT alm_me_fifoitem_pkey PRIMARY KEY (id),
  CONSTRAINT fk_22i3rv27hwchu5hqbcua33dj4 FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_3pa241s7brr43ml1kgvlrb9e8 FOREIGN KEY (material_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_c1aff1rb22jk8rxfyjw2ahp6p FOREIGN KEY (materialestoque_id)
      REFERENCES alm_materialestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_dr3ga3srn18drk0qykl00mr5 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_k80jc3a46c8i36hhbppqy2t7i FOREIGN KEY (materialestoqueinativo_id)
      REFERENCES alm_materialestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_mc0i03d1p7s6ney7y1hnwulbo FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_t03lnpymhj4fxcvtwg3rs1st9 FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT uk_3pa241s7brr43ml1kgvlrb9e8 UNIQUE (material_id)
);

CREATE TABLE alm_me_fifoitem_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  quantidadeinicial numeric(20,4),
  quantidaderestante numeric(20,4),
  valorsobra numeric(20,4),
  valortotal numeric(20,4),
  valorunitario numeric(20,4),
  autor_id bigint,
  editor_id bigint,
  material_id bigint,
  materialestoque_id bigint,
  materialestoqueinativo_id bigint,
  CONSTRAINT alm_me_fifoitem_aud_pkey PRIMARY KEY (id, rev)
);

CREATE TABLE alm_me_movimentoestoque
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  datamovimento timestamp without time zone NOT NULL,
  idclassereferencia bigint,
  quantidade numeric(19,2),
  valorfifo numeric(20,4),
  valormedia numeric(20,4),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  dominioclassereferencia_id bigint,
  material_id bigint NOT NULL,
  materialestoque_id bigint,
  materiallocalestoque_id bigint,
  tipomovimento_id bigint NOT NULL,
  CONSTRAINT alm_me_movimentoestoque_pkey PRIMARY KEY (id),
  CONSTRAINT fk_2i23htrrm31ummfpwt5sf2bm9 FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_5c9filnq6hohatk9hgl4jv4gc FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_5vrvdeo94atx7eryndteynymr FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_aqnd3i2nqi2k6jty7k5jpa1v8 FOREIGN KEY (materialestoque_id)
      REFERENCES alm_materialestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_kaop9f8yojum5yn743s9ckyw9 FOREIGN KEY (materiallocalestoque_id)
      REFERENCES alm_me_localestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_npkk25ix0nqw69q74rm5fiiqu FOREIGN KEY (material_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_o29xdmxcha63gb8re1m4htq1g FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_piofgnndttb0j8y2akpotqgfv FOREIGN KEY (dominioclassereferencia_id)
      REFERENCES dominio (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_sa7jtn7qy3my47jm1tglcdkh0 FOREIGN KEY (tipomovimento_id)
      REFERENCES dominio (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_me_movimentoestoque_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  datamovimento timestamp without time zone,
  idclassereferencia bigint,
  quantidade numeric(19,2),
  valorfifo numeric(20,4),
  valormedia numeric(20,4),
  autor_id bigint,
  editor_id bigint,
  dominioclassereferencia_id bigint,
  material_id bigint,
  materialestoque_id bigint,
  materiallocalestoque_id bigint,
  tipomovimento_id bigint,
  CONSTRAINT alm_me_movimentoestoque_aud_pkey PRIMARY KEY (id, rev)
);

CREATE TABLE alm_me_saldo
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  datareferencia timestamp without time zone,
  quantidade numeric(19,2),
  valorfechado numeric(20,4),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  localestoque_id bigint,
  material_id bigint,
  tipofechamento_id bigint,
  unidademedidamaterial_id bigint,
  CONSTRAINT alm_me_saldo_pkey PRIMARY KEY (id),
  CONSTRAINT fk_589xlahkulrpqys29gclk6gni FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_6g11acmoqci1mbj4a464l3v7 FOREIGN KEY (localestoque_id)
      REFERENCES alm_me_localestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_6gy8vmoy3wg8v7uhmqljoovqx FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_99mhx5drww5r99ykddu2tg7uc FOREIGN KEY (tipofechamento_id)
      REFERENCES dominio (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_9jcyhumgfyuqoox02ug4sc431 FOREIGN KEY (unidademedidamaterial_id)
      REFERENCES unidademedida (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_o6xycy6ped3gdsdcmchoyxl3y FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_p9a08mrh2jsn8d8hgn0y09iia FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_pvab6hxxw44jvhkjyx9smuv2o FOREIGN KEY (material_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_not_ressuprimento
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  cronexpression character varying(255),
  identificador character varying(255),
  limiteestoque numeric(20,2),
  milissegundocron bigint,
  pontopedido integer,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  localestoque_id bigint NOT NULL,
  materialconsumo_id bigint,
  notificacao_id bigint NOT NULL,
  CONSTRAINT alm_not_ressuprimento_pkey PRIMARY KEY (id),
  CONSTRAINT fk_c7rvw5oa5yiunkyuq6hyr92id FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_dvgtfsqpa4w9326sekcwf8hjn FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_dyj3xdj44hb6pcijjt9ka6u1n FOREIGN KEY (localestoque_id)
      REFERENCES alm_me_localestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_hfj922mlbpwp69umqesvsi9bh FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_jpv4gpk8kypfb2apegmm0pkoi FOREIGN KEY (notificacao_id)
      REFERENCES notificacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_kpxb1byqsspecea7o10xw4ay9 FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_n97xunao8nboa082dnfr07jbx FOREIGN KEY (materialconsumo_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_en_entradaitem
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  datavalidade timestamp without time zone,
  numerolote character varying(255),
  quantidade numeric(19,2),
  valortotal numeric(20,4),
  valorunitario numeric(20,4),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  entrada_id bigint,
  entradainativo_id bigint,
  material_id bigint NOT NULL,
  materiallocalestoque_id bigint NOT NULL,
  unidademedidaentrada_id bigint NOT NULL,
  CONSTRAINT alm_en_entradaitem_pkey PRIMARY KEY (id),
  CONSTRAINT fk_51dvfphluspkpjev6p3brtmmw FOREIGN KEY (entrada_id)
      REFERENCES alm_entrada (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_995rtumo5346s148w5q9qw8t6 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ackxqpap8nt3qk6chb9onl4rj FOREIGN KEY (unidademedidaentrada_id)
      REFERENCES unidademedida (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ak8ldmlglxidulpw4e1qto3dp FOREIGN KEY (material_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_n3hepobqcqgjqno0hcanw5era FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_opbnhs743oeshvg2tt4frjk4y FOREIGN KEY (entradainativo_id)
      REFERENCES alm_entrada (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_r2m81bt0elxvncf8su58px08j FOREIGN KEY (materiallocalestoque_id)
      REFERENCES alm_me_localestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_rkae7uj2vji4kwqvkga7b7ige FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_en_entradaitem_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  datavalidade timestamp without time zone,
  numerolote character varying(255),
  quantidade numeric(19,2),
  valortotal numeric(20,4),
  valorunitario numeric(20,4),
  autor_id bigint,
  editor_id bigint,
  entrada_id bigint,
  entradainativo_id bigint,
  material_id bigint,
  materiallocalestoque_id bigint,
  unidademedidaentrada_id bigint,
  CONSTRAINT alm_en_entradaitem_aud_pkey PRIMARY KEY (id, rev)
);





CREATE TABLE alm_baixa
(
  databaixa timestamp without time zone NOT NULL,
  numerobaixa character varying(30),
  id bigint NOT NULL,
  almoxarifado_id bigint NOT NULL,
  destino_id bigint,
  dominiosituacaoestorno_id bigint NOT NULL,
  dominiotipobaixa_id bigint NOT NULL,
  CONSTRAINT alm_baixa_pkey PRIMARY KEY (id),
  CONSTRAINT fk_3d9f7d4vwqobat8qo6r8jjnea FOREIGN KEY (almoxarifado_id)
      REFERENCES estruturaorganizacional (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_6e4oev8qcuespbgavxe3wm73n FOREIGN KEY (dominiotipobaixa_id)
      REFERENCES dominio (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_dkscfqr5g3ve84gt3sqahekn1 FOREIGN KEY (destino_id)
      REFERENCES parceiro (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_grdxvkfwjpi56v6ps2xo2xfdq FOREIGN KEY (dominiosituacaoestorno_id)
      REFERENCES dominio (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_j9jove8gg2oc5ba6bmtwbauv4 FOREIGN KEY (id)
      REFERENCES baixa (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_baixa_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  databaixa timestamp without time zone,
  numerobaixa character varying(30),
  almoxarifado_id bigint,
  destino_id bigint,
  dominiosituacaoestorno_id bigint,
  dominiotipobaixa_id bigint,
  CONSTRAINT alm_baixa_aud_pkey PRIMARY KEY (id, rev),
  CONSTRAINT fk_5ccgyy8rem29kelqvt82o67kj FOREIGN KEY (id, rev)
      REFERENCES baixa_aud (id, rev) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_bem_caracteristica
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  valorcaracteristica character varying(255),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  caracteristica_id bigint NOT NULL,
  entradaitem_id bigint NOT NULL,
  materialcaracteristica_id bigint NOT NULL,
  CONSTRAINT alm_bem_caracteristica_pkey PRIMARY KEY (id),
  CONSTRAINT fk_9nevva15x4pp5wxkcscw7ycv3 FOREIGN KEY (materialcaracteristica_id)
      REFERENCES materialcaracteristica (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_9o2lc892ugxi43qpfy340kvuf FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_a7yyeopuhh47j3qbm0hjjlsjy FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_cyqjy0cn0837xb7ns870qkrtn FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_pe6990bdkscpphicmmgoj51sh FOREIGN KEY (entradaitem_id)
      REFERENCES alm_en_entradaitem (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_q6g8lkp1krshkcd4uaeobmkwp FOREIGN KEY (caracteristica_id)
      REFERENCES caracteristica (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_r7m2dwpb6g78wftnvox1h4m7r FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_bem_caracteristica_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  valorcaracteristica character varying(255),
  autor_id bigint,
  editor_id bigint,
  caracteristica_id bigint,
  entradaitem_id bigint,
  materialcaracteristica_id bigint,
  CONSTRAINT bemalmoxcaract_aud_pkey PRIMARY KEY (id, rev)
);

CREATE TABLE alm_bx_item
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  dataestorno timestamp without time zone,
  quantidade numeric(20,4),
  total numeric(20,4),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  baixaalmoxarifado_id bigint,
  baixaremocao_id bigint,
  materialconsumo_id bigint,
  CONSTRAINT alm_bx_item_pkey PRIMARY KEY (id),
  CONSTRAINT fk_3xs5ark9djrpghnk3vf07whxg FOREIGN KEY (baixaalmoxarifado_id)
      REFERENCES alm_baixa (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_43k9gp25kqh95gyl84hnq30h FOREIGN KEY (baixaremocao_id)
      REFERENCES alm_baixa (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_4rak32nl2kradw0c3p24shf1h FOREIGN KEY (materialconsumo_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_c2x028qwptoypbiofjchc8tj9 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_d11fqh0tlvnrkgc2b6iei9mdl FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_hnvjoomhkyt6imnufbnj36egp FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_catalogomaterial
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  datafim timestamp without time zone,
  datainicio timestamp without time zone,
  nome character varying(255),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  CONSTRAINT alm_catalogomaterial_pkey PRIMARY KEY (id),
  CONSTRAINT fk_2dhpq4fa38jam1bbvu37swmyn FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_8xum7fb3ob6gqgbmwmayq5cyv FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_e8t6p872p7je4i4q38h9mv16a FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_hxf5rf6v640v3o8d457j7w7e7 FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_cm_item
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  catalogomaterial_id bigint NOT NULL,
  materialconsumo_id bigint NOT NULL,
  CONSTRAINT alm_cm_item_pkey PRIMARY KEY (id),
  CONSTRAINT fk_bnp4h6goh04umd2lvtetul8nh FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_c5g3uvmexica8ughd7ykgfi1j FOREIGN KEY (catalogomaterial_id)
      REFERENCES alm_catalogomaterial (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_cbhwaadbh34310mryn6dq9li3 FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_du9lemgnqhg77avdhujvxaanv FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_epelrqf3aktttgvyv53y1mvp FOREIGN KEY (materialconsumo_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_inuk562194dnsmj58vbr3j126 FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_cm_undreqitem
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  catalogomaterial_id bigint NOT NULL,
  unidaderequisitante_id bigint NOT NULL,
  CONSTRAINT alm_cm_undreqitem_pkey PRIMARY KEY (id),
  CONSTRAINT fk_294s488hbmpuepd6wfls4t3i9 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_5oc7drk4gya0nu35dwqyhdhkr FOREIGN KEY (catalogomaterial_id)
      REFERENCES alm_catalogomaterial (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_akj8kbr08hp3129lks0835e9s FOREIGN KEY (unidaderequisitante_id)
      REFERENCES estruturaorganizacional (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_bahetq98ci8w12tmolm070a8o FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_j2cmc135l6whf86wt0g1el3qy FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_scl46678vlyuwbyubforgplhc FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_requisicaoconsumo
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  datafinalizacaoatendimento timestamp without time zone,
  datarequisicao timestamp without time zone,
  numerorequisicao character varying(30),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  almoxarifado_id bigint NOT NULL,
  centrocusto_id bigint,
  tipostatusrequisicao_id bigint NOT NULL,
  unidaderequisitante_id bigint NOT NULL,
  CONSTRAINT alm_requisicaoconsumo_pkey PRIMARY KEY (id),
  CONSTRAINT fk_2rtcpbfu6j54ytvkrb9jtohif FOREIGN KEY (tipostatusrequisicao_id)
      REFERENCES dominio (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ar232n8scv6owg2ydek8380ou FOREIGN KEY (unidaderequisitante_id)
      REFERENCES estruturaorganizacional (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_e81qkn4fox1hsih8b3v0y8x8o FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_k3tw6c49ngn8xxy1dk9fgm5vy FOREIGN KEY (centrocusto_id)
      REFERENCES centrocusto (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ovunox81s57l0s2675w50yen FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_qpembuodsqupq67fdugrb0a53 FOREIGN KEY (almoxarifado_id)
      REFERENCES estruturaorganizacional (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_rdap15k23q9l952qvjtwtm4h3 FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_tcwvovj7uyyajiss78og4w1lf FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_devolucao
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  codigo character varying(30),
  datadevolucao timestamp without time zone,
  justificativa character varying(500),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  requisicao_id bigint NOT NULL,
  CONSTRAINT alm_devolucao_pkey PRIMARY KEY (id),
  CONSTRAINT fk_a0kk8jgf5w6gmv3fohw54ku5w FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_d63k1orwwrgpixvku8y6v0yqy FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_edejl58jex7jfs18ue1ih1hir FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_h6xpqvti46xu1kqsqxra3lv2a FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_idi0ykj68jgaen3msqtfvy8pd FOREIGN KEY (requisicao_id)
      REFERENCES alm_requisicaoconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_dev_documento
(
  id bigint NOT NULL,
  devolucao_id bigint,
  devolucaoinativo_id bigint,
  CONSTRAINT alm_dev_documento_pkey PRIMARY KEY (id),
  CONSTRAINT fk_jiakoxluai4y62voc6hpdpjw9 FOREIGN KEY (id)
      REFERENCES documento (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_l782dfs40d95akv2qqlyplipc FOREIGN KEY (devolucao_id)
      REFERENCES alm_devolucao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_qtgqs6flkp5apqvj069rj77u6 FOREIGN KEY (devolucaoinativo_id)
      REFERENCES alm_devolucao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_dev_item
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  quantidade numeric(19,2),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  devolucao_id bigint NOT NULL,
  materialconsumo_id bigint NOT NULL,
  CONSTRAINT alm_dev_item_pkey PRIMARY KEY (id),
  CONSTRAINT fk_55xrqu0r4hurduwvvih7d0y26 FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_5llj4rnuytri0v3ocn79f1mal FOREIGN KEY (materialconsumo_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_81jtiv200et09uag46xocbqeq FOREIGN KEY (devolucao_id)
      REFERENCES alm_devolucao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_hwts3vbywpijv5k3gx9788xpw FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_nxs5alywm29dc1f4n8ub4kp66 FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_sulau6l09s8xrduwxqyjoxmi2 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_dev_observacao
(
  id bigint NOT NULL,
  devolucao_id bigint NOT NULL,
  CONSTRAINT alm_dev_observacao_pkey PRIMARY KEY (id),
  CONSTRAINT fk_7smn823j6x5na4q53k7k96we3 FOREIGN KEY (id)
      REFERENCES observacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_cuy6rqe0sod94y0kcjf04iqxv FOREIGN KEY (devolucao_id)
      REFERENCES alm_devolucao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_eo_almoxarifado
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  diasrequisicao character varying(255),
  isalmoxarifado boolean,
  isalmoxarifadopadrao boolean,
  isundconsumidorarequisitante boolean,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  centrocusto_id bigint,
  estruturaorganizacional_id bigint NOT NULL,
  CONSTRAINT alm_eo_almoxarifado_pkey PRIMARY KEY (id),
  CONSTRAINT fk_1a0puuipc4ocvdbq4h39fe3a6 FOREIGN KEY (centrocusto_id)
      REFERENCES centrocusto (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_76mfsc24itxa4n5g1jtpesev1 FOREIGN KEY (estruturaorganizacional_id)
      REFERENCES estruturaorganizacional (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_8getuf8eb63hauqr11k7tcw73 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_d17lg502rqbgl26obix1bq2ho FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_sd63g4y6t38ewo1v7m2s7vmbs FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT uk_76mfsc24itxa4n5g1jtpesev1 UNIQUE (estruturaorganizacional_id)
);

INSERT INTO alm_eo_almoxarifado(id, databloqueio, datainativo, datacriacao, dataedicao, version, diasrequisicao, isalmoxarifado, isalmoxarifadopadrao, isundconsumidorarequisitante,
	inativador_id, autor_id, editor_id, centrocusto_id, estruturaorganizacional_id)
	SELECT alm.id, alm.databloqueio, alm.datainativo, alm.datacriacao, alm.dataedicao, alm.version, alm.diasrequisicao, alm.isalmoxarifado, alm.isalmoxarifadopadrao, alm.isundconsumidorarequisitante,
		alm.inativador_id, alm.autor_id, alm.editor_id, alm.centrocusto_id, alm.estruturaorganizacional_id
	FROM estruturaorganizacionalalmox AS alm;

DROP TABLE estruturaorganizacionalalmox;

CREATE TABLE alm_mc_unidmedidaentrada
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  inativador_id bigint,
  materialconsumo_id bigint,
  materialconsumoremocao_id bigint,
  unidademedida_id bigint NOT NULL,
  CONSTRAINT alm_mc_unidmedidaentrada_pkey PRIMARY KEY (id),
  CONSTRAINT fk_dhm8t4yhha7dqv7pyyppbttkx FOREIGN KEY (unidademedida_id)
      REFERENCES unidademedida (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_e04vl07hegumg3lodcu7g5bj8 FOREIGN KEY (materialconsumoremocao_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ja5nq76b6hs5wcdol4m5k38cj FOREIGN KEY (materialconsumo_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_tou1ikcim2a2qec4bqr9gwp1v FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_mc_unidmedidaentrada_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  materialconsumo_id bigint,
  materialconsumoremocao_id bigint,
  unidademedida_id bigint,
  CONSTRAINT alm_mc_unidmedidaentrada_aud_pkey PRIMARY KEY (id, rev)
);

CREATE TABLE alm_not_res_grupo
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  confignotificaressuprimento_id bigint,
  confignotificaressupremocao_id bigint,
  grupo_id bigint,
  CONSTRAINT alm_not_res_grupo_pkey PRIMARY KEY (id),
  CONSTRAINT fk_5i7ncxc578f98qp4iibtpnlmf FOREIGN KEY (confignotificaressuprimento_id)
      REFERENCES alm_not_ressuprimento (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_8bm0o79i0mtdefjyjmddtlby4 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_9y9ruw57i1i93qmxir7k1rnml FOREIGN KEY (confignotificaressupremocao_id)
      REFERENCES alm_not_ressuprimento (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_c73ivikehs0i74nxihuk2rx08 FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_fvsnovw6rgkxxwg6ikrokqype FOREIGN KEY (grupo_id)
      REFERENCES grupo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_g939p30f7u1ghsurabnfkj1lc FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_nnevrmdpskh6sh10ktwyiiq31 FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_not_res_usuario
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  confignotificaressuprimento_id bigint,
  confignotificaressupremocao_id bigint,
  usuario_id bigint NOT NULL,
  CONSTRAINT alm_not_res_usuario_pkey PRIMARY KEY (id),
  CONSTRAINT fk_52tg7hip8g3qgsinkgf0b3e4 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_e3m1xqkl5yvn074w024l1qpp2 FOREIGN KEY (usuario_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ey9q0b7ndugyy40i2o7udg4rp FOREIGN KEY (confignotificaressuprimento_id)
      REFERENCES alm_not_ressuprimento (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_lyr3ju29kp99yav6t2qn9um1r FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ns1p5keyn8j5clpllpcnmne1n FOREIGN KEY (confignotificaressupremocao_id)
      REFERENCES alm_not_ressuprimento (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_q5151hj1hkal163spejidd6q FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_ro30in3erb0p8jpwi65nrodq4 FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_rc_item
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  quantidade numeric(19,2),
  quantidadeatendida numeric(19,2),
  quantidadedevolvida numeric(19,2),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  materialconsumo_id bigint NOT NULL,
  requisicaoconsumo_id bigint NOT NULL,
  CONSTRAINT alm_rc_item_pkey PRIMARY KEY (id),
  CONSTRAINT fk_3c8qistprafue9af90477bhme FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_c99x6hnjkd5usbsbou4qe40jo FOREIGN KEY (materialconsumo_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_e20htn00lsgfi01p2gvrpdayt FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_l5qufoktjn1lq4qnkv4le13rj FOREIGN KEY (requisicaoconsumo_id)
      REFERENCES alm_requisicaoconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_oqoo2q47mdi9lbeh99kmxjyis FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_trrimun78xirbwnn8pdnnn1kj FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_rc_observacao
(
  id bigint NOT NULL,
  requisicaoconsumo_id bigint NOT NULL,
  CONSTRAINT alm_rc_observacao_pkey PRIMARY KEY (id),
  CONSTRAINT fk_1cd9vgprga28bm3go715m3eas FOREIGN KEY (id)
      REFERENCES observacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_4cq3urvskeegc6dpjl86r96s2 FOREIGN KEY (requisicaoconsumo_id)
      REFERENCES alm_requisicaoconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_rc_atendimento
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  dataatendimento timestamp without time zone,
  numeroatendimento character varying(30),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  requisicaoconsumo_id bigint NOT NULL,
  CONSTRAINT alm_rc_atendimento_pkey PRIMARY KEY (id),
  CONSTRAINT fk_7prcgcdeydc36hqgc9evkyodf FOREIGN KEY (requisicaoconsumo_id)
      REFERENCES alm_requisicaoconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_bwo6wjnhmt3fpc5fnoq0rmv92 FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_c4ntew46noy16bo4yu2rh66tt FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_j1ifnut4jmt2r73xmtqdkv4h2 FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_phc5l7oaasb3ym7cloij4lxv FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_rc_atendimentoitem
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  quantidade numeric(19,2),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  atendimentoreqconsumo_id bigint NOT NULL,
  material_id bigint NOT NULL,
  requisicaoconsumoitem_id bigint NOT NULL,
  CONSTRAINT alm_rc_atendimentoitem_pkey PRIMARY KEY (id),
  CONSTRAINT fk_11fyc09hkikfrmktr7gxyduiy FOREIGN KEY (requisicaoconsumoitem_id)
      REFERENCES alm_rc_item (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_6d4f0998i3ylo9n0p3db5yi4i FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_a7putli22w7uxwjfcle7s3h8f FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_hhpk649se8vba32soog3esf2l FOREIGN KEY (atendimentoreqconsumo_id)
      REFERENCES alm_rc_atendimento (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_jh7bb6ukkhhw29nc6kemyxiv2 FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_or46npdrk4b7cxqn57scgitqt FOREIGN KEY (material_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_pvuivwxu1td48cm0ciku678hn FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE mat_matpermanenteconsumo
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  materialconsumo_id bigint,
  materialpermanente_id bigint,
  CONSTRAINT mat_matpermanenteconsumo_pkey PRIMARY KEY (id),
  CONSTRAINT fk_33w5ws6st88qm6jxro6dc64jf FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_dk8utoxs4y4j7gl2wfefs671u FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_gl4xp5c57fd6h9s4tm8vts7lv FOREIGN KEY (materialconsumo_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_hculumamc3oxvv8bjj1lywpea FOREIGN KEY (materialpermanente_id)
      REFERENCES materialpermanente (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_olx53p76qqit7vcxis44iu2xp FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE mat_matpermanenteconsumo_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  autor_id bigint,
  editor_id bigint,
  materialconsumo_id bigint,
  materialpermanente_id bigint,
  CONSTRAINT mat_matpermanenteconsumo_aud_pkey PRIMARY KEY (id, rev)
);

ALTER TABLE materialcaracteristica DISABLE TRIGGER ALL;
ALTER TABLE material               DISABLE TRIGGER ALL;
ALTER TABLE contacontabilmovimento DISABLE TRIGGER ALL;
ALTER TABLE entradaobservacao      DISABLE TRIGGER ALL;
ALTER TABLE entradadocumento       DISABLE TRIGGER ALL;
ALTER TABLE entrada                DISABLE TRIGGER ALL;

DELETE FROM materialcaracteristica WHERE material_id IN (SELECT id FROM material WHERE dominiotipomaterial_id = (SELECT id FROM dominio WHERE chave = 'tipoMaterial' AND codigo = 1));
DELETE FROM material WHERE dominiotipomaterial_id = (SELECT id FROM dominio WHERE chave = 'tipoMaterial' AND codigo = 1);

DELETE FROM contacontabilmovimento WHERE entrada_id NOT IN (SELECT id FROM entradapatrimonio);
DELETE FROM entradaobservacao WHERE entrada_id NOT IN (SELECT id FROM entradapatrimonio);
DELETE FROM entradadocumento WHERE entrada_id IS NOT null AND entrada_id NOT IN (SELECT id FROM entradapatrimonio);
DELETE FROM entradadocumento WHERE entrada_id IS NOT null AND entradainativo_id NOT IN (SELECT id FROM entradapatrimonio);
DELETE FROM entrada WHERE id NOT IN (SELECT id FROM entradapatrimonio);

ALTER TABLE materialcaracteristica ENABLE TRIGGER ALL;
ALTER TABLE material               ENABLE TRIGGER ALL;
ALTER TABLE contacontabilmovimento ENABLE TRIGGER ALL;
ALTER TABLE entradaobservacao      ENABLE TRIGGER ALL;
ALTER TABLE entradadocumento       ENABLE TRIGGER ALL;
ALTER TABLE entrada                ENABLE TRIGGER ALL;

-- GEOVANE FIM 04/05/2016

-- ERICK INICIO 04/05/2016

INSERT INTO menufile (id, datacriacao, dataedicao, version, ativo, caminho, dominiomenufile_id, menu_id)
VALUES (NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, true, '/cit-almoxarifado-web/assets/js/angular/custom/repository/MaterialEnderecoEstoqueRepository.js',
	(SELECT id FROM dominio WHERE chave = 'tipoFile' AND codigo = 2), (SELECT id FROM menu WHERE chave = 'USUARIO'));

INSERT INTO menufile (id, datacriacao, dataedicao, version, ativo, caminho, dominiomenufile_id, menu_id)
VALUES (NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, true, '/cit-almoxarifado-web/assets/js/angular/custom/repository/MaterialEnderecoEstoqueRepository.min.js',
	(SELECT id FROM dominio WHERE chave = 'tipoFile' AND codigo = 2), (SELECT id FROM menu WHERE chave = 'USUARIO'));

INSERT INTO menufile (id, datacriacao, dataedicao, version, ativo, caminho, dominiomenufile_id, menu_id)
VALUES (NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, true, '/cit-almoxarifado-web/assets/js/angular/custom/repository/MaterialLocalEstoqueRepository.js',
	(SELECT id FROM dominio WHERE chave = 'tipoFile' AND codigo = 2), (SELECT id FROM menu WHERE chave = 'USUARIO'));

INSERT INTO menufile (id, datacriacao, dataedicao, version, ativo, caminho, dominiomenufile_id, menu_id)
VALUES (NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, true, '/cit-almoxarifado-web/assets/js/angular/custom/repository/MaterialLocalEstoqueRepository.min.js',
	(SELECT id FROM dominio WHERE chave = 'tipoFile' AND codigo = 2), (SELECT id FROM menu WHERE chave = 'USUARIO'));


ALTER TABLE alm_me_localestoque ALTER COLUMN unidadeMedidaEntrada_id DROP NOT NULL;
ALTER TABLE alm_me_localestoque ADD COLUMN  localPrincipal BOOLEAN;

ALTER TABLE alm_me_localestoque_aud ADD COLUMN  localPrincipal BOOLEAN;

ALTER TABLE alm_me_localestoque DROP CONSTRAINT uk_jsrcjmbvm7pnw3ql1hoiyhamj;
ALTER TABLE alm_me_localestoque DROP CONSTRAINT uk_qnx0r3sv9yxte5bholpq15k4p;
-- ERICK FIM 04/05/2016

-- JOYFAS INICIO 06/05/16
alter table alm_mc_unidmedidaentrada add isPadrao boolean;

alter table alm_mc_unidmedidaentrada_aud add isPadrao boolean;
-- JOYFAS FIM 06/05/16

-- THIAGO INICIO 09/05/2016
delete from menufile where menu_id = (select id from menu where chave = 'UNIDADE_DE_MEDIDA');
delete from menugrupo where menu_id = (select id from menu where chave = 'UNIDADE_DE_MEDIDA') OR menuremocao_id = (select id from menu where chave = 'UNIDADE_DE_MEDIDA');
delete from menu where chave = 'UNIDADE_DE_MEDIDA'; 
delete from pagina where nome = 'Unidade de medida';
-- THIAGO FIM 09/05/2016


-- Erick INICIO 09/05/2016

INSERT INTO menufile (id, datacriacao, dataedicao, version, ativo, caminho, dominiomenufile_id, menu_id)
VALUES (NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, true, '/cit-almoxarifado-web/assets/js/angular/custom/repository/TransferenciaEnderecoEstoqueRepository.js',
	(SELECT id FROM dominio WHERE chave = 'tipoFile' AND codigo = 2), (SELECT id FROM menu WHERE chave = 'USUARIO'));

INSERT INTO menufile (id, datacriacao, dataedicao, version, ativo, caminho, dominiomenufile_id, menu_id)
VALUES (NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, true, '/cit-almoxarifado-web/assets/js/angular/custom/repository/TransferenciaEnderecoEstoqueRepository.min.js',
	(SELECT id FROM dominio WHERE chave = 'tipoFile' AND codigo = 2), (SELECT id FROM menu WHERE chave = 'USUARIO'));

ALTER TABLE alm_me_localestoque ADD COLUMN capacidade NUMERIC(19,2);

CREATE TABLE alm_ee_transferencia
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  datatransferencia timestamp without time zone NOT NULL,
  quantidade numeric(19,2),
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  almoxarifado_id bigint NOT NULL,
  enderecoestoquedestino_id bigint NOT NULL,
  enderecoestoqueorigem_id bigint NOT NULL,
  material_id bigint NOT NULL,
  CONSTRAINT alm_ee_transferencia_pkey PRIMARY KEY (id),
  CONSTRAINT fk_21a1us9qpemu3lgu5jbqdisgu FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_2b2rfe5o4p8j8sic2kmxay32m FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_9a6wpagfkhydwsdbsxq8gqd3q FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_d6dff7rdhktoxacwlveu0w6to FOREIGN KEY (enderecoestoquedestino_id)
      REFERENCES alm_me_localestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_fdpifqxokpxfbeqjsh21as37d FOREIGN KEY (almoxarifado_id)
      REFERENCES estruturaorganizacional (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_fl7mat880ri95y9qg6q0rdc7y FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_kfotr1rwotdhx4xjj38yj8l72 FOREIGN KEY (enderecoestoqueorigem_id)
      REFERENCES alm_me_localestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_tou1v0a8mfd68auhh7imc6vw6 FOREIGN KEY (material_id)
      REFERENCES alm_materialconsumo (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT uk_tou1v0a8mfd68auhh7imc6vw6 UNIQUE (material_id)
);

CREATE TABLE alm_ee_transferencia_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  datatransferencia timestamp without time zone,
  quantidade numeric(19,2),
  autor_id bigint,
  editor_id bigint,
  almoxarifado_id bigint,
  enderecoestoquedestino_id bigint,
  enderecoestoqueorigem_id bigint,
  material_id bigint,
  CONSTRAINT alm_ee_transferencia_aud_pkey PRIMARY KEY (id, rev)
);


-- RONAN INICIO 09/05/2016 --
ALTER TABLE alm_me_localestoque_aud ADD COLUMN capacidade NUMERIC(19,2);

update pessoa set email = null where email = ' ';
-- RONAN FIM 09/05/2016

-- ERick INICIO 10/05/2016
/* 
 * SCRIPT PARA REMOVER TERMO RESPONSABILIDADE GERADO PELA TRANSFERENCIA E RESET DA NUMERACAO DO TERMO RESPONSABILIDADE
 * 
 * DE ACORDO COM HALINE: 
 * [16:24:25] Haline Moreira: deixa que eu controlo em qual cliente vamos rodar.
 * 

DELETE from TermoResponsabilidade where numerotermo ilike '2016%' AND TRANSFERENCIA_ID IS NOT NULL;

DO $$ 
DECLARE   
r record;
BEGIN

FOR r IN
	select id, row_number() OVER (ORDER BY ID) AS num from TermoResponsabilidade where numerotermo ilike '2016%'
LOOP
	update TermoResponsabilidade 
	set numerotermo = '2016'||lpad(r.num::text, 6, '0')
	where id = r.id;
	
END LOOP;
END$$; 

*/   
-- ERICK FIM 10/05/2016
-- GEOVANE 10/05/2016
ALTER TABLE alm_me_fifoitem DROP CONSTRAINT IF EXISTS uk_3pa241s7brr43ml1kgvlrb9e8;

ALTER TABLE alm_me_fifoitem ADD COLUMN entradaitem_id bigint,
	ADD CONSTRAINT fk_fifoitem_entradaalmoxarifadoitem FOREIGN KEY (entradaitem_id)
		REFERENCES alm_en_entradaitem (id) MATCH SIMPLE
		ON UPDATE NO ACTION ON DELETE NO ACTION;
		
ALTER TABLE alm_me_movimentoestoque ADD COLUMN materialestoqueinativo_id bigint,
	ADD CONSTRAINT fk_movimentoestoque_materialestoqueinativo FOREIGN KEY (materialestoqueinativo_id)
		REFERENCES alm_materialestoque (id) MATCH SIMPLE
		ON UPDATE NO ACTION ON DELETE NO ACTION;
		
ALTER TABLE alm_me_movimentoestoque_aud ADD COLUMN materialestoqueinativo_id bigint;
		
-- GEOVANE FIM 10/05/2016


-- RONAN INICIO 12/05/2016
update historicobempatrimonial hbp set codigooperacao = e.codigo 
	from entrada e
	where e.id = hbp.idclassereferencia and hbp.codigooperacao is null
	and hbp.dominioclassereferencia_id = (
	   select id from dominio where chave = 'classeReferencia' and codigo = 1);

update historicobempatrimonial hbp set codigooperacao = b.codigo 
	from baixapatrimonio b
	where b.id = hbp.idclassereferencia and hbp.codigooperacao is null
	and hbp.dominioclassereferencia_id = (
	   select id from dominio where chave = 'classeReferencia' and codigo = 2);

update historicobempatrimonial hbp set codigooperacao = t.codigo 
	from transferencia t
	where t.id = hbp.idclassereferencia and hbp.codigooperacao is null
	and hbp.dominioclassereferencia_id in (
	   select id from dominio where chave = 'classeReferencia' and (codigo = 3 or codigo = 4));

update historicobempatrimonial hbp set codigooperacao = s.codigo 
	from saidatemporaria s
	where s.id = hbp.idclassereferencia and hbp.codigooperacao is null
	and hbp.dominioclassereferencia_id = (
	   select id from dominio where chave = 'classeReferencia' and codigo = 9);

update historicobempatrimonial hbp set codigooperacao = d.codigo 
	from definicaodetentor d
	where d.id = hbp.idclassereferencia and hbp.codigooperacao is null
	and hbp.dominioclassereferencia_id = (
	   select id from dominio where chave = 'classeReferencia' and codigo = 10);
-- RONAN FIM 12/05/2016

-- ERICK INICIO 12/05/2016

ALTER TABLE alm_ee_transferencia DROP CONSTRAINT fk_tou1v0a8mfd68auhh7imc6vw6;
-- ERICK FIM 12/05/2016

-- GEOVANE INICIO 13/05/2016
ALTER TABLE alm_me_fifoitem_aud ADD COLUMN entradaitem_id bigint;
-- GEOVANE FIM 13/05/2016

-- ERICK INICIO 12/05/2016

ALTER TABLE alm_ee_transferencia DROP CONSTRAINT uk_tou1v0a8mfd68auhh7imc6vw6;
-- ERICK FIM 12/05/2016

-- GEOVANE INICIO 14/05/2016
ALTER TABLE alm_en_entradaitem ALTER COLUMN materiallocalestoque_id DROP NOT NULL;
-- GEOVANE FIM 14/05/2016

-- ERick INICIO 16/05/2016
UPDATE INTERNACIONALIZACAO SET MODULO_ID = (SELECT ID FROM MODULO WHERE CHAVE = 'PATRIMONIO') WHERE CHAVE = 'VALIDACAO.DEFINICAO_DETENTOR_ANTERIOR_ULTIMA_OPERACAO';
-- ERick FIM 16/05/2016