-- THIAGO INICIO 18/05/2016
INSERT INTO configuracaoparametrosistema (
	    id, datacriacao, dataedicao, version, 
	    chave, valor, configuracao_id) 
VALUES (
	 NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, 0, 
	 'TIPO_CONFIGURACAO_UNIDADE_MEDIDA_ENTRADA', '1', 1);


INSERT INTO dominio (
	    id,datacriacao,dataedicao,version,
	    chave,codigo,descricao,nome) 
VALUES(
	(SELECT NEXTVAL('hibernate_sequence')),
	LOCALTIMESTAMP,	LOCALTIMESTAMP,0,'tipoConfiguracaoUnidadeMedida',
	1,'Considerar a mesma unidade de medida de armazenamento',
	'UNIDADE_MEDIDA_ARMAZENAMENTO');
	
INSERT INTO dominio (
	    id,datacriacao,dataedicao,version,
	    chave,codigo,descricao,nome) 
VALUES(
	(SELECT NEXTVAL('hibernate_sequence'))	,
	LOCALTIMESTAMP,	LOCALTIMESTAMP,0,'tipoConfiguracaoUnidadeMedida',
	2,'Permitir múltiplas unidades de medida de entrada',
	'PERMITIR_MULTIPLAS_UNIDADES_MEDIDA');
-- THIAGO FIM 18/05/2016	
	
	
-- GEOVANE INICIO 24/05/2016
	
DO $$

	DECLARE r record;
	BEGIN 
	
	FOR r IN (SELECT id FROM configuracao) LOOP 
		
		IF NOT EXISTS (SELECT id FROM configuracaoparametrosistema WHERE configuracao_id = r.id AND chave = 'MARGEM_ERRO_PRECO_MEDIO') THEN
		INSERT INTO configuracaoparametrosistema(id, datacriacao, dataedicao, version, chave, isobrigatorio, valor, configuracao_id)
			VALUES(NEXTVAL('hibernate_sequence'),
					LOCALTIMESTAMP,
					LOCALTIMESTAMP,
					0,
					'MARGEM_ERRO_PRECO_MEDIO',
					true,
					'20',
					r.id);
		END IF;
	
	END LOOP;

END $$;

INSERT INTO alm_mc_unidmedidaentrada(id, materialconsumo_id, unidademedida_id, ispadrao)
	SELECT NEXTVAL('hibernate_sequence') AS id,
		mat.id AS materialconsumo_id,
		mat.unidadearmazenamento_id AS unidademedida_id,
		false AS ispadrao
	FROM alm_materialconsumo mat
	WHERE mat.unidadearmazenamento_id NOT IN (
		SELECT unidademedida_id FROM alm_mc_unidmedidaentrada WHERE materialconsumo_id = mat.id
		);
		
UPDATE
    alm_mc_unidmedidaentrada und
SET
    ispadrao = true
FROM
    (SELECT mat.id, mat.unidadearmazenamento_id FROM alm_materialconsumo mat WHERE
	(SELECT count(*) FROM alm_mc_unidmedidaentrada WHERE materialconsumo_id = mat.id AND ispadrao = true) = 0) AS undidadesEnt
WHERE
    und.materialconsumo_id = undidadesEnt.id AND und.unidademedida_id = undidadesEnt.unidadearmazenamento_id;
	
-- GEOVANE FIM 24/05/2016
-- ERICK INICIO 16/05/2016
DELETE FROM alm_bem_caracteristica CASCADE;
DELETE FROM alm_me_fifoitem CASCADE;
DELETE FROM alm_en_documento CASCADE;
DELETE FROM alm_en_entradaitem CASCADE;
DELETE FROM alm_en_observacao CASCADE;
DELETE FROM alm_entrada CASCADE;
DELETE FROM alm_me_movimentoestoque CASCADE;
DELETE FROM alm_me_localestoque CASCADE;
DELETE FROM alm_materialestoque CASCADE;
    
DELETE FROM alm_rc_atendimentoitem CASCADE;
DELETE FROM alm_rc_atendimento CASCADE;

DELETE FROM alm_rc_item CASCADE;
DELETE FROM alm_rc_observacao CASCADE;
DELETE FROM alm_requisicaoconsumo CASCADE;

DELETE FROM DOMINIO WHERE CHAVE = 'tipoStatusRequisicao';

INSERT INTO dominio 
(id, datacriacao, dataedicao, datainativo, version, chave, descricao, nome, codigo, ispadrao) 
VALUES 
(NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, NULL, 0, 'tipoStatusRequisicao', 'Atendida parcialmente', 'ATENDIDA_PARCIALMENTE', 1, false),
(NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, NULL, 0, 'tipoStatusRequisicao', 'Pronta para atendimento', 'PRONTA_PARA_ATENDIMENTO', 2, false),
(NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, NULL, 0, 'tipoStatusRequisicao', 'Não concluída', 'NAO_CONCLUIDA', 3, false),  
(NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, NULL, 0, 'tipoStatusRequisicao', 'Devolvida', 'DEVOLVIDA', 4, false),     
(NEXTVAL('hibernate_sequence'), LOCALTIMESTAMP, LOCALTIMESTAMP, NULL, 0, 'tipoStatusRequisicao', 'Finalizada', 'FINALIZADA', 5, false);  
-- ERICK FIM 16/05/2016

-- RONAN INICIO 18/05/2016

ALTER TABLE alm_rc_atendimentoitem ADD COLUMN materiallocalestoque_id bigint;
ALTER TABLE alm_rc_atendimentoitem
  ADD CONSTRAINT fk_hx3srtvuubkwfds6s3bckj3yp FOREIGN KEY (materiallocalestoque_id)
      REFERENCES public.alm_me_localestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;
      
-- RONAN FIM 18/05/2016    
      
      
-- ERICK INICIO 19/05/2016

      CREATE TABLE alm_rc_atendimento_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  dataatendimento timestamp without time zone,
  numeroatendimento character varying(30),
  autor_id bigint,
  editor_id bigint,
  requisicaoconsumo_id bigint
);

CREATE TABLE alm_requisicaoconsumo_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  datafinalizacaoatendimento timestamp without time zone,
  datarequisicao timestamp without time zone,
  numerorequisicao character varying(30),
  autor_id bigint,
  editor_id bigint,
  almoxarifado_id bigint,
  centrocusto_id bigint,
  tipostatusrequisicao_id bigint,
  unidaderequisitante_id bigint
);

CREATE TABLE centrocusto_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  codigo character varying(30),
  descricao character varying(255),
  autor_id bigint,
  editor_id bigint,
  centrocustoparent_id bigint
);


CREATE TABLE alm_rc_item_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  quantidade numeric(19,2),
  quantidadeatendida numeric(19,2),
  quantidadedevolvida numeric(19,2),
  autor_id bigint,
  editor_id bigint,
  materialconsumo_id bigint,
  requisicaoconsumo_id bigint
);


CREATE TABLE alm_rc_atenditem_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  quantidade numeric(19,2),
  autor_id bigint,
  editor_id bigint,
  atendimentoreqconsumo_id bigint,
  material_id bigint,
  materiallocalestoque_id bigint,
  requisicaoconsumoitem_id bigint
);

-- ERICK FIM 19/05/2016      

-- ERICK INICIO 20/05/2016
ALTER TABLE alm_requisicaoconsumo ADD COLUMN emAtendimento BOOLEAN DEFAULT FALSE;
ALTER TABLE alm_requisicaoconsumo_aud ADD COLUMN emAtendimento BOOLEAN; 

ALTER TABLE alm_requisicaoconsumo ADD COLUMN atendente_id BIGINT;
ALTER TABLE alm_requisicaoconsumo_aud ADD COLUMN atendente_id BIGINT; 

ALTER TABLE ONLY alm_requisicaoconsumo
ADD CONSTRAINT fk_req_atendente FOREIGN KEY (atendente_id) REFERENCES seguranca_usuario(id);
-- ERICK FIM 20/05/2016

-- RONAN INICIO 19/05/2016

alter table alm_rc_atendimentoitem drop column quantidade;
alter table alm_rc_atendimentoitem drop constraint fk_hx3srtvuubkwfds6s3bckj3yp;
alter table alm_rc_atendimentoitem drop column materiallocalestoque_id;

CREATE TABLE alm_rc_at_item_endereco
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  quantidade numeric(19,2),
  inativador_id bigint,
  at_req_consumoitem_id bigint NOT NULL,
  materiallocalestoque_id bigint NOT NULL,
  CONSTRAINT alm_rc_at_item_endereco_pkey PRIMARY KEY (id),
  CONSTRAINT fk_7ep45inuirh29oxc70t085n7t FOREIGN KEY (at_req_consumoitem_id)
      REFERENCES public.alm_rc_atendimentoitem (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_9tdi5v43fn5qtt3n4wn2c9ma4 FOREIGN KEY (materiallocalestoque_id)
      REFERENCES public.alm_me_localestoque (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_g385pn6ltxma9nmkq8sohtkw2 FOREIGN KEY (inativador_id)
      REFERENCES public.seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

-- RONAN FIM 19/05/2016

-- Erick INICIO 23/05/2016
CREATE TABLE alm_rc_at_item_end_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  quantidade numeric(19,2),
  at_req_consumoitem_id bigint,
  materiallocalestoque_id bigint
);

-- ERICK FIM 23/05/2016

-- Erick INICIO 24/05/2016
CREATE TABLE alm_rc_atendimentoitemfifo
(
  id bigint NOT NULL,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone NOT NULL,
  dataedicao timestamp without time zone NOT NULL,
  version bigint,
  quantidadeutilizada numeric(20,4) NOT NULL,
  inativador_id bigint,
  autor_id bigint,
  editor_id bigint,
  organizacao_id bigint,
  at_req_consumoitem_id bigint NOT NULL,
  materialestoquefifoitem_id bigint,
  CONSTRAINT alm_rc_atendimentoitemfifo_pkey PRIMARY KEY (id),
  CONSTRAINT fk_182ti3frfvwwapjtm4qkhoyao FOREIGN KEY (inativador_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_97ui5rhx7nsr6h8eourfsxct0 FOREIGN KEY (at_req_consumoitem_id)
      REFERENCES alm_rc_atendimentoitem (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_cvmj6dr7enhmoi7huv9rjf2sp FOREIGN KEY (organizacao_id)
      REFERENCES organizacao (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_pfax4c9citfm74ok7q8oe7m2l FOREIGN KEY (autor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_r6b6iwwn5nu263ulnugc55o8a FOREIGN KEY (editor_id)
      REFERENCES seguranca_usuario (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_s34cvykt2pw5kmw63ctdod3hi FOREIGN KEY (materialestoquefifoitem_id)
      REFERENCES alm_me_fifoitem (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

CREATE TABLE alm_rc_atitfifo_aud
(
  id bigint NOT NULL,
  rev integer NOT NULL,
  revtype smallint,
  databloqueio date,
  datainativo date,
  datacriacao timestamp without time zone,
  dataedicao timestamp without time zone,
  quantidadeutilizada numeric(20,4),
  autor_id bigint,
  editor_id bigint,
  at_req_consumoitem_id bigint,
  materialestoquefifoitem_id bigint
);
-- Erick FIM 24/05/2016

-- GEOVANE INICIO 30/05/2016
ALTER TABLE contacontabilmovimento DISABLE TRIGGER ALL;

DELETE FROM contacontabilmovimento WHERE contacontabil_id IN (SELECT id FROM contacontabil WHERE dominiotipomaterial_id = 655);

ALTER TABLE contacontabilmovimento ENABLE TRIGGER ALL;
-- GEOVANE FIM 30/05/2016
--JOYFAS INICIO 31/05/2016
ALTER TABLE seguranca_usuario ADD COLUMN nome CHARACTER VARYING(255);
--JOYFAS FIM