package br.com.citsmart.api.service.impl;

import java.math.BigDecimal;

import org.jbehave.Ensure;
import org.jbehave.scenario.annotations.Given;
import org.jbehave.scenario.annotations.Then;
import org.jbehave.scenario.annotations.When;
import org.jbehave.scenario.steps.Steps;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Spy;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.ContaContabilDao;
import br.com.centralit.api.model.ContaContabil;
import br.com.centralit.api.service.impl.ContaContabilServiceImpl;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 02/10/2015 - 18:27:07
 *
 * @version 1.0.0
 *
 * @author gilberto.nery
 *
 */
public class DepreciacaoBemPatrimonialSteps extends Steps {

	@InjectMocks
    private ContaContabil contaContabil = new ContaContabil();

	@Mock
	ContaContabilDao contaContabilDao;

	@Mock
	Validator validator;

	@Spy
	private ContaContabilServiceImpl contaContabilServiceImpl = new ContaContabilServiceImpl(contaContabilDao, validator);

	@Given("Uma conta com $diasUteis dias uteis")
	public void setUp(String  diasUteis) {

		contaContabil.setVidaUtil(new Integer(diasUteis));

	}

	@When("realizo o calculo")
	public void checkSenha() {

		contaContabil = contaContabilServiceImpl.calcularTaxaDepreciacao(contaContabil);

	}

	@Then("retornar o valor $valor")
	public void checkMessagem(String valor){
		Ensure.ensureThat(contaContabil.getTaxaDepreciacaoMensal().compareTo(new BigDecimal(valor)) == 0);
	}

}