package br.com.citsmart.api.service.impl;

import static org.junit.Assert.assertTrue;

import java.math.BigDecimal;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Spy;
import org.mockito.runners.MockitoJUnitRunner;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.ContaContabilDao;
import br.com.centralit.api.model.ContaContabil;
import br.com.centralit.api.service.impl.ContaContabilServiceImpl;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 01/10/2015 - 11:10:12
 *
 * @version 1.0.0
 *
 * @author gilberto.nery
 *
 */
@RunWith(MockitoJUnitRunner.class)
public class TestContaContabilServiceImpl {

	@InjectMocks
    private ContaContabil contaContabil = new ContaContabil();

	@Mock
	ContaContabilDao contaContabilDao;

	@Mock
	Validator validator;

	@Spy
	private ContaContabilServiceImpl contaContabilServiceImpl = new ContaContabilServiceImpl(contaContabilDao, validator);

	@Test
	public void testCalcularTaxaDepreciacao() {

		// Teste Positivo
		contaContabil.setVidaUtil(0);
		contaContabil = contaContabilServiceImpl.calcularTaxaDepreciacao(contaContabil);
		assertTrue(contaContabil.getTaxaDepreciacaoMensal().compareTo(new BigDecimal("0.0")) == 0);

		// Teste Positivo
		contaContabil.setVidaUtil(120);
		contaContabil = contaContabilServiceImpl.calcularTaxaDepreciacao(contaContabil);
		assertTrue(contaContabil.getTaxaDepreciacaoMensal().equals(new BigDecimal("0.0083")));

		// Teste Positivo
		contaContabil.setVidaUtil(null);
		contaContabil = contaContabilServiceImpl.calcularTaxaDepreciacao(contaContabil);
		assertTrue(contaContabil.getTaxaDepreciacaoMensal().compareTo(new BigDecimal("0.0")) == 0);

		// Teste negativo
		contaContabil.setVidaUtil(120);
		contaContabil = contaContabilServiceImpl.calcularTaxaDepreciacao(contaContabil);
		assertTrue(!contaContabil.getTaxaDepreciacaoMensal().equals(new BigDecimal("0.0125")));

		// Teste Positivo
		contaContabil.setVidaUtil(80);
		contaContabil = contaContabilServiceImpl.calcularTaxaDepreciacao(contaContabil);
		assertTrue(contaContabil.getTaxaDepreciacaoMensal().equals(new BigDecimal("0.0125")));

	}

}