package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import br.com.centralit.api.model.MaterialCaracteristica;
import br.com.centralit.api.service.MaterialCaracteristicaService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.Views;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 23/12/2014 - 15:57:09
 *
 * @version 1.0.0
 *
 * @author rogerio.costa
 *
 */
@Controller
@RequestMapping("/rest/materialCaracteristica")
public class MaterialCaracteristicaController extends GenericController<MaterialCaracteristica> {

	/** Atributo materialCaracteristicaService. */
	private MaterialCaracteristicaService materialCaracteristicaService;

	public MaterialCaracteristicaController() {
		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param materialCaracteristicaService
	 */
	@Autowired
	private MaterialCaracteristicaController( MaterialCaracteristicaService materialCaracteristicaService ) {

		super(materialCaracteristicaService);

		this.materialCaracteristicaService = materialCaracteristicaService;

	}

	/**
	 * Retorna o valor do atributo <code>materialCaracteristicaService</code>
	 *
	 * @return <code>MaterialCaracteristicaService</code>
	 */
	public MaterialCaracteristicaService getMaterialCaracteristicaService() {

		return materialCaracteristicaService;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<Views.MaterialEditView> getEditView() {

		return Views.MaterialEditView.class;
	}

}
