package br.com.centralit.listener;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.stereotype.Component;

import br.com.centralit.api.service.DefaultFileService;
import br.com.centralit.api.service.DominioService;
import br.com.centralit.api.service.InternacionalizacaoService;
import br.com.centralit.api.service.ModuloService;
import br.com.centralit.framework.model.DefaultFile;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.Internacionalizacao;
import br.com.centralit.framework.model.Modulo;
import br.com.centralit.framework.model.UtilStartup;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 22/02/2016 - 09:30:08
 *
 * @version 1.0.0
 *
 * @author rogerio.cassimiro
 *
 */
@Component
public class StartupListenerAdmMaterial extends UtilStartup implements ApplicationListener<ContextRefreshedEvent>{

	@Autowired
	DefaultFileService defaultFileService;

	@Autowired
	private DominioService dominioService;

	@Autowired
	private ModuloService moduloService;

	@Autowired
	private InternacionalizacaoService internacionalizacaoService;

	@Override
	public void onApplicationEvent(ContextRefreshedEvent event) {
		criarDominios();
		criarDefaultFile();
		gerarInternacionalizacao();
	}

	private void criarDominios() {
		List<Dominio> list = new ArrayList<Dominio>();

		list.add(new Dominio("tipoBem", "Próprio contabilizado", "PROPRIO_CONTABILIZADO", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoBem", "Próprio controlado", "PROPRIO_CONTROLADO", 2L, Boolean.FALSE));
		list.add(new Dominio("tipoBem", "De terceiros", "DE_TERCEIROS", 3L, Boolean.FALSE));
		list.add(new Dominio("tipoEntrada", "Orçamentária", "ORCAMENTARIA", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoEntrada", "Extra orçamentária", "EXTRA_ORCAMENTARIA", 2L, Boolean.FALSE));
		list.add(new Dominio("tipoObjetivoTransferencia", "Comodato", "COMODATO", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoObjetivoTransferencia", "Conserto", "CONSERTO", 2L, Boolean.FALSE));
		list.add(new Dominio("tipoObjetivoTransferencia", "Empréstimo", "EMPRESTIMO", 3L, Boolean.FALSE));
		list.add(new Dominio("tipoObjetivoTransferencia", "Evento", "EVENTO", 4L, Boolean.FALSE));
		list.add(new Dominio("tipoObjetivoTransferencia", "Manutenção", "MANUTENCAO", 5L, Boolean.FALSE));
		list.add(new Dominio("tipoUnidadeMedida", "Unidade", "UNIDADE", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoUnidadeMedida", "Caixa", "CAIXA", 2L, Boolean.FALSE));
		list.add(new Dominio("tipoUnidadeMedida", "Pacote", "PACOTE", 3L, Boolean.FALSE));
		list.add(new Dominio("tipoUnidadeMedida", "Galão", "GALAO", 4L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Venda", "VENDA", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Doação", "DOACAO", 2L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Cessão de uso", "CESSAO_DE_USO", 3L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Extravio", "EXTRAVIO", 4L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Permuta", "PERMUTA", 5L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Transferência fora do sistema", "TRANSFERENCIA_FORA_SISTEMA", 6L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Cadastramento indevido", "CADASTRAMENTO_INDEVIDO", 7L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Mudança Permanente/Consumo", "MUDANCA_PERMANENTE_CONSUMO", 8L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Roubo ou furto", "ROUBO_OU_FURTO", 9L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Outros motivos", "OUTROS_MOTIVOS", 10L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Leilão", "LEILAO", 11L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Outras diversas", "OUTROS_DIVERSAS", 12L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Recuperável", "RECUPERAVEL", 13L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Despacho", "DESPACHO", 14L, Boolean.FALSE));
		list.add(new Dominio("tipoBaixa", "Cessão", "CESSAO", 15L, Boolean.FALSE));
		list.add(new Dominio("tipoSituacaoBaixa", "Em andamento", "EM_ANDAMENTO", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoSituacaoBaixa", "Autorizada", "AUTORIZADA", 2L, Boolean.FALSE));
		list.add(new Dominio("tipoSituacaoBaixa", "Não autorizada", "NAO_AUTORIZADA", 3L, Boolean.FALSE));
		list.add(new Dominio("tipoContaContabil", "Resultado", "RESULTADO", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoContaContabil", "Receita", "RECEITA", 2L, Boolean.FALSE));
		list.add(new Dominio("tipoContaContabil", "Despesa", "DESPESA", 3L, Boolean.FALSE));
		list.add(new Dominio("tipoContaContabil", "Passivo", "PASSIVO", 4L, Boolean.FALSE));
		list.add(new Dominio("tipoContaContabil", "Ativo", "ATIVO", 5L, Boolean.FALSE));
		list.add(new Dominio("tipoDepreciacao", "Linear", "LINEAR", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoMovimentoContaContabil", "Entrada orçamentária", "ENTRADA_ORCAMENTARIA", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoMovimentoContaContabil", "Baixa orçamentária", "BAIXA_ORCAMENTARIA", 2L, Boolean.FALSE));
		list.add(new Dominio("tipoMovimentoContaContabil", "Entrada extra orçamentária", "ENTRADA_EXTRAORCAMENTARIA", 3L, Boolean.FALSE));
		list.add(new Dominio("tipoMovimentoContaContabil", "Baixa extra orçamentária", "BAIXA_EXTRAORCAMENTARIA", 4L, Boolean.FALSE));
		list.add(new Dominio("objetivoContaContabil", "Almoxarifado", "OBJETIVO_CONTA_CONTABIL_ALMOXARIFADO", 1L, Boolean.FALSE));
		list.add(new Dominio("objetivoContaContabil", "Material", "OBJETIVO_CONTA_CONTABIL_MATERIAL", 2L, Boolean.FALSE));
		list.add(new Dominio(Dominio.COMISSAO_TIPO, Dominio.COMISSAO_DESCRICAO_INVENTARIO, Dominio.COMISSAO_NOME_INVENTARIO, Dominio.COMISSAO_CODIGO_INVENTARIO, Boolean.FALSE));
		list.add(new Dominio(Dominio.COMISSAO_TIPO, Dominio.COMISSAO_DESCRICAO_DESFAZIMENTO, Dominio.COMISSAO_NOME_DESFAZIMENTO, Dominio.COMISSAO_CODIGO_DESFAZIMENTO, Boolean.FALSE));
		list.add(new Dominio("tipoDepReavaliacaoReducao", "Reiniciar depreciação", "REINICIAR_DEPRECIACAO", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoDepReavaliacaoReducao", "Dar entrada da depreciação acumulada", "ENTRADA_DEPRECIACAO_ACUMULADA", 2L, Boolean.FALSE));
		list.add(new Dominio("tipoMovReavaliacaoReducao", "Dar saida de valor antigo e entrada de valor novo", "SAIDA_VALOR_ANTIGO_ENTRADA_VALOR_NOVO", 1L, Boolean.FALSE));
		list.add(new Dominio("tipoMovReavaliacaoReducao", "Dar entrada/saida da diferença entre valor antigo e novo", "ENTRADA_SAIDA_DIFERENCA_ENTRE_VALORES", 2L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Entrada", "ENTRADA", 1L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Entrada de materiais (Almoxarifado)", "ENTRADA_ALMOXARIFADO", 15L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Baixa", "BAIXA", 2L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Transferência Interna", "TRANSFERENCIA_INTERNA", 3L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Transferência entre contas contábeis", "TRANSFERENCIA_ENTRE_CONTAS", 4L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Atendimento", "ATENDIMENTO", 5L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Devolução Item", "DEVOLUCAO_ITEM", 6L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Depreciação", "DEPRECIACAO", 7L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Alteração bem patrimonial", "ALTERACAO_BEM_PATRIMONIAL", 8L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Saída temporária", "SAIDA_TEMPORARIA", 9L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Definição detentor", "DEFINICAO_DETENTOR", 10L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Adição bem principal", "ADICAO_BEM_PRINCIPAL", 11L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Entrada Almoxarifado Item", "ENTRADA_ALMOXARIFADO_ITEM", 12L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Baixa Almoxarifado Item", "BAIXA_ALMOXARIFADO_ITEM", 13L, Boolean.FALSE));
		list.add(new Dominio("classeReferencia", "Atendimento Almoxarifado Item", "ATENDIMENTO_ALMOXARIFADO_ITEM", 14L, Boolean.FALSE));
		
		this.dominioService.saveListIfNotExist(list);
		Logger.getLogger(StartupListenerAdmMaterial.class).info("Domínios executados - StartupListenerAdmMaterial!");
	}

	/**
	 *
	 * Método responsável por criar arquivos padrao para inicializacao do modulo
	 *
	 * @author wilker.machado
	 *
	 */
	private void criarDefaultFile() {
		dominioJS = this.dominioService.findByChaveAndNome(TIPO_FILE, TIPO_FILE_JS);
		List<DefaultFile> list = new ArrayList<DefaultFile>();
		list.add(new DefaultFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/ContaContabilMovimentoRepository.js", dominioJS, 146));
		list.add(new DefaultFile(CIT_ADM_MATERIAIS_WEB_ANGULAR_CUSTOM + "repository/ContaContabilMovimentoRepository.min.js", dominioJS, 147));
		this.defaultFileService.saveListIfNotExist(list);
	}

	/**
	 *
	 * Método responsável por gerar internacionalização do módulo administração de materiais
	 *
	 * @author rogerio.cassimiro
	 *
	 */
	private void gerarInternacionalizacao() {

		dominioPT_BR = this.dominioService.findByChaveAndCodigo(Dominio.TIPO_IDIOMA, Dominio.TIPO_IDIOMA_PT_BR_CODIGO);
		moduloSelecionado = this.moduloService.getModuloPorBaseUrl(BASE_URL_ADM_MATERIAIS, null);
		List<Internacionalizacao> internacionalizacaoList = new ArrayList<Internacionalizacao>();

		this.gerarLabel(dominioPT_BR, moduloSelecionado, internacionalizacaoList);
		this.gerarValidacao(dominioPT_BR, moduloSelecionado, internacionalizacaoList);
		this.gerarMensagem(dominioPT_BR, moduloSelecionado, internacionalizacaoList);

		this.internacionalizacaoService.saveListIfNotExist(internacionalizacaoList);
		Logger.getLogger(StartupListenerAdmMaterial.class).info("Internacionalização executada - StartupListenerAdmMaterial!");
	}

	private void gerarLabel(Dominio dominio, Modulo modulo, List<Internacionalizacao> internacionalizacaoList) {

		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.APRESENTAR_RELATORIO_DEPRECIACAO", "Apresentar no relatório de depreciação", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.APRESENTAR_RELATORIO_INVENTARIO", "Apresentar relatório inventário", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.APRESENTAR_RMA", "Apresentar no RMA", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.APRESENTAR_RMB", "Apresentar no RMB", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.CLASSIFICACAO_MATERIAL", "Classificação de materiais", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.CONFIGURACAO", "Configuração", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.CONTADESTINO", "Conta de destino", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.CONTAORIGEM", "Conta de origem", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.DADOS_CONTA_CONTABIL", "Dados de conta contábil", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.DADOS_MATERIAL", "Dados do material", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.DADOS_TRANSFERENCIACONTACONTABIL", "Dados de transferência", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.DADOS_UNIDADE_MEDIDA", "Dados da unidade de medida", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.DATATRANSFERENCIA", "Data de transferência", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.DO", "do", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.EMPLAQUETAVEL", "Emplaquetável", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.FECHAR_MES", "Efetuar fechamento", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.IMAGENS", "Imagens", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.MATERIAIS_CONSUMO_USADOS_POR_MATERIAL_PERMANENTE", "Materiais de consumo utilizados por esse material permanente", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.REFERENCIA", "Referência", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.SELECIONE_MATERIAL", "Escolha o detalhe que deseja incluir/editar:", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.TIPO_UNIDADE_MEDIDA_ENTRADA", "Unidades de medida de entrada", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.VALOR_TRANSFERENCIA", "Valor da transferência", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.DADOS_CLASSIFICACAO_MATERIAL", "Dados classificação de materiais", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.FECHAMENTO_MES_REFERENCIA", "Fechamento do mês de referência", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.GENERICO", "Genérico", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.TIPO_MATERIAL", "Tipo do material", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.TIPO_NUMERICO", "Tipo numérico", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.CODIGO_SISTEMA_ORIGEM", "Código de origem", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.DEPRECIACAO_ACUMULADA", "Depreciação Acumulada", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.DETALHE", "Detalhe", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.ELEMENTO_DESPESA", "Elemento despesa", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.PERCENTUAL_NAO_DEPRECIACAO", "Não depreciável (0-100%)", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.QUANTIDADE_PADRAO", "Qtde. Padrão", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.SELECIONE_DETALHE_MATERIAL", "Selecione o nível detalhe para edição:", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.TAXA_DEPRECIACAO_MENSAL", "Taxa mensal (0-100%)", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.TIPO_CLASSIFICACAO_MATERIAL", "Tipo de classificação de materiais", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.TIPO_CONTA_CONTABIL", "Tipo", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.TRANSFERENCIA_ESTRUTURA", "Transferência de almoxarifado", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.UNIDADE_MEDIDA_ARMAZENAMENTO", "Unidade de medida de armazenamento", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.APURACAO_FECHADA", "FECHADA", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.APURACAO_PARCIAL", "PARCIAL", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.REFERENCIA_SUBSEQUENTE", "Referência Subsequente", dominio, modulo));	
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.LABEL.UNIDADE_MEDIDA_ENTRADA_ARMAZENAMENTO", "Unidade de medida de entrada e de armazenamento", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("MSG.ALTERACAO_QUANTIDADE_PADRAO", "Alteração permitida somente para unidades de medidas que não são padrões do sistema", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("MSG.ALTERACAO_QUANTIDADE_PADRAO", "Alteração permitida somente para unidades de medidas que não são padrões do sistema", dominio, modulo));
		
	}

	private void gerarValidacao(Dominio dominio, Modulo modulo, List<Internacionalizacao> internacionalizacaoList) {
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.VALIDACAO.DATA_TRANSFERENCIA_FORA_REFERENCIA", "A data de transferência deve estar dentro da referência vigente!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.VALIDACAO.VALOR_TOTAL_MAIOR_ZERO", "Valor total deve ser maior que zero!", dominio, modulo));
	}

	private void gerarMensagem(Dominio dominio, Modulo modulo, List<Internacionalizacao> internacionalizacaoList) {
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.CONFIRMA_EXCLUIR_CONTA_CONTABIL", "Confirma a exclusão da conta contábil?", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.CONFIRMA_FECHAR_MES", "Tem certeza que deseja fechar o mês de referência? Fechamento de contas e depreciações de bens ocorrerão. Esta ação não poderá ser revertida. O processo será iniciado em segundo plano, quando o mesmo terminar, você será notificado.", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.EXCLUSAO_CLASSIFICASSAO_MATERIAL", "Classificação de material excluído com sucesso.", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.SELECIONE_MATERIAL_PRIMEIRO", "Você deve selecionar um material primeiro!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.SUCESSO_CLASSIFICACAO", "Classificação de material salvo com sucesso!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.SUCESSO_CONTA_CONTABIL", "Conta contábil salva com sucesso!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.SUCESSO_CONTA_CONTABIL_EXCLUIDO", "Conta contábil excluída com sucesso!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.SUCESSO_MATERIAL", "Material salvo com sucesso!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.TRANSFERENCIA_FAIL", "A transferência não pode ser realizada com sucesso!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.TRANSFERENCIA_SUCESS", "Transferência realizada com sucesso!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.INFO_EDICAO_MATERIAL", "Para a edição de outro material, localize o nível detalhe da classificação do material.", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.FECHAMENTO_ENTRADAS_INCOMPLETAS", "Existem entradas de bens incompletas neste mês de referência! Por favor concluir as mesmas antes de realizar o fechamento do mês!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.INFO_MSG_FECHAMENTO_MES_NOTIFICA_FIM", "Fechamento do mês de referência em execução. Quando o processo terminar, você será notificado!", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.CONFIRMA_ALTERAR_PADRAO", "Já foi definido uma unidade de medida de entrada como padrão. Deseja alterar?", dominio, modulo));
		
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.REMOVER_LOCAL_ESTOQUE_MATERIAL_PRINCIPAL", "O endereço selecionado para remoção está definido como principal de um almoxarifado. Para remover este endereço de estoque, informe outro endereço de estoque como principal para o almoxarifado.", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.EDITA_LOCAL_ESTOQUE_MATERIAL_PRINCIPAL", "Para definir esse endereço de estoque como não sendo principal, primeiramente informe outro endereço de estoque como principal para o almoxarifado.", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.LOCAL_SALVA_ESTOQUE_MATERIAL_COMO_PRINCIPAL_PARA_ALMOXARIFADO", "Este endereço de estoque é o principal do almoxarifado ", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.LOCAL_ESTOQUE_JA_VINCULADO_MATERIAL", "Este endereço de estoque já possui vínculo ao material.", dominio, modulo));
		internacionalizacaoList.add(new Internacionalizacao("ADMINISTRACAODEMATERIAIS.MSG.REMOVER_LOCAL_ESTOQUE_MATERIAL_VINCULADO_ENTRADA_ALMOX_ITEM", "Não é possível remover esse vínculo de endereço de estoque com o material, pois o endereço selecionado foi utilizado em um item de entrada do almoxarifado.", dominio, modulo));
	}

}