'use strict';
citApp.controller('MaterialController', ['$scope', 'MaterialRepository', 'ClassificacaoMaterialRepository', 'CaracteristicaRepository', 'FileUploader', 'MaterialImagemRepository',
                                 		'$timeout', 'MaterialCaracteristicaRepository', 'MaterialPermanenteConsumoRepository', 'ContaContabilRepository', 'DominioRepository', '$translate', '$filter', 'MaterialConsumoRepository', 'MaterialConsumoTipoUnidadeMedidaEntradaRepository', 'MaterialPermanenteRepository', 'UnidadeMedidaRepository', 'ConfiguracaoParametroSistemaRepository','$injector',
                                 				function MaterialController($scope, MaterialRepository, ClassificacaoMaterialRepository, CaracteristicaRepository, FileUploader, MaterialImagemRepository,
                                 						$timeout, MaterialCaracteristicaRepository, MaterialPermanenteConsumoRepository, ContaContabilRepository, DominioRepository, $translate, $filter, MaterialConsumoRepository, MaterialConsumoTipoUnidadeMedidaEntradaRepository, MaterialPermanenteRepository, UnidadeMedidaRepository, ConfiguracaoParametroSistemaRepository,$injector) {

	// CONSTANTES DOMINIO
	var CODIGO_TIPO_CLASSIFICACAO_DETALHE = 4;
	$scope.edit = true;

	$scope.classificacaoMaterial;
	$scope.classificacaoMaterialList = [];

	$scope.unidadesMedida = [];
	$scope.unidadesMedidaMaterialConsumo = [];
	$scope.unidadeMedidaEntrada = {};

	$scope.materialCaracteristica = {};
	$scope.materialConsumo = {};

	$scope.material = {
			materialCaracteristicas : [],
			materiaisConsumo : []
	};

	$scope.resetForm = function() {
		$scope.edit = true;
		$scope.limpar();
	};
	
	//recupera o parametro  TIPO_CONFIGURACAO_UNIDADE_MEDIDA_ENTRADA
	ConfiguracaoParametroSistemaRepository.getParametro('TIPO_CONFIGURACAO_UNIDADE_MEDIDA_ENTRADA').then(function(result) {
		if(result !== undefined && result.valor === '1' ) {
			$scope.indicaMultiplasUnidadesMedida = false;
		} else if(result !== undefined && result.valor === '2' ) {
			$scope.indicaMultiplasUnidadesMedida = true;
		}
		
	});
	
	function verificaMaterialConsumoSetGenerico(){
		if ($scope.material.dominioTipoMaterial && $scope.material.dominioTipoMaterial.codigo) {
			if($scope.material.dominioTipoMaterial.codigo == 1){
				$scope.materialCaracteristica.generico = true;
				$scope.bloquearMaterialConsumo = true;
			}else{
				$scope.bloquearMaterialConsumo = false;
				$scope.materialCaracteristica.generico = false;
			}
		}else{
			$scope.bloquearMaterialConsumo = false;
			$scope.materialCaracteristica.generico = false;
		}
	}

	$scope.getMaterial = function (material, edit) {
		$scope.setLoadingSalva(true);

		MaterialRepository.get(material.id).then(function(result) {
			$scope.material = result.originalElement;
			$scope.unidadeMedidaSelecionada = null;
			if ($scope.material.dataBloqueio === null || $scope.material.dataBloqueio === undefined) {
				$scope.edit = edit;
			} else {
				$scope.edit = false;
			}

			configurarDadosClassificacaoMaterial();
			verificaMaterialConsumoSetGenerico();
			$scope.verificaAlmoxarifadoAtivo();
			$scope.setLoading(false);
		});
	};

	$scope.limpar = function() {
		$scope.material = {};
		$scope.unidadeMedidaSelecionada = null;

		uploader.clearQueue();

		$scope.materialCaracteristica.caracteristica = null;
		$scope.materialConsumo.materialConsumo =  null;
		$scope.apresentarBloquearCaracteristica = false;

		$scope.materialDadosGrupo = null;
		$scope.materialDadosSubGrupo = null;
		$scope.materialDadosMaterial = null;
		$scope.MaterialDadosDetalhe = null;

		$timeout(function() {
			$scope.materialForm.$submitted = false;
			$scope.materialForm.$setPristine();
		});
	};

	var uploader = $scope.uploader = new FileUploader({
		autoUpload: false,
		queueLimit: 10,
		url : '/cit-adm-materiais-web/rest/materialImagem/uploadMultipleFile?idMaterial=',
	});

	// FILTERS
	uploader.filters.push({
		name: 'imageFilter',
		fn: function(item /*{File|FileLikeObject}*/, options) {
			var type = '|' + item.type.slice(item.type.lastIndexOf('/') + 1) + '|';
			return '|jpg|png|jpeg|bmp|gif|'.indexOf(type) !== -1;
		}
	});

	// CALLBACKS
	uploader.onWhenAddingFileFailed = function(item /*{File|FileLikeObject}*/, filter, options) {
		console.info('onWhenAddingFileFailed', item, filter, options);
	};
	uploader.onAfterAddingFile = function(fileItem) {
		console.info('onAfterAddingFile', fileItem);
	};
	uploader.onAfterAddingAll = function(addedFileItems) {
		console.info('onAfterAddingAll', addedFileItems);
	};
	uploader.onBeforeUploadItem = function(item) {
		console.info('onBeforeUploadItem', item);
	};
	uploader.onProgressItem = function(fileItem, progress) {
		console.info('onProgressItem', fileItem, progress);
	};
	uploader.onProgressAll = function(progress) {
		console.info('onProgressAll', progress);
	};
	uploader.onSuccessItem = function(fileItem, response, status, headers) {
		console.info('onSuccessItem', fileItem, response, status, headers);
	};
	uploader.onErrorItem = function(fileItem, response, status, headers) {
		console.info('onErrorItem', fileItem, response, status, headers);
	};
	uploader.onCancelItem = function(fileItem, response, status, headers) {
		console.info('onCancelItem', fileItem, response, status, headers);
	};
	uploader.onCompleteItem = function(fileItem, response, status, headers) {
		console.info('onCompleteItem', fileItem, response, status, headers);
	};
	uploader.onCompleteAll = function() {
		//uploader.clearQueue();
		console.info('onCompleteAll');
	};

	// Atualiza pagina de pesquisa
	$scope.atualizaPaginaPesquisa = function () {
		angular.element('#searchMaterial').scope().fetchResultMaterial();
	};

	$scope.saveOrUpdate = function(){
		$scope.materialForm.$submitted = true;

		//Vefifica se o materialForm está invalido, caso esteja envia um alerta para o usuario
		if ($scope.materialForm.$invalid) {
			$scope.showAlert('error', $translate.instant('MSG.MN001'));
		} else {
			$scope.setLoadingSalva(true);

			if ($scope.material.dominioTipoMaterial.codigo == 1) {
				MaterialConsumoRepository.save($scope.material).then(function(result) {
					$scope.posSave(result);
				});
			} else {
				MaterialPermanenteRepository.save($scope.material).then(function(result) {
					$scope.posSave(result);
				});
			}
		}
	};

	$scope.posSave = function(result) {
		$scope.material = result.originalElement;
		$scope.setLoading(false);
		salvarUpload(result);
		$scope.showAlert("success", $translate.instant('ADMINISTRACAODEMATERIAIS.MSG.SUCESSO_MATERIAL'));

		$timeout(function(){
			$scope.materialForm.$submitted = false;
		});
	};

	function salvarUpload(result) {
		//Percorre a lista de arquivos para setar na url o id do material
		angular.forEach(uploader.queue, function(item, key) {
			item.url =  item.url + result.originalElement.id;
		});
		//Envia a requisição dos arquivos
		uploader.uploadAll();
	};

	$scope.apresentarDialogConfirmacaoRemocaoMaterial = function(){
		//Verifica se o material já foi persistido
		if($scope.material.id){
			$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.remove});
		}
	};

	// Método responsável por remove o material
	$scope.remove = function(){
		$scope.setLoadingRemove(true);

		MaterialRepository.remove($scope.material).then(function() {
			$scope.setLoading(false);
			$scope.resetForm(false);
			uploader.clearQueue();
			$scope.materialForm.$submitted = false;
			$scope.showAlert("success",  $translate.instant('MSG.MG001'));
		});

		$scope.$modalConfirmInstance.dismiss('cancel');
		$timeout(function(){
			$scope.materialForm.$submitted = false;
			$scope.materialForm.$setPristine();
		});
	};

	// AUTO COMPLETE CLASSIFICAÇÃO MATERIAL
	// Busca a classificação de material pela descricao ou código por tipo detalhe
	$scope.findClassificacaoMaterial = function(value) {
		return ClassificacaoMaterialRepository.listarClassificacaoMaterial(value, CODIGO_TIPO_CLASSIFICACAO_DETALHE).then(function(result) {
			return result;
		});
	};

	//Método responsável por apresentar os dados do Matérial
	$scope.apresentarDadosMaterial = function(item) {
		// verifica se o dominioTipoClassificacaoMaterial é do tipo material
		uploader.clearQueue();

		if(item.dominioTipoClassificacaoMaterial.codigo == 4){
			$scope.material = {};

			MaterialRepository.findPorIdClassificacaoMaterial(item.id).then(function(result) {
				$scope.material = result.originalElement;
				$scope.unidadesMedidaMaterialConsumo = $filter('idNotEqualUnidadeMedida')($scope.unidadesMedidaMaterialConsumo, $scope.material.tiposUnidadeMedidaEntrada);

				if (!$scope.material.id) {
					$scope.material.classificacaoMaterial = item.originalElement ? item.originalElement : item;
				} else {
					$scope.materialForm.$submitted = false;
					$scope.materialForm.$setPristine();
				}

				configurarDadosClassificacaoMaterial();

				$scope.edit = true;
			});
		} else {
			$scope.resetForm();
		};

		$scope.classificacaoMaterial = null;
		$timeout(function(){
			$scope.materialForm.$submitted = false;
			$scope.materialForm.$setPristine();
			$scope.apresentarBloquearCaracteristica = false;
		});

	};

	function configurarDadosClassificacaoMaterial() {
		$scope.materialDadosGrupo = null;
		$scope.materialDadosSubGrupo = null;
		$scope.materialDadosMaterial = null;
		$scope.MaterialDadosDetalhe = null;

		if ($scope.material.classificacaoMaterial) {
			//GRUPO
			if($scope.material.classificacaoMaterial.classificacaoMaterialParent.classificacaoMaterialParent.classificacaoMaterialParent){
				$scope.materialDadosGrupo = $scope.material.classificacaoMaterial.classificacaoMaterialParent.classificacaoMaterialParent.classificacaoMaterialParent.codigo + ' - ' + $scope.material.classificacaoMaterial.classificacaoMaterialParent.classificacaoMaterialParent.classificacaoMaterialParent.descricao;
			}
			//SUBGRUPO
			if($scope.material.classificacaoMaterial.classificacaoMaterialParent.classificacaoMaterialParent){
				$scope.materialDadosSubGrupo = $scope.material.classificacaoMaterial.classificacaoMaterialParent.classificacaoMaterialParent.codigo + ' - ' + $scope.material.classificacaoMaterial.classificacaoMaterialParent.classificacaoMaterialParent.descricao;
			}
			//MATERIAL
			if($scope.material.classificacaoMaterial.classificacaoMaterialParent){
				$scope.materialDadosMaterial = $scope.material.classificacaoMaterial.classificacaoMaterialParent.codigo + ' - ' + $scope.material.classificacaoMaterial.classificacaoMaterialParent.descricao;
			}
			//DETALHE
			if($scope.material.classificacaoMaterial){
				$scope.MaterialDadosDetalhe = $scope.material.classificacaoMaterial.codigo  + ' - ' + $scope.material.classificacaoMaterial.descricao;
			}
		}
	};

    $scope.$watch('material.dominioTipoMaterial.codigo', function() {
    	verificaMaterialConsumoSetGenerico();
    });
    
    $scope.$watch('material.unidadeArmazenamento', function() {
    	if ($scope.material.unidadeArmazenamento) {
    		if (!$scope.material.tiposUnidadeMedidaEntrada) {
    			$scope.material.tiposUnidadeMedidaEntrada = [];
    		}
    		
    		var jaAdd = false;
    		var isPossuiPadrao = false;
    		for (var i = 0; i < $scope.material.tiposUnidadeMedidaEntrada.length; i++) {
    			if ($scope.material.tiposUnidadeMedidaEntrada[i].unidadeMedida.id == $scope.material.unidadeArmazenamento.id) {
    				jaAdd = true;
    			}
    			if ($scope.material.tiposUnidadeMedidaEntrada[i].isPadrao) {
    				isPossuiPadrao = true;
    			}
    		}
    		
    		if (!jaAdd) {
				if(isPossuiPadrao){
					var unidadeEntrada = {
							unidadeMedida : $scope.material.unidadeArmazenamento,
							isPadrao : false
					};
					$scope.material.tiposUnidadeMedidaEntrada.push(unidadeEntrada);
				} else {
					var unidadeEntrada = {
							unidadeMedida : $scope.material.unidadeArmazenamento,
							isPadrao : true
					};
					$scope.material.tiposUnidadeMedidaEntrada.push(unidadeEntrada);
				}
    		}
    	}
    });


	DominioRepository.findAllDominio('tipoMaterial').then(function(result) {
		$scope.tiposMaterial = result;
	});

	$scope.findContaContabil =  function(value) {
		return ContaContabilRepository.findContaContabilPorOrganizacaoTipoMaterial(value, $scope.usuarioLogado.organizacao.id, $scope.material.dominioTipoMaterial.codigo).then(function(result) {
			return result;
		});
	};

	$scope.novaContaContabil = function() {
		$scope.openWorkspaceIfNotOpen($translate.instant('LABEL.CONTA_CONTABIL'), '/cit-adm-materiais-web/html/contaContabil/contaContabil.html', 'mod-green');

		$timeout(function() {
			angular.element('#searchContaContabil').scope().$showPageEditWorkspace(angular.element('#searchContaContabil').scope().workspace);
			angular.element('#searchContaContabil').scope().resetForm();

		}, 300);
	};

	$scope.limparDadosMaterial =  function(){
		if(!$scope.material.id){

			$scope.material.contaContabil = '';

			$scope.materialForm.$submitted = false;
			$scope.materialForm.$setPristine();
		}
	};

	UnidadeMedidaRepository.getList().then(function(result) {
		angular.forEach(result, function(item) {

			$scope.unidadesMedida.push(item.originalElement);
			$scope.unidadesMedidaMaterialConsumo.push(item.originalElement);
		});

		$scope.unidadesMedidaMaterialConsumo.sort(function (a, b) {
		  return a.descricao.localeCompare(b.descricao);
		});
	});

	function addTipoUnidadeMedida(unidadeMedidaEntradaTemp){
		unidadeMedidaEntradaTemp.isPadrao = angular.copy($scope.unidadeMedidaEntrada.isPadrao);
		$scope.material.tiposUnidadeMedidaEntrada.push(unidadeMedidaEntradaTemp);
		$scope.unidadesMedidaMaterialConsumo = $filter('idNotEqualUnidadeMedida')($scope.unidadesMedidaMaterialConsumo, $scope.material.tiposUnidadeMedidaEntrada);
		$scope.unidadeMedidaEntrada = {};
	}
	//Método responsável por editar unidadeMedidaEntrada.
	$scope.adicionarUnidadeMedidaEntrada = function() {
		//Verifica se a lista  tiposUnidadeMedidaEntrada não está vazia
		if(!$scope.material.tiposUnidadeMedidaEntrada){
			$scope.material.tiposUnidadeMedidaEntrada = [];
		}
		//Verifica se o materialCaracteristica está sendo editado
		if(!$scope.unidadeMedidaEntrada.$edit){

			var unidadeMedidaEntradaTemp = {};
			angular.copy($scope.unidadeMedidaEntrada, unidadeMedidaEntradaTemp);

			if($scope.unidadeMedidaEntrada.isPadrao){
				var isPossuiPadrao = false;

				angular.forEach($scope.material.tiposUnidadeMedidaEntrada, function(tipoUnidade) {
					if(tipoUnidade.isPadrao){
						isPossuiPadrao = true;
					}
				});

				if( isPossuiPadrao){
					$scope.$openModalConfirm({message: $translate.instant('ADMINISTRACAODEMATERIAIS.MSG.CONFIRMA_ALTERAR_PADRAO'), callback:
						function(){
							angular.forEach($scope.material.tiposUnidadeMedidaEntrada, function(tipoUnidade) {
								tipoUnidade.isPadrao = false;
							});
							addTipoUnidadeMedida(unidadeMedidaEntradaTemp);
							$scope.$modalConfirmInstance.dismiss('cancel');
						}
					});
				}else{
					addTipoUnidadeMedida(unidadeMedidaEntradaTemp);
				}
			}else{
				addTipoUnidadeMedida(unidadeMedidaEntradaTemp);
			}
		}
	};

	$scope.exibirDialogRemocaoUnidadeMedida = function() {
		$scope.getCheckUnidadeMedidaEntrada();
		if($scope.unidadeMedidaSelecionada){
			$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.removerUnidadeMedida});
		} else {
			$scope.showAlert("warning",  $translate.instant('LABEL.SELECIONE_UM_ITEM'));
		}
	};

	$scope.removerUnidadeMedida = function() {
		angular.forEach($scope.material.tiposUnidadeMedidaEntrada, function(unidadeMedida, index) {

			if(unidadeMedida.$checked) {
				if (unidadeMedida.id) {
					MaterialConsumoTipoUnidadeMedidaEntradaRepository.remove(unidadeMedida).then(function() {
						$scope.showAlert("success",  $translate.instant('MSG.MG001'));
						$scope.unidadeMedidaSelecionada = null;
						$scope.material.tiposUnidadeMedidaEntrada.splice(index, 1);
					});
				} else {
					$scope.material.tiposUnidadeMedidaEntrada.splice(index, 1);
				}

				$scope.unidadesMedidaMaterialConsumo.push(unidadeMedida.unidadeMedida);
				$scope.$modalConfirmInstance.dismiss('cancel');
			};
		});

		$scope.unidadesMedidaMaterialConsumo.sort(function (a, b) {
		  return a.descricao.localeCompare(b.descricao);
		});
	};

	$scope.getCheckUnidadeMedidaEntrada = function () {
		$scope.material.tiposUnidadeMedidaEntrada.forEach(function (unidade) {
			if(unidade.$checked){
				$scope.unidadeMedidaSelecionada = unidade;
			}
		});
	};

	$scope.checkUnidadeMedidaEntrada = function (unidadeMedida) {

		removeCheckedUnidadeMedidaEntrada();

		unidadeMedida.$checked = true;

		if (unidadeMedida.id && !unidadeMedida.dataBloqueio) {

			$scope.apresentarBloquearUnidadeMedidaEntrada =  true;
			$scope.dataBloqueio = "";
		} else {
			$scope.apresentarBloquearUnidadeMedidaEntrada =  false;
		}

		if(unidadeMedida.dataBloqueio) {
			$scope.apresentarDesbloquearUnidadeMedida = true;
		} else {
			$scope.apresentarDesbloquearUnidadeMedida = false;
		}
	};

	function removeCheckedUnidadeMedidaEntrada() {

		$scope.material.tiposUnidadeMedidaEntrada.forEach(function (unidade) {
			unidade.$checked = false;
		});
	};

	$scope.novaCaracteristica = function() {

		$scope.openWorkspaceIfNotOpen($translate.instant('LABEL.CARACTERISTICA'), '/cit-tabelas-corp-web/html/caracteristica/caracteristica.html', 'mod-green');
		$timeout(function() {
			angular.element('#searchCaracteristica').scope().$showPageEditWorkspace(angular.element('#searchCaracteristica').scope().workspace);
			angular.element('#searchCaracteristica').scope().resetForm();

		}, 300);
	};

	$scope.findCaracteristica =  function(value) {
		return CaracteristicaRepository.listarCaracteristicasPorOrganizacao(value, $scope.usuarioLogado.organizacao.id).then(function(result) {
			return $filter('idNotEqualCaracteristica')(result, $scope.material.materialCaracteristicas);
		});
	};

	$scope.limparCaracteristicaAutoComplete = function(value) {
		value = {};
	};

	$scope.adicionarCaracteristica = function() {
		//Verifica se a lista  materialCaracteristicas não está vazia
		if (!$scope.material.materialCaracteristicas) {
			$scope.material.materialCaracteristicas = [];
		}

		//Verifica se o materialCaracteristica está sendo editado
		if (!$scope.materialCaracteristica.$edit) {
			var materialCaracteristicaTemp = {};
			angular.copy($scope.materialCaracteristica, materialCaracteristicaTemp);
			materialCaracteristicaTemp.sequencia =	$scope.material.materialCaracteristicas.length + 1;
			$scope.material.materialCaracteristicas.push(materialCaracteristicaTemp);
		}

		$scope.materialCaracteristica.$edit = false;
		$scope.materialCaracteristica = {};
		verificaMaterialConsumoSetGenerico();
	};

	$scope.editCaracteristica = function() {

		var  caracteristicaSelecionada = $scope.material.materialCaracteristicas.some(function(item) {
			return item.$checked;
		});

		if (caracteristicaSelecionada) {
			angular.forEach($scope.material.materialCaracteristicas, function(caracteristica, index) {
				if (caracteristica.$checked) {
					$scope.materialCaracteristica = caracteristica;
					$scope.materialCaracteristica.$edit = true;
				}
			});

		} else {
			$scope.showAlert('warning', $translate.instant('LABEL.SELECIONE_UM_ITEM'));
		}
	};

	$scope.bloquearCaracteristica = function(dataBloqueio) {
		angular.forEach($scope.material.materialCaracteristicas, function (materialCaracteristica, key) {

			if (materialCaracteristica.$checked) {
				if (dataBloqueio != "") {
					materialCaracteristica.dataBloqueio = dataBloqueio;
					materialCaracteristica.material = {
							id : $scope.material.id
					};

					MaterialCaracteristicaRepository.save(materialCaracteristica).then(function(result) {
						$scope.showAlert("success", $translate.instant('MSG.SUCESSO_BLOQUEIO_CARACTERISTICA'));

						materialCaracteristica.$checked = false;

						$scope.apresentarBloquearCaracteristica = false;

						materialCaracteristica.version = result.originalElement.version;
					});
				}
			}
		});
	};

	$scope.desbloquearCaracteristica = function() {
		angular.forEach($scope.material.materialCaracteristicas, function(materialCaracteristica, key) {

			if(materialCaracteristica.$checked) {
				materialCaracteristica.dataBloqueio = null;
				materialCaracteristica.material = {
						id : $scope.material.id,
				};

				MaterialCaracteristicaRepository.save(materialCaracteristica).then(function(result) {
					$scope.showAlert("success", $translate.instant('MSG.SUCESSO_DESBLOQUEIO_CARACTERISTICA'));
					$scope.apresentarDesbloquearCaracteristica = false;

					materialCaracteristica.$checked = false;
					materialCaracteristica.version = result.originalElement.version;
				});
			}
		});
	};

	$scope.excluirCaracteristica = function() {
		var  caracteristicaSelecionada = $scope.material.materialCaracteristicas.some(function(item){
			return item.$checked;
		});

		if (caracteristicaSelecionada) {
			//Verifica se o material já foi persistido
			$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.removerCaracteristica});
		} else {
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_ITEM_EXCLUIR'));
		}
	};

	$scope.removerCaracteristica = function() {
		//Percorre a lista de materialCaracteristicas para encontrar a caracteristica selecionada
		angular.forEach($scope.material.materialCaracteristicas, function(caracteristica, index) {

			if (caracteristica.$checked) {
				if (caracteristica.id) {
					MaterialCaracteristicaRepository.remove(caracteristica).then(function() {

						$scope.showAlert("success",  $translate.instant('MSG.MG001'));
						$scope.material.materialCaracteristicas.splice(index, 1);
					});
				} else {
					$scope.material.materialCaracteristicas.splice(index, 1);
				}

				$scope.$modalConfirmInstance.dismiss('cancel');
			}
		});
	};

	$scope.checkMaterialCaracteristica = function (materialCaracteristica) {
		removeCheckedCaracteristica();

		materialCaracteristica.$checked = true;

		if (materialCaracteristica.id && !materialCaracteristica.dataBloqueio) {

			$scope.apresentarBloquearCaracteristica =  true;
			$scope.dataBloqueio = "";
		} else {
			$scope.apresentarBloquearCaracteristica =  false;
		}

		if (materialCaracteristica.id && materialCaracteristica.dataBloqueio) {
			$scope.apresentarDesbloquearCaracteristica = true;
		} else {
			$scope.apresentarDesbloquearCaracteristica = false;
		}

	};

	function removeCheckedCaracteristica() {
		var caracteristicas = $scope.material.materialCaracteristicas;

		caracteristicas.forEach(function (caracteristica) {
			caracteristica.$checked = false;
		});
	};

	$scope.findMaterialConsumo =  function(value) {
		return MaterialRepository.findMaterialConsumo(value).then(function(result) {
			return $filter('idNotEqualMaterial')(result, $scope.material.materiaisConsumo);
		});
	};

	$scope.adicionarMaterialConsumo =  function() {
		if (!$scope.material.materiaisConsumo) {
			$scope.material.materiaisConsumo = [];
		}

		var materialConsumoTemp = {};
		angular.copy($scope.materialConsumo, materialConsumoTemp);

		$scope.material.materiaisConsumo.push(materialConsumoTemp);
		$scope.materialConsumo = {};
	};

	$scope.apresentarDialogConfirmacaoRemocaoMaterialConsumo = function() {
		var materialConsumoSelecionado = $scope.material.materiaisConsumo.some(function(item) {
			return item.$checked;
		});

		if (materialConsumoSelecionado) {
			$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback: $scope.removerMaterialConsumo});
		} else {
			$scope.showAlert("warning", $translate.instant("LABEL.SELECIONE_UM_ITEM"));
		}
	};

	$scope.removerMaterialConsumo = function() {
		angular.forEach($scope.material.materiaisConsumo, function(materialConsumo, index) {

			if (materialConsumo.$checked) {
				if (materialConsumo.id) {
					MaterialPermanenteConsumoRepository.remove(materialConsumo).then(function() {

					});
				}
				$scope.material.materiaisConsumo.splice(index, 1);
			}
		});
		$scope.$modalConfirmInstance.dismiss('cancel');
	};

	$scope.checkMaterialConsumio =  function(materialConsumo) {
		$scope.removeCheckedMaterialConsumo();
		materialConsumo.$checked = true;
	};

	$scope.visualizarImagem = function(materialImagemSelecionado) {
		if (!materialImagemSelecionado.id) {
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO'));
			return;
		}

		$scope.url = '/cit-adm-materiais-web/rest/materialImagem/visualizarImagem?idMaterialImagem=' + materialImagemSelecionado.id;
		$scope.$openModal('visualizarArquivos', 'lg');
	};

	$scope.removerUploadMaterialImagem = function(materialImagem){
		if (materialImagem) {
			if (materialImagem.id) {
				$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback:  function() {

					$scope.setLoading(true);
					angular.forEach($scope.material.materialImagens, function(materialImg, index) {
						if (materialImg.id === materialImagem.id) {

							$scope.material.materialImagens.splice(index , 1);
							MaterialImagemRepository.remove(materialImagem).then(function(result) {

								$scope.showAlert("success", $translate.instant("MSG.EXCLUSAO_SUCESSO"));
								$scope.$modalConfirmInstance.dismiss('cancel');
								$scope.setLoading(false);
							});
						}
					});
				}
				});
			} else {
				materialImagem.remove();
			}
		} else {
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_ITEM_EXCLUIR'));
		}
	};

	$scope.verificaAlmoxarifadoAtivo = function(){
		$scope.almoxarifadoAtivo = $scope.isModuloAtivo("/cit-almoxarifado-web");
		if($scope.almoxarifadoAtivo){
			$scope.MaterialLocalEstoqueRepository = $injector.get(["MaterialLocalEstoqueRepository"]);
			$scope.EstruturaOrganizacionalAlmoxarifadoRepository = $injector.get(["EstruturaOrganizacionalAlmoxarifadoRepository"]);
			$scope.EnderecoEstoqueRepository = $injector.get(["EnderecoEstoqueRepository"]);
			$scope.EntradaAlmoxarifadoItemRepository = $injector.get(["EntradaAlmoxarifadoItemRepository"]);
			
			$scope.EstruturaOrganizacionalAlmoxarifadoRepository.getAlmoxarifadoPadrao($scope.usuarioLogado.organizacao.id).then(function(result){
				$scope.almoxarifadoTemp = result.originalElement.estruturaOrganizacional;
			});
			if($scope.material && $scope.material.id){
				$scope.listaLocaisEstoqueMaterial();
			}
			$scope.editEnderecoEstoque = false;
		}
	}


	$scope.adicionarEnderecoEstoque = function(){
		$scope.materialLocalEstoque = {};
		$scope.$openModal('modal-material-endereco-estoque.html', 'lg');
		$scope.alternaTipoNumericoUnidadeMedida();
	};

	$scope.editarEnderecoEstoque = function(){
		if(!$scope.matEndEstoqueCheck){
			$scope.showAlert("warning",  $translate.instant('LABEL.SELECIONE_UM_ITEM'));
		}else{
			$scope.editEnderecoEstoque = true;
			$scope.materialLocalEstoque = $scope.matEndEstoqueCheck;
			$scope.almoxarifadoTemp = $scope.materialLocalEstoque.endereco.estoque.almoxarifado;
			$scope.$openModal('modal-material-endereco-estoque.html', 'lg');
			 $scope.alternaTipoNumericoUnidadeMedida();
		}
	};

	$scope.removerEnderecoEstoque = function(){
		if(!$scope.matEndEstoqueCheck){
			$scope.showAlert("warning",  $translate.instant('LABEL.SELECIONE_UM_ITEM'));
		}else{
			$scope.$openModalConfirm({message: $translate.instant('LABEL.CONFIRMA_EXCLUSAO'), callback:  function() {
					$scope.setLoading(true);
					$scope.MaterialLocalEstoqueRepository.buscarLocaisEstoquePorIdMaterialIdAlmoxarifado($scope.material.id, $scope.matEndEstoqueCheck.endereco.estoque.almoxarifado.id).then(function(result) {
						if(result && result.length > 1){
							if($scope.matEndEstoqueCheck.localPrincipal){
								$scope.showAlert("warning",  $translate.instant('ADMINISTRACAODEMATERIAIS.MSG.REMOVER_LOCAL_ESTOQUE_MATERIAL_PRINCIPAL'));
								$scope.setLoading(false);
								$scope.$modalConfirmInstance.dismiss('cancel');
								return;
							}
						}
						
						$scope.EntradaAlmoxarifadoItemRepository.existeItemVinculadoAMaterialLocalEstoque($scope.matEndEstoqueCheck.id).then(function(result) {
							if(result){
								$scope.showAlert("warning",  $translate.instant('ADMINISTRACAODEMATERIAIS.MSG.REMOVER_LOCAL_ESTOQUE_MATERIAL_VINCULADO_ENTRADA_ALMOX_ITEM'));
								$scope.setLoading(false);
								$scope.$modalConfirmInstance.dismiss('cancel');
								return;
							}
							
							$scope.MaterialLocalEstoqueRepository.get($scope.matEndEstoqueCheck.id).then(function(result) {
								if(result.quantidade > 0){
									$scope.showAlert("warning",  $translate.instant('ADMINISTRACAODEMATERIAIS.MSG.REMOVER_LOCAL_ESTOQUE_MATERIAL_VINCULADO_ENTRADA_ALMOX_ITEM'));
									$scope.setLoading(false);
									$scope.$modalConfirmInstance.dismiss('cancel');
									return;
								}
								
								$scope.MaterialLocalEstoqueRepository.remove($scope.matEndEstoqueCheck).then(function(result) {
									$scope.listaLocaisEstoqueMaterial();
									$scope.setLoading(false);
								});
							});
							
						});
						
						$scope.$modalConfirmInstance.dismiss('cancel');
					});
				}
			});
		}
	};

	$scope.checkMatEndEstoque = function(materialLocalEstoque){
		$scope.matEndEstoqueCheck = materialLocalEstoque.originalElement;
	};

    $scope.findAutoCompleteAlmoxarifado = function(value){
		return $scope.EstruturaOrganizacionalAlmoxarifadoRepository.listarEstruturasOrganizacionaisAlmoxarifadoPorOrganizacao(value, $scope.usuarioLogado.organizacao.id).then(function(result) {
			return result;
		});
    };

    $scope.findAutoCompleteEndereco = function(value, almoxarifado){
    	var idAlmoxarifado = 0;
    	if(almoxarifado){
    		idAlmoxarifado = almoxarifado.id;
    	}
    	return $scope.EnderecoEstoqueRepository.listarEnderecosEstoque(value, idAlmoxarifado).then(function(result) {
    		return result;
    	});
    };

    $scope.salvarMaterialEnderecoEstoque = function(formDialogMaterialEnderecoEstoque, materialLocalEstoque, almoxarifadoTemp){
    	formDialogMaterialEnderecoEstoque.$submitted = true;
		if (formDialogMaterialEnderecoEstoque.$invalid) {
			$scope.showAlert('error', $translate.instant('MSG.MN001'));
		} else {
			$scope.almoxarifadoTemp = almoxarifadoTemp;
			$scope.setLoading(true);
			if(!materialLocalEstoque.materialEstoque){
				materialLocalEstoque.materialEstoque = {material : $scope.material};
			}
			materialLocalEstoque.endereco.estoque = {almoxarifado : $scope.almoxarifadoTemp};
			$scope.MaterialLocalEstoqueRepository.save(materialLocalEstoque).then(function(result) {
				if( result.originalElement.localPrincipal){
					$scope.showAlert("warning",  $translate.instant('ADMINISTRACAODEMATERIAIS.MSG.LOCAL_SALVA_ESTOQUE_MATERIAL_COMO_PRINCIPAL_PARA_ALMOXARIFADO') + $scope.almoxarifadoTemp.codigoENome);
				}
				$scope.$modalInstance.dismiss('cancel');
				$scope.listaLocaisEstoqueMaterial();
				$scope.editEnderecoEstoque = false;
				$scope.setLoading(false);
			});
		}
    };

    $scope.listaLocaisEstoqueMaterial = function(){
    	$scope.setLoading(true);
    	$scope.listaMaterialEnderecoEstoque = [];
    	$scope.MaterialLocalEstoqueRepository.listarMaterialEstoquePorMaterial($scope.material.id).then(function(result) {
			$scope.listaMaterialEnderecoEstoque = result;
			$scope.matEndEstoqueCheck = null;
			$scope.alternaTipoNumericoUnidadeMedida();
			$scope.setLoading(false);
		});
    };

    $scope.bloquearEnderecoEstoque = function(){
		if(!$scope.matEndEstoqueCheck){
			$scope.showAlert("warning",  $translate.instant('LABEL.SELECIONE_UM_ITEM'));
		}else{
			$scope.matEndEstoqueCheck.dataBloqueio = new Date();
			$scope.MaterialLocalEstoqueRepository.save($scope.matEndEstoqueCheck).then(function(result) {
				$scope.listaLocaisEstoqueMaterial();
			});
		}
    };

    $scope.desbloquearEnderecoEstoque = function(){
		if(!$scope.matEndEstoqueCheck){
			$scope.showAlert("warning",  $translate.instant('LABEL.SELECIONE_UM_ITEM'));
		}else{
			$scope.matEndEstoqueCheck.dataBloqueio = null;
			$scope.MaterialLocalEstoqueRepository.save($scope.matEndEstoqueCheck).then(function(result) {
				$scope.listaLocaisEstoqueMaterial();
			});
		}
    };

    $scope.alternaTipoNumericoUnidadeMedida = function(){
    	$timeout(function(){
    		if($scope.material.unidadeArmazenamento.tipoNumerico.codigo){
    			switch($scope.material.unidadeArmazenamento.tipoNumerico.codigo){
	    			case 1:
	    				$scope.showInteiro= true;
	    				$scope.showDecimal = false;
	    			break;

	    			case 2:
	    				$scope.showDecimal = true;
	    				$scope.showInteiro= false;
	    			break;

    			}
    		}
    	});
    };
}]);