'use strict';

citApp.controller('MesReferenciaController', ['$scope', 'OrganizacaoRepository', 'DominioRepository', '$filter', '$translate', 'DepreciacaoRepository', 'OrganizacaoPatrimonioRepository',
                                              	function MesReferenciaController($scope, OrganizacaoRepository, DominioRepository, $filter, $translate, DepreciacaoRepository,
                                              			OrganizacaoPatrimonioRepository) {

	$scope.setLoadingGet(true);

	var setOrganizacao = function(organizacaoId) {
		OrganizacaoRepository.get(organizacaoId).then(function(result) {
			$scope.atualizaOrganizacao(result.originalElement);

			$scope.setLoading(false);
		});
	};

	setOrganizacao($scope.usuarioLogado.organizacao.id);

	$scope.atualizaOrganizacao = function(organizacao) {//Atualiza as informações do orgão na página
		$scope.organizacao = organizacao;
		$scope.tipoDepreciacaoObj = 1; //Define que a depreciação linear deve vir marcada
		$scope.dataVigente = $filter('date')(converterStringEmDate($scope.organizacao.dataReferenciaVigente), "MMMM/yyyy");
		var dataSubsequente = converterStringEmDate($scope.organizacao.dataReferenciaVigente);
		dataSubsequente.setMonth(dataSubsequente.getMonth() + 1);
		$scope.dataSubsequente = $filter('date')(dataSubsequente, "MMMM/yyyy");
	};

	DominioRepository.findAllDominio('tipoDepreciacao').then(function(result) {//Lista dos tipos de depreciação existentes
		$scope.dominiosTipoDepreciacao = result;
	});

	// Fecha o mês de referencia do orgão.
	$scope.fecharMes = function(){
		$scope.$openModalConfirm({
			message: $translate.instant('ADMINISTRACAODEMATERIAIS.MSG.CONFIRMA_FECHAR_MES'),
			callback: function () {
				$scope.$modalConfirmInstance.dismiss('cancel');

				OrganizacaoPatrimonioRepository.bloquearValidarFechamentoMes($scope.organizacao.id).then(function(result) {
					if (result != true && !result.originalElement.status) {
						angular.forEach(result.originalElement.mensagens, function (mensagem) {
							$scope.showAlert(mensagem.tipoMensagem, $translate.instant(mensagem.mensagem));
						});
					} else {//Se o mês de referencia mudou atualiza as informações do orgão na página.

						$scope.showAlert('info', $translate.instant('ADMINISTRACAODEMATERIAIS.MSG.INFO_MSG_FECHAMENTO_MES_NOTIFICA_FIM'));

						OrganizacaoPatrimonioRepository.fecharMes($scope.organizacao.id, $scope.tipoDepreciacaoObj).then(function(result) {
							//Caso a data de referencia não tenha mudado o mês não foi fechado
							setOrganizacao($scope.organizacao.id);

							$scope.atualizarUsuarioLogado();
						});
					}
				});
			}
		});
	};
	
}]);
