'use strict';

citApp.controller('TransferenciaContaContabilListController', ['$scope', 'TransferenciaContaContabilRepository', '$translate', '$timeout', 'DominioRepository', 'BemPatrimonialRepository',
		function TransferenciaContaContabilListController($scope, TransferenciaContaContabilRepository, $translate, $timeout, DominioRepository, BemPatrimonialRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editTransferenciaContaContabil").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('ADMINISTRACAODEMATERIAIS.LABEL.DATATRANSFERENCIA'), value : 'dataTransferencia' , filter : 'dateBR'} ,
                       {title : $translate.instant('LABEL.MATERIAL'), value : 'material.descricao' } ,
                       {title : $translate.instant('ADMINISTRACAODEMATERIAIS.LABEL.CONTAORIGEM'), value : 'contaOrigem.descricao' } ,
                       {title : $translate.instant('ADMINISTRACAODEMATERIAIS.LABEL.CONTADESTINO'), value : 'contaDestino.descricao' },
                       {title : $translate.instant('ADMINISTRACAODEMATERIAIS.LABEL.VALOR_TRANSFERENCIA'), value : 'valorTransferencia', filter : 'currency' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'dataTransferencia', 'material.descricao', 'contaOrigem.descricao', 'contaDestino.descricao', 'valorTransferencia'],
        filters : [ {type : 'date-range', field : 'dataTransferencia' } , {type : 'string', field : 'material.descricao' } , {type : 'string', field : 'contaOrigem.descricao' } ,
                    {type : 'string', field : 'contaDestino.descricao' }]
    };

    // ABRI TransferenciaContaContabil SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var transferenciaContaContabil = $scope.transferenciaContaContabilChecked;

        if(!transferenciaContaContabil) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }

        angular.element('#editTransferenciaContaContabil').scope().getTransferenciaContaContabil(transferenciaContaContabil, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);
