'use strict';

citApp.factory('ClassificacaoMaterialRepository', ['RestangularAdmMateriais', 'AbstractRepository', function (restangularAdmMateriais, AbstractRepository) {

    function ClassificacaoMaterialRepository() {
    	
    	this.listarGrupos = function() {
			return restangularAdmMateriais.one(this.route).getList("listarGrupos").then();
		};

		this.listarGruposTree = function(buscaFederalDescricao) {
			return restangularAdmMateriais.one(this.route).getList("listarGruposTree" , {descricao : buscaFederalDescricao}).then();
		};
		
		this.listarFilhos = function(idClassificacaoMaterial){
			return restangularAdmMateriais.one(this.route).getList("listarFilhos", {id: idClassificacaoMaterial}).then();
		};
		
		this.listarClassificacaoMaterial = function(value, codigo) {
			return restangularAdmMateriais.one(this.route).getList("listarClassificacaoMaterial", {descricao : value, codigo : codigo}).then();
		};
		
		this.salvarClassificacaoMaterialTipoMaterial = function(classificacaoMaterial) {
			return restangularAdmMateriais.all(this.route + '/salvarClassificacaoMaterialTipoMaterial').post(classificacaoMaterial).then();
			
		};
		
		this.salvarClassificacaoMaterialDetalhe = function(federalSupply) {
			return restangularAdmMateriais.all(this.route + '/salvarClassificacaoMaterialDetalhe').post(federalSupply).then();
			
		};
		
		this.findClassificacaoMaterialParent = function(federalSupply) {
			return restangularAdmMateriais.all(this.route + '/findClassificacaoMaterialParent').post(federalSupply).then();
		};
		
		this.listarClassificacaoMaterialFilho = function(descricao, id) {
			return restangularAdmMateriais.one(this.route).getList("listarClassificacaoMaterialFilho", {descricao : descricao, id : id}).then();
		};
		
		this.listarFilhosPorDescricaoIdParent = function(descricao, id) {
			return restangularAdmMateriais.one(this.route).getList("listarFilhosPorDescricaoIdParent", {descricao : descricao, id : id}).then();
		};
		
    	AbstractRepository.call(this, restangularAdmMateriais, 'rest/classificacaoMaterial');
    }
    
    AbstractRepository.extend(ClassificacaoMaterialRepository);
    
    return new ClassificacaoMaterialRepository();
}]);