
citApp.factory('ContaContabilMovimentoRepository', ['RestangularAdmMateriais', 'AbstractRepository', function (restangularAdmMateriais, AbstractRepository) {

    function ContaContabilMovimentoRepository() {
    	AbstractRepository.call(this, restangularAdmMateriais, 'rest/contaContabilMovimento');
    	
    	this.existeSaldoReferencia = function(organizacaoId, dataReferencia) { //Método para realizar o fechamento do mês de um orgão passando o tipo de depreciação a ser realizada
    		var request = {
    				organizacao : organizacaoId,
    				dataReferencia : dataReferencia
    		};
    		
    		return restangularAdmMateriais.all(this.route + '/existeSaldoReferencia').post(request);
    	};
    	
    	this.existeMovimentacaoReferenciaTipoMaterial = function(organizacaoId, dataRefInicial, dataRefFinal, tipoMaterial) { //Método para verificar se existe movimentações de um tipo de material especifico em uma data de referencia
    		var request = {
    				organizacao : organizacaoId,
    				dataReferenciaInicial : dataRefInicial,
    				dataReferenciaFinal : dataRefFinal,
    				tipoMaterial : tipoMaterial
    		};
    		
    		return restangularAdmMateriais.all(this.route + '/existeMovimentacaoReferencia').post(request);
    	};
    }
    
    AbstractRepository.extend(ContaContabilMovimentoRepository);
    
    return new ContaContabilMovimentoRepository();
}]);