
citApp.factory('ContaContabilRepository', ['RestangularAdmMateriais', 'AbstractRepository', function (restangularAdmMateriais, AbstractRepository) {

    function ContaContabilRepository() {

		// Autocomplete conta contábil por código
    	this.findContaContabil = function(codigo) {
    		return restangularAdmMateriais.one('rest/contaContabil').getList("findContaContabil", {"chave": codigo}).then();
		};

		// Autocomplete conta contábil por código e órgão do usuário logado
		this.findContaContabilPorOrganizacao = function(codigo, idOrganizacao) {
    		return restangularAdmMateriais.one(this.route).getList("findContaContabilPorOrganizacao", {codigo: codigo, idOrganizacao : idOrganizacao}).then();
		};

		// Autocomplete conta contábil por código; órgão do usuário logado; domínio tipo
		this.findContaContabilPorOrganizacaoEDominio = function(codigo, idOrganizacao, idDominio) {
    		return restangularAdmMateriais.one(this.route).getList("findContaContabilPorOrganizacaoEDominio", {codigo: codigo, idOrganizacao : idOrganizacao, idDominio : idDominio}).then();
		};

		// Autocomplete conta contábil por código; órgão do usuário logado; domínio tipo; sem uso com material
		this.findContaContabilPorOrganizacaoEDominioSemUsoMaterial = function(codigo, idOrganizacao, idDominio) {
    		return restangularAdmMateriais.one(this.route).getList("findContaContabilPorOrganizacaoEDominioSemUsoMaterial", {codigo: codigo, idOrganizacao : idOrganizacao, idDominio : idDominio}).then();
		};

		// Autocomplete conta contábil por código; órgão do usuário logado; domínio tipo; sem uso com almoxarifado
		this.findContaContabilPorOrganizacaoEDominioSemUsoAlmoxarifado = function(codigo, idOrganizacao, idDominio) {
    		return restangularAdmMateriais.one(this.route).getList("findContaContabilPorOrganizacaoEDominioSemUsoAlmoxarifado", {codigo: codigo, idOrganizacao : idOrganizacao, idDominio : idDominio}).then();
		};

		// Autocomplete conta contábil por código; órgão do usuário logado; domínio tipoMaterial; sem uso na estrutura
		this.findContaContabilPorOrganizacaoTipoMaterial = function(codigo, idOrganizacao, codigoTipoMaterial) {
    		return restangularAdmMateriais.one(this.route).getList("findContaContabilPorOrganizacaoTipoMaterial", {codigo: codigo, idOrganizacao : idOrganizacao, codigoTipoMaterial : codigoTipoMaterial}).then();
		};

		// Obtem conta contabil definada na configuracaoparametrosistema
    	this.obterContaContabilAlmoxarifadoConfiguracaoParametroSistema = function() {
    		return restangularAdmMateriais.one(this.route + "/obterContaContabilAlmoxarifadoConfiguracaoParametroSistema").get().then();
    	};

    	// Obtem valor da conta contabil
    	this.getValorTotal = function(contaId) {
    		return restangularAdmMateriais.one(this.route + "/obterValorTotal").get({"contaId" : contaId}).then();
    	};
    	
    	// Autocomplete conta contabil por inventario
    	this.findContaContabilPorInventario = function(busca, idInventario) {
    		return restangularAdmMateriais.one(this.route).getList("findContaContabilPorInventario", {busca: busca, idInventario : idInventario}).then();
		};
		
		// Obtem conta contabil definada na configuracaoparametrosistema
    	this.findContaContabilPorMaterial = function(materialId) {
    		return restangularAdmMateriais.one(this.route + "/findContaContabilPorMaterial").get({"materialId" : materialId}).then();
    	};

    	AbstractRepository.call(this, restangularAdmMateriais, 'rest/contaContabil');
    }

    AbstractRepository.extend(ContaContabilRepository);

    return new ContaContabilRepository();
}]);